Type TAcListTypes
	
	pszTypeName As Zstring Ptr ' name type
	
	pszExtType As Zstring Ptr ' name extends type
	
End Type

Type TAcVariablesType Extends TAcListTypes
	
	bTypeVar As Byte ' property variables (1 - var , 2  - sub\func , 3 - property , 4 - enum(const))
	
	pszType As Zstring Ptr ' type
	
	pszName As Zstring Ptr ' name
	
End Type

Type TAcVariables
	
	bGlob As Byte ' shared
	
	bPlace As Byte ' before or after "AS"
	
	iLine As Long ' line 
	
	pszType As Zstring Ptr ' type
	
	pszName As Zstring Ptr ' name
	
	mt As iHandle Ptr ' handle multitext (nead for transition to bi files when searching for a variable)
	
	iRealLineForBi As Long ' real line for bi files
	
End Type

Type TAcListDeclaresFunc
	
	pszName As Zstring Ptr ' name function
	
	pszReturnParam As Zstring Ptr ' return type
	
	pszParameters As Zstring Ptr ' the list of parameters 
	
	fType As Ubyte	' function\sub , property , constr , destruc , operat
	
End Type

Type TAcLinesLocalArea Extends TAcListDeclaresFunc
	
	iLineBFW As Long ' start line function in the multiline (iLineBFW - start multiline , iLineB - end multiline) 
	
	iLineB As Long ' start line function
	
	iLineE As Long ' end line function
	
End Type


Redim Shared As String sAcChainOfWords(20)

Redim Shared sAcDimScopes() As String ' an array of levels of nested lines

Redim Shared tAcListTypes() As TAcListTypes ' an array of all types and her extending the type 

Redim Shared tAcDimVariables() As TAcVariables ' an array of all variables 

Redim Shared tAcDimTypeVariables() As TAcVariablesType ' an array of fields types 

Redim Shared tAcDimLinesLocalArea() As TAcLinesLocalArea  ' the array of information about functions and their parameters 

Redim Shared sAcExtendsTypes() As String ' an array extends types

Redim Shared tAcParserListDeclaresFunc() As TAcListDeclaresFunc ' an array declares function

Redim Shared As Short shAcDimMaxScopesNumbers(0 To 100) ' auxiliary array to create an array of levels of nested lines 

Redim Shared bAcDimIndexesExtends() As Byte ' an array , allowing to weed out duplicate extends types

' variables iterators for arrays and backups for bi files 
Dim Shared As Long iAcIndexListTypes , iAcIndexListTypes_ForBI
Dim Shared As Long iAcIndexDimVariables , iAcIndexDimVariables_ForBI
Dim Shared As Long iAcIndexTypeVariables , iAcIndexTypeVariables_ForBI
Dim Shared As Long iAcIndexChainOfWords
Dim Shared As Long iAcIndexLinesLocalArea , iAcIndexLinesLocalArea_ForBI 
Dim Shared As Long iAcIndexExtendsTypes
Dim Shared As Long iAcIndexParserListDeclaresFunc , iAcIndexParserListDeclaresFunc_ForBI


Dim Shared As String sAcList 'list autocompletion

Dim Shared As Byte bAcKeyOption ' flag different options for autocompletion when you press different keys 


' function erases the block inside the string. The beginning and the end of the block is specified by the markers (symbols) 
Function ac_truncate_blocks_proc(sText As String , sMarkerBegin As String , sMarkerEnd As String) As String
	
	Dim As Integer iStart = 1 , iEnd
	
	Do
		
		iStart = Instr(iStart , sText , sMarkerBegin)
		
		If iStart Then
			
			If Len(sMarkerEnd) Then
				
				iEnd = Instr(iStart + 1 , sText , sMarkerEnd)
				
			Endif 
			
			If iEnd Then
				
				sText = Mid(sText , 1 , iStart - 1 ) & Mid(sText , iEnd + Len(sMarkerEnd) )
				
			Else
				
				sText = Mid(sText , 1 , iStart - 1 ) 
				
				Exit Do
				
			Endif
			
		Else
			
			Exit Do
			
		Endif       
		
	Loop    
	
	Return sText
	
End Function

' recursion function erases all simbols inside the brackets
Function ac_truncate_brackets_proc(Byval sText As String , iPositionBrackets As Long = 0) As String
	
	Static i As Long
	
	For i = iPositionBrackets To Len(sText)-1
		
		If i > Len(sText)-1 Then Exit For
		
		Select Case Chr(sText[i])
				
			Case "{" , "("
				
				sText = ac_truncate_brackets_proc(sText ,  i + 1 )
				
			Case "}"  , ")"
				
				sText = Mid(sText , 1 , iPositionBrackets - 1 ) & Mid(sText , i+2)	
				
				i = iPositionBrackets - 2 
				
				Return sText				
				
		End Select
		
	Next
	
	Return sText 
	
End Function

' function erases simbols    : = TAB EXTRA SPACES  
Function ac_truncate_another_simbols_proc(sText As String) As String
	
	Dim As String sRet = Space(Len(sText))
	
	Dim As Byte bFlag , bFlagEcv
	
	Dim As Long iIndexStr
	
	For i As Long = 0 To Len(sText)-1
		
		If bFlagEcv = 0 Then
			
			Select Case sText[i] 
					
				Case 32
					
					If bFlag = 0 Then
						
						sRet[iIndexStr] = sText[i]
						
						iIndexStr+=1
						
						bFlag = 1
						
					Endif
					
				Case 61 ' =
					
					bFlagEcv = 1
					
					Continue For
					
				Case 58  ' : 
					
					Exit For
					
				Case 9
					
					Continue For
					
				Case Else
					
					sRet[iIndexStr] = sText[i]
					
					iIndexStr+=1    
					
					bFlag = 0           
					
			End Select  
			
		Else
			
			If sText[i] = 44 Then ',
				
				bFlagEcv = 0
				
				sRet[iIndexStr] = sText[i]
				
				iIndexStr+=1    
				
				bFlag = 0                   
				
			Endif
			
		Endif
		
	Next
	
	Return Trim(sRet)
	
End Function

' function erases PTR , POINTER
Function ac_truncate_pointers_proc(sText As String) As String
	
	Dim As String sTruncate = sText
	
	sTruncate = misc_replace_string_proc(sTruncate , " PTR " , " " , ,1)
	
	sTruncate = misc_replace_string_proc(sTruncate , " POINTER " , " " , ,1)
	
	If Right(sTruncate , 4) = " PTR" Then
		
		sTruncate = Mid(sTruncate , 1 , Len(sTruncate)-4)
		
	Elseif Right(sTruncate , 8) = " POINTER" Then	
		
		sTruncate = Mid(sTruncate , 1 , Len(sTruncate)-8)
		
	Endif
	
	Return Trim(sTruncate)	
	
End Function

' the aggregate function to erase 
Function ac_truncate_proc(sText As String) As String
	
	sText = ac_truncate_blocks_proc(sText , Chr(34) , Chr(34))
	
	If Len(sText) Then
		
		sText = ac_truncate_blocks_proc(sText , "/'" , "'/")
		
	Endif
	
	If Len(sText) Then
		
		sText = ac_truncate_blocks_proc(sText , "'" , "")
		
	Endif
	
	If Len(sText) Then
		
		sText = ac_truncate_brackets_proc(sText)
		
	Endif
	
	If Len(sText) Then
		
		sText = ac_truncate_another_simbols_proc(sText)
		
	Endif
	
	Return sText
	
End Function

' function gets all variables, their types and declarations functions
Function ac_vars_get_proc(sText As String , iLine As Long , bBiBasFlag As Byte , mt As IHANDLE Ptr) As Long 
	
	Dim As Byte bGlob 
	
	Dim As Long iStart
	
	Dim As String sType
	
	Dim As String sVar 
	
	tbspc_fast_tab_in_space_proc(sText)
	
	sText = Ucase(Trim(sText , Any " " & Chr(13) & Chr(10)))
	
	If (Left(sText, 4) = "DIM " _
	Orelse Left(sText, 4) = "FOR " _
	Orelse Left(sText, 7) = "STATIC " _
	Orelse Left(sText, 6) = "REDIM " _
	Orelse Left(sText, 7) = "EXTERN " _
	Orelse Left(sText, 7) = "COMMON ") Then
		
		If Instr(sText , " PRESERVE ") Then Return 0
		
		sText = ac_truncate_proc(sText) 
		
		sText = misc_replace_string_proc(sText , " BYREF " , " " , ,1)     
		
		If Len(sText) Then
			
			If bBiBasFlag Then
				
				If Left(sText, 10) = "DIM SHARED" Then
					
					bGlob  = 1 
					
					iStart = 12
					
				Elseif Left(sText, 13) = "STATIC SHARED" Then
					
					bGlob  = 1
					
					iStart = 15
					
				Elseif Left(sText, 3) = "DIM" Orelse Left(sText, 3) = "FOR" Then
					
					iStart = 5
					
				Elseif Left(sText, 6) = "STATIC" Then	
					
					iStart = 8
					
				Elseif Left(sText, 12) = "REDIM SHARED" Then
					
					bGlob  = 1 
					
					iStart = 14
					
				Elseif Left(sText, 5) = "REDIM" Then
					
					iStart = 7
					
				Elseif Left(sText, 13) = "COMMON SHARED" Then
					
					bGlob  = 1
					
					iStart = 15	
					
				Elseif Left(sText, 6) = "COMMON" Then
					
					iStart = 8
					
				Elseif Left(sText, 6) = "EXTERN" Then
					
					Dim As Long iAlias = Instr(sText, " ALIAS ")
					
					If iAlias Then 
						
						sText = Mid(sText , 1 , iAlias-1) & Mid(sText , iAlias+6)
						
					Endif
					
					iStart = 8									
					
				Endif
				
			Else
				
				If Left(sText, 10) = "DIM SHARED" Then
					
					bGlob  = 1 
					
					iStart = 12
					
				Elseif Left(sText, 13) = "STATIC SHARED" Then
					
					bGlob  = 1
					
					iStart = 15
					
				Elseif Left(sText, 12) = "REDIM SHARED" Then
					
					bGlob  = 1 
					
					iStart = 14
					
				Elseif Left(sText, 13) = "COMMON SHARED" Then
					
					bGlob  = 1
					
					iStart = 15
					
				Endif
				
			Endif
			
			If Mid(sText , iStart , 3) = "AS " Then
				
				iStart = iStart + 3
				
				Dim As Long iSpc = Instrrev(sText , " PTR ")
				
				If iSpc = 0 Then
					
					iSpc = Instrrev(sText , " POINTER ")
					
					If iSpc Then
						
						iSpc += 8
						
					Else
						
						iSpc = Instr(iStart , sText , " ")
						
					Endif
					
				Else
					
					Dim As Long iSpc2 = Instrrev(sText , " POINTER ")
					
					If iSpc2 > iSpc Then
						
						iSpc = iSpc2 + 8 
						
					Else
						
						iSpc += 4
						
					Endif
					
				Endif
				
				If iSpc Then
					
					sType = Mid(sText , iStart , iSpc - iStart)
					
					iStart = iSpc + 1
					
					Do
						
						Dim As Long iCom = Instr(iStart , sText , ",")
						
						If iAcIndexDimVariables > Ubound(tAcDimVariables) Then
							
							Redim Preserve tAcDimVariables(iAcIndexDimVariables+30) As TAcVariables
							
						Endif
						
						If iCom Then
							
							sVar = Trim(Mid(sText , iStart , iCom - iStart))
							
							tAcDimVariables(iAcIndexDimVariables).pszName = Callocate(Len(sVar)+1)
							
							*(tAcDimVariables(iAcIndexDimVariables).pszName) = sVar
							
							tAcDimVariables(iAcIndexDimVariables).pszType = Callocate(Len(sType)+1)
							
							*(tAcDimVariables(iAcIndexDimVariables).pszType) = sType
							
							tAcDimVariables(iAcIndexDimVariables).bGlob = bGlob
							
							If bBiBasFlag Then
								
								tAcDimVariables(iAcIndexDimVariables).iLine = iLine

							Else
								
								tAcDimVariables(iAcIndexDimVariables).iLine = 0
								
								tAcDimVariables(iAcIndexDimVariables).mt = mt
								
								tAcDimVariables(iAcIndexDimVariables).iRealLineForBi = iLine
								
							Endif
							
							tAcDimVariables(iAcIndexDimVariables).bPlace = 2
							
							iStart = iCom + 1
							
							iAcIndexDimVariables +=1
							
							Function = 1
							
						Else
							
							sVar = Trim(Mid(sText , iStart ))
							
							tAcDimVariables(iAcIndexDimVariables).pszName = Callocate(Len(sVar)+1)
							
							*(tAcDimVariables(iAcIndexDimVariables).pszName) = sVar
							
							tAcDimVariables(iAcIndexDimVariables).pszType = Callocate(Len(sType)+1)
							
							*(tAcDimVariables(iAcIndexDimVariables).pszType) = sType
							
							tAcDimVariables(iAcIndexDimVariables).bGlob = bGlob
							
							If bBiBasFlag Then
								
								tAcDimVariables(iAcIndexDimVariables).iLine = iLine
								
							Else
								
								tAcDimVariables(iAcIndexDimVariables).mt = mt
								
								tAcDimVariables(iAcIndexDimVariables).iLine = 0
								
								tAcDimVariables(iAcIndexDimVariables).iRealLineForBi = iLine
								
							Endif
							
							tAcDimVariables(iAcIndexDimVariables).bPlace = 2                       
							
							iAcIndexDimVariables +=1
							
							Function = 1
							
							Exit Do
							
						Endif                       
						
					Loop
					
				Endif
				
			Else
				
				Do
					
					Dim As Long iAs = Instr(iStart , sText , " AS")
					
					If iAs Then
						
						If iAcIndexDimVariables > Ubound(tAcDimVariables) Then
							
							Redim Preserve tAcDimVariables(iAcIndexDimVariables+30) As TAcVariables
							
						Endif
						
						sVar = Trim(Mid(sText , iStart , iAs - iStart ))
						
						tAcDimVariables(iAcIndexDimVariables).pszName = Callocate(Len(sVar)+1)
						
						*(tAcDimVariables(iAcIndexDimVariables).pszName) = sVar
						
						tAcDimVariables(iAcIndexDimVariables).bGlob = bGlob
						
						If bBiBasFlag Then
							
							tAcDimVariables(iAcIndexDimVariables).iLine = iLine
							
						Else
							
							tAcDimVariables(iAcIndexDimVariables).iLine = 0
							
							tAcDimVariables(iAcIndexDimVariables).mt = mt
							
							tAcDimVariables(iAcIndexDimVariables).iRealLineForBi = iLine
							
						Endif
						
						tAcDimVariables(iAcIndexDimVariables).bPlace = 1 
						
						Function = 1
						
						iStart = iAs+4
						
						Dim As Long iCom = Instr(iStart , sText , ",")
						
						If iCom Then
							
							sType = Trim(Mid(sText , iStart , iCom - iStart))
							
							tAcDimVariables(iAcIndexDimVariables).pszType = Callocate(Len(sType)+1)
							
							*(tAcDimVariables(iAcIndexDimVariables).pszType) = sType
							
							iStart = iCom + 1
							
							iAcIndexDimVariables +=1
							
						Else
							
							sType = Trim(Mid(sText , iStart ))
							
							tAcDimVariables(iAcIndexDimVariables).pszType = Callocate(Len(sType)+1)
							
							*(tAcDimVariables(iAcIndexDimVariables).pszType) = sType 
							
							iAcIndexDimVariables +=1
							
							Exit Do
							
						Endif
						
					Else
						
						Exit Do
						
					Endif
					
				Loop
				
			Endif
			
		Endif
		
	Elseif Left(sText, 8) = "DECLARE " Then
		
		sText = Ltrim(Mid(sText , 9))	
		
		Dim As String sLeftEightText = Left(sText , 8)
		
		Dim As Byte bFlagOper_Prop
		
		If sLeftEightText = "PROPERTY" Then
			
			bFlagOper_Prop = 1
			
		Elseif sLeftEightText = "OPERATOR" Then
			
			bFlagOper_Prop = 2
			
		Endif
		
		If bFlagOper_Prop Then
			
			Dim As Long iBr = Instr(9 , sText , "(")
			
			If iBr Then
				
				sVar = (Trim(Mid(sText , 10 , iBr - 10 )))
				
			Else
				
				sVar = (Trim(Mid(sText , 10  )))
				
			Endif
			
			If iAcIndexParserListDeclaresFunc > Ubound(tAcParserListDeclaresFunc) Then
				
				Redim Preserve tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc+10) As TAcListDeclaresFunc                 
				
			Endif
			
			Dim As Long iBrEnd = Instr(sText , ")")		
			
			Dim As String szParameters , szReturnParam
			
			If iBrEnd Andalso iBrEnd > iBr Then
				
				szParameters  = Trim(Mid(sText , iBr+1 , iBrEnd-iBr-1))
				
				szParameters = ac_truncate_brackets_proc(szParameters)
				
				If Len(szParameters) Then
					
					szParameters = ac_truncate_another_simbols_proc(szParameters)
					
				Endif				
				
				szReturnParam = Trim(Mid(sText , iBrEnd+1 ))
				
				If Len(szReturnParam) Then
					
					szReturnParam = ac_truncate_another_simbols_proc(szReturnParam)
					
				Endif
				
			Endif
			
			tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName = Callocate(Len(sVar)+1)
			
			*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName) = Lcase(sVar)
			
			If bFlagOper_Prop = 1 Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = 3
				
			Elseif bFlagOper_Prop = 2 Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = 6
				
			Endif
			
			If Len(szParameters) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters = Callocate(Len(szParameters)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters) = szParameters
				
			Endif
			
			If Len(szReturnParam) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam = Callocate(Len(szReturnParam)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam) = szReturnParam
				
			Endif
			
			iAcIndexParserListDeclaresFunc += 1
			
			Return 1
			
		Endif
		
		If Left(sText , 6) = "STATIC" Then
			
			sText = Ltrim(Mid(sText , 7))
			
		Endif
		
		sText = misc_replace_string_proc(sText , " CDECL" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " STDCALL" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " PASCAL" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " ALIAS" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " OVERLOAD" , " " , ,1)	
		
		sText = misc_replace_string_proc(sText , " NAKED" , " " , ,1)
		
		'sText = ac_truncate_blocks_proc(sText , chr(34) , chr(34))				
		
		Dim As Long iBr , iSubfuncflag
		
		If Left(sText , 3) = "SUB" Then
			
			sText = Ltrim(Mid(sText , 5))
			
			iBr = Instr(sText , "(")
			
			If iBr Then
				
				sVar = (Trim(Mid(sText , 1 , iBr -1 ))) 
				
			Else
				
				sVar = (Trim(Mid(sText , 1 ))) 
				
			Endif
			
			iSubfuncflag = 2
			
		Elseif Left(sText , 8) = "FUNCTION" Then
			
			sText = Ltrim(Mid(sText , 10))
			
			iBr = Instr(sText , "(")  
			
			sVar = (Trim(Mid(sText , 1 , iBr -1 )))    
			
			iSubfuncflag = 1     
			
		Endif
		
		If Len(sVar) Then		
			
			If iAcIndexParserListDeclaresFunc > Ubound(tAcParserListDeclaresFunc) Then
				
				Redim Preserve tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc+20) As TAcListDeclaresFunc                 
				
			Endif
			
			Dim As Long iBrEnd = Instr(sText , ")")		
			
			Dim As String szParameters , szReturnParam
			
			If iBrEnd Andalso iBrEnd > iBr Then
				
				szParameters  = Trim(Mid(sText , iBr+1 , iBrEnd-iBr-1))
				
				szParameters = ac_truncate_brackets_proc(szParameters)
				
				If Len(szParameters) Then
					
					szParameters = ac_truncate_another_simbols_proc(szParameters)
					
				Endif				
				
				szReturnParam = Trim(Mid(sText , iBrEnd+1 ))
				
				If Len(szReturnParam) Then
					
					szReturnParam = ac_truncate_another_simbols_proc(szReturnParam)
					
				Endif				
				
			Endif
			
			tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName = Callocate(Len(sVar)+1)
			
			*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName) = Lcase(sVar)
			
			tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = iSubfuncflag
			
			If Len(szParameters) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters = Callocate(Len(szParameters)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters) = szParameters
				
			Endif
			
			If Len(szReturnParam) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam = Callocate(Len(szReturnParam)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam) = szReturnParam
				
			Endif	
			
			iAcIndexParserListDeclaresFunc += 1		                    
			
			Return 1            
			
		Endif	
		
	Endif
	
End Function

' function gets types , their extends,  all fields types variables, their types, and field declarations functions
Function ac_vars_type_get_proc(mt As iHandle Ptr  , sText As String , iLine As Long , iCount As Long , iIdenFlag As Long)  As Long 
	
	Dim As Long iStart = 1 , iCounter
	
	Dim As String sType , sVar , sTextBackup , sTextBackup2
	
	Static As String szT_Name , szT_ExtName 
	
	If iIdenFlag Then
		
		Dim As String szTempText = sText
		
		tbspc_fast_tab_in_space_proc(szTempText)
		
		szTempText = Ucase(Trim(szTempText, Any " " & Chr(13) & Chr(10)))
		
		If iAcIndexListTypes > Ubound(tAcListTypes) Then
			
			Redim Preserve tAcListTypes(Ubound(tAcListTypes)+20) As TAcListTypes
			
		Endif
		
		If Left( szTempText , 4 ) = "TYPE" Then
			
			szTempText = Ltrim(Mid(szTempText , 5) , Any " " & Chr(13) & Chr(10))
			
			Dim As Long iFind = Instr(szTempText , " ")
			
			If iFind Then 
				
				szT_Name = Mid(szTempText , 1 , iFind-1)
				
			Else
				
				szT_Name = Mid(szTempText , 1)
				
			Endif
			
			tAcListTypes(iAcIndexListTypes).pszTypeName = Callocate(Len(szT_Name)+1)
			
			*(tAcListTypes(iAcIndexListTypes).pszTypeName) = szT_Name
			
			iFind = Instr(szTempText , " EXTENDS ")
			
			If iFind Then
				
				szTempText = Mid(szTempText , iFind+9)
				
				szTempText = ac_truncate_blocks_proc(szTempText , "/'" , "'/")
				
				szTempText = ac_truncate_blocks_proc(szTempText , "'" , "")
				
				szTempText = Trim(szTempText , Any " " & Chr(13) & Chr(10))
				
				If szTempText = " OBJECT" Then 
					
					szT_ExtName = ""
					
				Else
					
					szT_ExtName = szTempText
					
					tAcListTypes(iAcIndexListTypes).pszExtType = Callocate(Len(szTempText)+1)
					
					*(tAcListTypes(iAcIndexListTypes).pszExtType) = szTempText
					
				Endif
				
			Else
				
				szT_ExtName = ""
				
			Endif
			
			iAcIndexListTypes +=1
			
		Elseif Left( szTempText , 5 ) = "UNION" Then
			
			szTempText = Ltrim(Mid(szTempText , 6) , Any " " & Chr(13) & Chr(10))
			
			If Len(szTempText) Then
				
				Dim As Long iFind = Instr(szTempText , " ")
				
				If iFind Then 
					
					szT_Name = Mid(szTempText , 1 , iFind-1)
					
				Else
					
					szT_Name = Mid(szTempText , 1)
					
				Endif
				
				tAcListTypes(iAcIndexListTypes).pszTypeName = Callocate(Len(szT_Name)+1)
				
				*(tAcListTypes(iAcIndexListTypes).pszTypeName) = szT_Name
				
				iAcIndexListTypes +=1									
				
			Endif
			
		Endif
		
		For i As Long = iLine+1 To iCount -1
			
			Dim As String szTempText = *IupGetAttributeId(mt, "LINE", i)
			
			tbspc_fast_tab_in_space_proc(szTempText)
			
			szTempText = Ucase(Trim( szTempText , Any " " & Chr(13) & Chr(10)))
			
			If Left( szTempText , 4 ) = "TYPE" Orelse Left( szTempText , 5 ) = "UNION" Then
				
				iCounter +=1
				
			Elseif Left( szTempText , 4 ) = "END " Then
				
				If Instr(4 , szTempText , " UNION") Orelse Instr(4 , szTempText , " TYPE") Then
					
					If iCounter Then
						
						iCounter -=1
						
					Else
						
						Return i
						
					Endif
					
				Endif
				
			Endif
			
		Next        
		
	Endif
	
	tbspc_fast_tab_in_space_proc(sText)
	
	sText = Trim(sText , Any " " & Chr(13) & Chr(10))
	
	sTextBackup = Ucase(sText)
	
	sTextBackup2 = sText
	
	sText = Ucase(sText)
	
	If Len(sText) = 0 Then Return 0
	
	Select Case Left(sText , 8)
			
		Case "PRIVATE " , "PRIVATE:"
			
			Return 0
			
	End Select
	
	Select Case Left(sText , 7)
			
		Case "PUBLIC " , "PUBLIC:"
			
			Return 0
			
	End Select
	
	If sText = "UNION" Then Return 0
	
	If sText = "TYPE" Then Return 0
	
	If Left(sText, 4) = "END " Then Return 0    
	
	'-------------
	
	If iAcIndexTypeVariables > Ubound(tAcDimTypeVariables) Then
		
		Redim Preserve tAcDimTypeVariables(iAcIndexTypeVariables+30) As TAcVariablesType
		
	Endif	
	
	If Left(sText , 8) = "DECLARE " Then
		
		sText = Ltrim(Mid(sText , 9))
		
		Dim As Byte CDPO_flag, iBr 
		
		If Left(sText , 8) = "OPERATOR" Then
			
			CDPO_flag = 4
			
		Elseif Left(sText , 11) = "CONSTRUCTOR" Then
			
			CDPO_flag = 1		
			
		Elseif Left(sText , 10) = "DESTRUCTOR" Then
			
			CDPO_flag = 2	
			
		Elseif Left(sText , 8) = "PROPERTY" Then
			
			CDPO_flag = 3
			
		Endif
		
		If CDPO_flag Then
			
			iBr = Instr(9 , sText , "(")
			
			If CDPO_flag = 3 Orelse CDPO_flag = 4 Then
				
				If iBr Then
					
					sVar = (Trim(Mid(sText , 10 , iBr - 10 )))
					
				Else
					
					sVar = (Trim(Mid(sText , 10  )))
					
				Endif				
				
			Endif
			
			tAcDimTypeVariables(iAcIndexTypeVariables).pszName = Callocate(Len(sVar)+1)
			
			Dim As Long iFind = Instr(sTextBackup , sVar)
			
			If iFind Then
				
				sVar = Mid(sTextBackup2 , iFind , Len(sVar))
				
			Endif
			
			*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
			
			If CDPO_flag = 3 Then
				
				tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 3
				
			Elseif 	CDPO_flag = 4 Then
				
				tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 4
				
			Endif
			
			tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = Callocate(Len(szT_Name)+1)
			
			*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
			
			If Len(szT_ExtName) Then
				
				tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType = Callocate(Len(szT_ExtName)+1)
				
				*(tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType) = szT_ExtName                 
				
			Endif
			
			iAcIndexTypeVariables+=1 
			
			If iAcIndexParserListDeclaresFunc > Ubound(tAcParserListDeclaresFunc) Then
				
				Redim Preserve tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc+10) As TAcListDeclaresFunc                 
				
			Endif
			
			Dim As Long iBrEnd = Instr(sText , ")")		
			
			Dim As String szParameters , szReturnParam
			
			If iBrEnd Andalso iBrEnd > iBr Then
				
				szParameters  = Trim(Mid(sText , iBr+1 , iBrEnd-iBr-1))
				
				szParameters = ac_truncate_brackets_proc(szParameters)
				
				If Len(szParameters) Then
					
					szParameters = ac_truncate_another_simbols_proc(szParameters)
					
				Endif				
				
				szReturnParam = Trim(Mid(sText , iBrEnd+1 ))
				
				If Len(szReturnParam) Then
					
					szReturnParam = ac_truncate_another_simbols_proc(szReturnParam)
					
				Endif
				
			Endif
			
			Dim As String sTempName 
			
			If CDPO_flag = 3 Orelse CDPO_flag = 4 Then
				
				sTempName = szT_Name & "." & sVar
				
			Else
				
				sTempName = szT_Name
				
			Endif
			
			tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName = Callocate(Len(sTempName)+1)
			
			*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName) = Lcase(sTempName)
			
			Select Case CDPO_flag
					
				Case 1
					
					tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = 4
					
				Case 2
					
					tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = 5
					
				Case 3
					
					tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = 3
					
				Case 4
					
					tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = 6
					
			End Select
			
			If Len(szParameters) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters = Callocate(Len(szParameters)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters) = szParameters
				
			Endif
			
			If Len(szReturnParam) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam = Callocate(Len(szReturnParam)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam) = szReturnParam
				
			Endif
			
			iAcIndexParserListDeclaresFunc += 1
			
			Return 1
			
		Endif
		
		If Left(sText , 6) = "STATIC" Then
			
			sText = Ltrim(Mid(sText , 7))
			
		Endif
		
		sText = misc_replace_string_proc(sText , " CDECL" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " STDCALL" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " PASCAL" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " ALIAS" , " " , ,1)
		
		sText = misc_replace_string_proc(sText , " OVERLOAD" , " " , ,1)	
		
		sText = misc_replace_string_proc(sText , " NAKED" , " " , ,1)				
		
		Dim As Long iSubfuncflag
		
		If Left(sText , 3) = "SUB" Then
			
			sText = Ltrim(Mid(sText , 5))
			
			iBr = Instr(sText , "(")
			
			If iBr Then
				
				sVar = (Trim(Mid(sText , 1 , iBr -1 ))) 
				
			Else
				
				sVar = (Trim(Mid(sText , 1 ))) 
				
			Endif
			
			iSubfuncflag = 2
			
		Elseif Left(sText , 8) = "FUNCTION" Then
			
			sText = Ltrim(Mid(sText , 10))
			
			iBr = Instr(sText , "(")  
			
			sVar = (Trim(Mid(sText , 1 , iBr -1 )))      
			
			iSubfuncflag = 1   
			
		Endif
		
		If Len(sVar) Then
			
			tAcDimTypeVariables(iAcIndexTypeVariables).pszName = Callocate(Len(sVar)+1)
			
			Dim As Long iFind = Instr(sTextBackup , sVar)
			
			If iFind Then
				
				sVar = Mid(sTextBackup2 , iFind , Len(sVar))
				
			Endif			
			
			*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
			
			tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 2
			
			tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = Callocate(Len(szT_Name)+1)
			
			*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
			
			If Len(szT_ExtName) Then
				
				tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType = Callocate(Len(szT_ExtName)+1)
				
				*(tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType) = szT_ExtName                 
				
			Endif
			
			iAcIndexTypeVariables+=1  
			
			If iAcIndexParserListDeclaresFunc > Ubound(tAcParserListDeclaresFunc) Then
				
				Redim Preserve tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc+20) As TAcListDeclaresFunc                 
				
			Endif
			
			Dim As Long iBrEnd = Instr(sText , ")")		
			
			Dim As String szParameters , szReturnParam
			
			If iBrEnd Andalso iBrEnd > iBr Then
				
				szParameters  = Trim(Mid(sText , iBr+1 , iBrEnd-iBr-1))
				
				szParameters = ac_truncate_brackets_proc(szParameters)
				
				If Len(szParameters) Then
					
					szParameters = ac_truncate_another_simbols_proc(szParameters)
					
				Endif				
				
				szReturnParam = Trim(Mid(sText , iBrEnd+1 ))
				
				If Len(szReturnParam) Then
					
					szReturnParam = ac_truncate_another_simbols_proc(szReturnParam)
					
				Endif
				
			Endif
			
			Dim As String sTempName = szT_Name & "." & sVar
			
			tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName = Callocate(Len(sTempName)+1)
			
			*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszName) = Lcase(sTempName)
			
			tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).fType = iSubfuncflag
			
			If Len(szParameters) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters = Callocate(Len(szParameters)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszParameters) = szParameters
				
			Endif
			
			If Len(szReturnParam) Then
				
				tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam = Callocate(Len(szReturnParam)+1)
				
				*(tAcParserListDeclaresFunc(iAcIndexParserListDeclaresFunc).pszReturnParam) = szReturnParam
				
			Endif	
			
			iAcIndexParserListDeclaresFunc += 1	                    
			
			Return 1            
			
		Endif
		
	Endif
	
	If Len(sText) Then 
		
		sText = ac_truncate_proc(sText) 
		
	Endif
	
	If Len(sText) Then 
		
		If Left(sText, 4) = "DIM " Then
			
			iStart = 5
			
		Elseif Left(sText, 6) = "REDIM " Then
			
			iStart = 7          
			
		Elseif Left(sText, 7) = "STATIC " Then
			
			iStart = 8
			
		Endif
		
		Dim As Long iFind = Instr(sText , " SUB")
		
		If iFind = 0 Then
			
			iFind = Instr(sText , " FUNCTION")
			
			If iFind Then
				
				Select Case Mid(sText , iFind+9 , 1)
						
					Case " " 
						
					Case Else
						
						iFind = 0
						
				End Select
				
			Endif
			
		Else
			
			Select Case Mid(sText , iFind+4 , 1)
					
				Case " " 
					
				Case Else
					
					iFind = 0
					
			End Select
			
		Endif
		
		If iFind Then
			
			iFind = Instr(iStart , sText , " ")
			
			sVar = Mid(sText , iStart , iFind - iStart)
			
			tAcDimTypeVariables(iAcIndexTypeVariables).pszName = Callocate(Len(sVar)+1)
			
			Dim As Long iFind = Instr(sTextBackup , sVar)
			
			If iFind Then
				
				sVar = Mid(sTextBackup2 , iFind , Len(sVar))
				
			Endif
			
			*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
			
			tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 2
			
			tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = Callocate(Len(szT_Name)+1)
			
			*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
			
			If Len(szT_ExtName) Then
				
				tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType = Callocate(Len(szT_ExtName)+1)
				
				*(tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType) = szT_ExtName                 
				
			Endif
			
			iAcIndexTypeVariables+=1                      
			
			Return 1            
			
		Endif
		
		If Mid(sText , iStart , 3) = "AS " Then
			
			iStart = iStart + 3
			
			Dim As Long iSpc = Instrrev(sText , " PTR ")
			
			If iSpc = 0 Then
				
				iSpc = Instrrev(sText , " POINTER ")
				
				If iSpc Then
					
					iSpc += 8
					
				Else
					
					iSpc = Instr(iStart , sText , " ")
					
				Endif
				
			Else
				
				Dim As Long iSpc2 = Instrrev(sText , " POINTER ")
				
				If iSpc2 > iSpc Then
					
					iSpc = iSpc2 + 8 
					
				Else
					
					iSpc += 4
					
				Endif
				
			Endif
			
			If iSpc Then
				
				sType = Trim(Mid(sText , iStart , iSpc - iStart))
				
				iStart = iSpc + 1
				
				Do
					
					Dim As Long iCom = Instr(iStart , sText , ",")
					
					If iAcIndexTypeVariables > Ubound(tAcDimTypeVariables) Then
						
						Redim Preserve tAcDimTypeVariables(iAcIndexTypeVariables+30) As TAcVariablesType
						
					Endif
					
					If iCom Then
						
						sVar = Trim(Mid(sText , iStart , iCom - iStart))
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszName = Callocate(Len(sVar)+1)
						
						Dim As Long iFind = Instr(sTextBackup , sVar)
						
						If iFind Then
							
							sVar = Mid(sTextBackup2 , iFind , Len(sVar))
							
						Endif
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszType = Callocate(Len(sType)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszType) = sType
						
						tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 1
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = Callocate(Len(szT_Name)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
						
						If Len(szT_ExtName) Then
							
							tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType = Callocate(Len(szT_ExtName)+1)
							
							*(tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType) = szT_ExtName                 
							
						Endif
						
						iStart = iCom + 1
						
						iAcIndexTypeVariables +=1
						
						Function = 1
						
					Else
						
						sVar = Trim(Mid(sText , iStart ))
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszName = Callocate(Len(sVar)+1)
						
						Dim As Long iFind = Instr(sTextBackup , sVar)
						
						If iFind Then
							
							sVar = Mid(sTextBackup2 , iFind , Len(sVar))
							
						Endif
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszType = Callocate(Len(sType)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszType) = sType
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = Callocate(Len(szT_Name)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
						
						If Len(szT_ExtName) Then
							
							tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType = Callocate(Len(szT_ExtName)+1)
							
							*(tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType) = szT_ExtName                 
							
						Endif 
						
						tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 1                                        
						
						iAcIndexTypeVariables +=1
						
						Function = 1
						
						Exit Do
						
					Endif                       
					
				Loop
				
			Endif
			
		Else
			
			Do
				
				Dim As Long iAs = Instr(iStart , sText , " AS")
				
				If iAs Then
					
					If iAcIndexTypeVariables > Ubound(tAcDimTypeVariables) Then
						
						Redim Preserve tAcDimTypeVariables(iAcIndexTypeVariables+30) As TAcVariablesType
						
					Endif
					
					sVar = Trim(Mid(sText , iStart , iAs - iStart ))
					
					tAcDimTypeVariables(iAcIndexTypeVariables).pszName = Callocate(Len(sVar)+1)
					
					Dim As Long iFind = Instr(sTextBackup , sVar)
					
					If iFind Then
						
						sVar = Mid(sTextBackup2 , iFind , Len(sVar))
						
					Endif
					
					*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
					
					tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = Callocate(Len(szT_Name)+1)
					
					*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
					
					If Len(szT_ExtName) Then
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType = Callocate(Len(szT_ExtName)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszExtType) = szT_ExtName                 
						
					Endif
					
					tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 1                 
					
					Function = 1
					
					iStart = iAs+4
					
					Dim As Long iCom = Instr(iStart , sText , ",")
					
					If iCom Then
						
						sType = Trim(Mid(sText , iStart , iCom - iStart))					
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszType = Callocate(Len(sType)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszType) = sType
						
						iStart = iCom + 1
						
						iAcIndexTypeVariables +=1
						
					Else
						
						sType = Trim(Mid(sText , iStart ))					
						
						tAcDimTypeVariables(iAcIndexTypeVariables).pszType = Callocate(Len(sType)+1)
						
						*(tAcDimTypeVariables(iAcIndexTypeVariables).pszType) = sType
						
						iAcIndexTypeVariables +=1
						
						Exit Do
						
					Endif
					
				Else
					
					Exit Do
					
				Endif
				
			Loop
			
		Endif
		
	Endif   
	
End Function

' the function returns a region ENUM (while nothing else does) 
Function ac_consts_enum_get_proc(mt As iHandle Ptr , sText As String , iLine As Long , iCount As Long , iIdenFlag As Long) As Long
	
	Static As String szT_Name
	
	If iIdenFlag Then
		
		Dim As String  szTempText = sText
		
		tbspc_fast_tab_in_space_proc(szTempText)
		
		szTempText = Ucase(Trim(szTempText, Any " " & Chr(13) & Chr(10)))
		
		If Left( szTempText , 4 ) = "ENUM" Then
			
			szTempText = Ltrim(Mid(szTempText , 5))
			
			Dim As Long iFind = Instr(szTempText , " ")
			
			If iFind Then 
				
				szT_Name = Mid(szTempText , 1 , iFind-1)
				
			Else
				
				szT_Name = Mid(szTempText , 1)
				
			Endif
			
		Endif
		
		For i As Long = iLine+1 To iCount -1
			
			Dim As String szTempText = *IupGetAttributeId(mt, "LINE", i)
			
			tbspc_fast_tab_in_space_proc(szTempText)
			
			szTempText = Ucase(Trim(szTempText, Any " " & Chr(13) & Chr(10)))
			
			If Left( szTempText , 4 ) = "END " Then
				
				If Instr(4 , szTempText , " ENUM") Then
					
					Return i
					
				Endif
				
			Endif
			
		Next
		
		'else
		'
		'fast_tab_in_space_proc(sText)
		'
		'sText = UCase(Trim(sText , any " " & chr(13) & chr(10)))   
		'
		'if len(sText) = 0 then return 0	
		'
		'dim as Long iStart = 1
		'
		'dim as string sVar
		'
		'do
		'
		'dim as Long iCom = instr(iStart , sText , ",")
		'
		'if iAcIndexTypeVariables > Ubound(tAcDimTypeVariables) then
		'
		'Redim preserve tAcDimTypeVariables(iAcIndexTypeVariables+30) as TAcVariablesType
		'
		'EndIf
		'
		'if iCom then
		'
		'sVar = trim(mid(sText , iStart , iCom - iStart))
		'
		'tAcDimTypeVariables(iAcIndexTypeVariables).pszName = callocate(len(sVar)+1)
		'
		'*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
		'
		'tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 4
		'
		'tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = callocate(len(szT_Name)+1)
		'
		'*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
		'
		'iStart = iCom + 1
		'
		'iAcIndexTypeVariables +=1
		'
		'function = 1
		'
		'else
		'
		'sVar = trim(mid(sText , iStart ))
		'
		'tAcDimTypeVariables(iAcIndexTypeVariables).pszName = callocate(len(sVar)+1)
		'
		'*(tAcDimTypeVariables(iAcIndexTypeVariables).pszName) = sVar
		'
		'tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName = callocate(len(szT_Name)+1)
		'
		'*(tAcDimTypeVariables(iAcIndexTypeVariables).pszTypeName) = szT_Name
		'
		'tAcDimTypeVariables(iAcIndexTypeVariables).bTypeVar = 4                                         
		'
		'iAcIndexTypeVariables +=1
		'
		'function = 1
		'
		'exit do
		'
		'EndIf                       
		'
		'Loop		  		
		
	Endif
	
End Function

' function obtains information about the blocks of procedures\functions\constructors... fills an array tAcDimLinesLocalArea and tAcDimVariables its parameters 
Sub ac_get_name_block_from_line_proc(iRet As Long , sNameFunction As String , sTextLine As String ,  sTextLineOriginal As String ,  iLine As Long)
	
	Dim As Long iFindB , iFindE
	
	Dim As String sFind
	
	Select Case iRet
			
		Case 1
			
			sFind = "function"
			
		Case 2
			
			sFind = "sub"		
			
		Case 10
			
			sFind = "constructor"
			
		Case 11
			
			sFind = "destructor"
			
		Case 12
			
			sFind = "operator"
			
		Case 13
			
			sFind = "property"	
			
	End Select
	
	If iRet < 3 Then ' only func and sub
		
		sTextLine = misc_replace_string_proc(sTextLine , " cdecl" , " " , ,1)
		
		sTextLine = misc_replace_string_proc(sTextLine , " stdcall" , " " , ,1)
		
		sTextLine = misc_replace_string_proc(sTextLine , " pascal" , " " , ,1)
		
		sTextLine = misc_replace_string_proc(sTextLine , " alias" , " " , ,1)
		
		sTextLine = misc_replace_string_proc(sTextLine , " overload" , " " , ,1)	
		
		sTextLine = misc_replace_string_proc(sTextLine , " naked" , " " , ,1)	
		
	Endif		
	
	iFindB = Instr(sTextLine , sFind) + Len(sFind) 
	
	sTextLine = Trim(Mid(sTextLine , iFindB))
	
	If Len(sTextLine) Then
		
		iFindB = Instr(sTextLine , " ")
		
		iFindE = Instr(sTextLine , "(")
		
		If iFindB + iFindE = 0 Then
			
			sNameFunction = Trim(Mid(sTextLine , 1))
			
		Elseif iFindB = 0 Then
			
			sNameFunction = Trim(Left(sTextLine , iFindE-1))
			
		Elseif iFindE = 0 Orelse iFindB < iFindE Then
			
			sNameFunction = Trim(Left(sTextLine , iFindB-1))
			
		Elseif iFindB > iFindE Then	
			
			sNameFunction = Trim(Left(sTextLine , iFindE-1))
			
		Elseif iFindB < iFindE Then	
			
			sNameFunction = Trim(Left(sTextLine , iFindB-1))
			
		Endif
		
		If iFindE Then
			
			sTextLine = Mid(sTextLine , iFindE)	
			
			sTextLine = ac_truncate_blocks_proc(sTextLine , Chr(34) , Chr(34))
			
			If Len(sTextLine) Then
				
				sTextLine = ac_truncate_blocks_proc(sTextLine , "/'" , "'/")
				
			Endif
			
			If Len(sTextLine) Then
				
				sTextLine = ac_truncate_blocks_proc(sTextLine , "'" , "")
				
			Endif
			
			iFindE = Instrrev(sTextLine , ")")
			
			If iFindE Then
				
				If iFindE < 8 Then Exit Sub
				
				Dim As String sReturnParam = Trim(Mid(sTextLine , iFindE+1) , Any " " & Chr(9) & Chr(13) & Chr(10))
				
				If Len(sReturnParam) Then
					
					If iAcIndexLinesLocalArea > Ubound(tAcDimLinesLocalArea) Then
						
						Redim Preserve tAcDimLinesLocalArea(Ubound(tAcDimLinesLocalArea)+10) As TAcLinesLocalArea
						
					Endif
					
					tAcDimLinesLocalArea(iAcIndexLinesLocalArea).pszReturnParam = Callocate(Len(sReturnParam)+1)
					
					*(tAcDimLinesLocalArea(iAcIndexLinesLocalArea).pszReturnParam) = sReturnParam
					
				Endif
				
				sTextLine = Mid(sTextLine , 2 , iFindE - 2)
				
				sTextLine = ac_truncate_brackets_proc(sTextLine)
				
				If Len(sTextLine) Then
					
					sTextLine = ac_truncate_another_simbols_proc(sTextLine)
					
				Endif
				
				If Len(sTextLine) Then
					
					If iAcIndexLinesLocalArea > Ubound(tAcDimLinesLocalArea) Then
						
						Redim Preserve tAcDimLinesLocalArea(Ubound(tAcDimLinesLocalArea)+10) As TAcLinesLocalArea
						
					Endif
					
					tAcDimLinesLocalArea(iAcIndexLinesLocalArea).pszParameters = Callocate(Len(sTextLine)+1)
					
					*(tAcDimLinesLocalArea(iAcIndexLinesLocalArea).pszParameters) = sTextLine
					
				Endif
				
				sTextLine = misc_replace_string_proc(sTextLine , " byval " , " " , ,1)
				
				sTextLine = misc_replace_string_proc(sTextLine , " byref " , " " , ,1)
				
				sTextLine = Rtrim(misc_replace_string_proc(sTextLine , "byval " , " " , ,1))
				
				sTextLine = Rtrim(misc_replace_string_proc(sTextLine , "byref " , " " , ,1))
				
				If Len(sTextLine) Then
					
					Dim As Long iStart = 1
					
					Dim As String sVar , sType
					
					Do
						
						Dim As Long iAs = Instr(iStart , sTextLine , " as")
						
						If iAs Then
							
							If iAcIndexDimVariables > Ubound(tAcDimVariables) Then
								
								Redim Preserve tAcDimVariables(iAcIndexDimVariables+30) As TAcVariables
								
							Endif
							
							sVar = Trim(Mid(sTextLine , iStart , iAs - iStart ))
							
							tAcDimVariables(iAcIndexDimVariables).pszName = Callocate(Len(sVar)+1)
							
							Dim As Long iFindOriginal = Instr(Lcase(sTextLineOriginal) , sVar)
							
							If iFindOriginal Then
								
								*(tAcDimVariables(iAcIndexDimVariables).pszName) = Mid(sTextLineOriginal , iFindOriginal , Len(sVar))
								
							Endif
							
							tAcDimVariables(iAcIndexDimVariables).iLine = iLine
							
							tAcDimVariables(iAcIndexDimVariables).bPlace = 1 
							
							iStart = iAs+4
							
							Dim As Long iCom = Instr(iStart , sTextLine , ",")
							
							If iCom Then
								
								sType = Trim(Mid(sTextLine , iStart , iCom - iStart))
								
								tAcDimVariables(iAcIndexDimVariables).pszType = Callocate(Len(sType)+1)
								
								*(tAcDimVariables(iAcIndexDimVariables).pszType) = Ucase(sType)
								
								iStart = iCom + 1
								
								iAcIndexDimVariables +=1
								
							Else
								
								sType = Trim(Mid(sTextLine , iStart ))
								
								tAcDimVariables(iAcIndexDimVariables).pszType = Callocate(Len(sType)+1)
								
								*(tAcDimVariables(iAcIndexDimVariables).pszType) = Ucase(sType) 
								
								iAcIndexDimVariables +=1
								
								Exit Do
								
							Endif
							
						Else
							
							Exit Do
							
						Endif
						
					Loop												
					
				Endif
				
			Endif
			
		Endif
		
	Endif	
	
End Sub

' a stripped-down version  atc_get_autocomplect_proc , which returns blocks altering the scope of 
Function ac_check_block_area_proc(mt As Ihandle Ptr ,  iLine As Integer , sNameFunction As String) As Integer Export
	
	Dim As String sTextLine , sTextLineOriginal
	
	If atc_get_string_from_multiline_text_proc(mt , iLine , sTextLine , 1) = -1 Then
		
		Return 0
		
	Endif
	
	If Len(sTextLine) < 2 Then Return 0
	
	tbspc_fast_tab_in_space_proc(sTextLine)
	
	sTextLine = Ltrim(sTextLine , Any " ")
	
	sTextLine = Rtrim(sTextLine , Any Chr(32) & Chr(13) & Chr(10))
	
	If Len(sTextLine) < 2 Orelse atc_has_separator_proc(sTextLine) = 1 Then Return 0 
	
	sTextLineOriginal = sTextLine
	
	sTextLine = Lcase(sTextLine)
	
	Select Case Left(sTextLine , 1)
			
		Case "f"
			
			If atc_k_for_proc(sTextLine) Then Return 16
			
			If atc_k_function_proc(sTextLine) Then 
				
				ac_get_name_block_from_line_proc(1 , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return 1
				
			Endif
			
		Case "s"
			
			If atc_k_sub_proc(sTextLine) Then 
				
				ac_get_name_block_from_line_proc(2 , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return 2
				
			Endif
			
			If atc_k_select_proc(sTextLine) Then Return 18
			
			If atc_k_scope_proc(sTextLine) Then Return 4
			
		Case "t"
			
			If atc_k_type_proc(sTextLine) Then Return 3
			
		Case "u"
			
			If atc_k_union_proc(sTextLine) Then Return 5
			
		Case "e"
			
			If atc_k_enum_proc(sTextLine) Then Return 6			
			
		Case "n"
			
			If atc_k_namespace_proc(sTextLine) Then Return 7
			
		Case "w"
			
			If atc_k_while_proc(sTextLine) Then Return 14
			
			If atc_k_with_proc(sTextLine) Then Return 8
			
		Case "c"
			
			If atc_k_constructor_proc(sTextLine) Then
				
				ac_get_name_block_from_line_proc(10 ,sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return 10
				
			Endif
			
		Case "d"
			
			If atc_k_do_proc(sTextLine) Then Return 15
			
			If atc_k_destructor_proc(sTextLine) Then 
				
				ac_get_name_block_from_line_proc(11 , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return 11
				
			Endif
			
		Case "o"
			
			If atc_k_operator_proc(sTextLine) Then 
				
				ac_get_name_block_from_line_proc(12 , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return 12
				
			Endif
			
		Case "p"
			
			If atc_k_property_proc(sTextLine) Then 
				
				ac_get_name_block_from_line_proc(13 , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return 13
				
			Endif
			
			Dim As Long iRet = atc_k_private_proc(sTextLine)
			
			If iRet Then
				
				ac_get_name_block_from_line_proc(iRet , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return iRet
				
			Endif
			
			iRet = atc_k_public_proc(sTextLine)
			
			If iRet Then
				
				ac_get_name_block_from_line_proc(iRet , sNameFunction , sTextLine , sTextLineOriginal , iLine)
				
				Return iRet
				
			Endif
			
		Case "i"
			
			If atc_k_if_proc(sTextLine) Then Return 17
			
		Case "a"
			
			If atc_k_asm_proc(sTextLine) Then Return 20
			
	End Select
	
End Function

' clearing arrays and init index-iterators
Sub ac_free_dims_proc(b() As TAcVariables , b2() As TAcVariablesType , b3() As TAcLinesLocalArea , _
b4() As TAcListTypes , b5() As TACListDeclaresFunc)
	
	Dim As Long i1 , i2 , i3 , i4 , i5
	
	If TGlobalVariables->bFlagBiFilesSignalUpdate = 0 Then
		
		If iAcIndexDimVariables_ForBI > 0 Andalso iAcIndexDimVariables_ForBI <= (Ubound(b)+1) Then
			
			i1 = iAcIndexDimVariables_ForBI
			
		Endif
		
		If iAcIndexTypeVariables_ForBI > 0 Andalso iAcIndexTypeVariables_ForBI <= (Ubound(b2)+1) Then
			
			i2 = iAcIndexTypeVariables_ForBI
			
		Endif
		
		If iAcIndexLinesLocalArea_ForBI > 0 Andalso iAcIndexLinesLocalArea_ForBI <= (Ubound(b3)+1) Then
			
			i3 = iAcIndexLinesLocalArea_ForBI
			
		Endif
		
		If iAcIndexListTypes_ForBI > 0 Andalso iAcIndexListTypes_ForBI <= (Ubound(b4)+1) Then
			
			i4 = iAcIndexListTypes_ForBI
			
		Endif	
		
		If iAcIndexParserListDeclaresFunc_ForBI > 0 Andalso iAcIndexParserListDeclaresFunc_ForBI <= (Ubound(b5)+1) Then
			
			i5 = iAcIndexParserListDeclaresFunc_ForBI
			
		Endif	
		
	Endif		
	
	For i As Long = i1 To Ubound(b)
		
		If b(i).pszType Then 
			
			Deallocate(b(i).pszType)
			
			b(i).pszType = 0
			
		Endif
		
		If b(i).pszName Then 
			
			Deallocate(b(i).pszName)
			
			b(i).pszName = 0
			
		Endif
		
	Next
	
	For i As Long = i2 To Ubound(b2)
		
		If b2(i).pszType Then 
			
			Deallocate(b2(i).pszType)
			
			b2(i).pszType = 0
			
		Endif
		
		If b2(i).pszName Then 
			
			Deallocate(b2(i).pszName) 
			
			b2(i).pszName = 0
			
		Endif
		
		If b2(i).pszExtType Then 
			
			Deallocate(b2(i).pszExtType)
			
			b2(i).pszExtType = 0
			
		Endif
		
		If b2(i).pszTypeName Then 
			
			Deallocate(b2(i).pszTypeName)
			
			b2(i).pszTypeName = 0
			
		Endif
		
	Next  
	
	For i As Long = i3 To Ubound(b3) 
		
		If b3(i).pszName Then 
			
			Deallocate(b3(i).pszName)
			
			b3(i).pszName = 0
			
		Endif
		
		If b3(i).pszReturnParam Then 
			
			Deallocate(b3(i).pszReturnParam)
			
			b3(i).pszReturnParam = 0
			
		Endif
		
		If b3(i).pszParameters Then 
			
			Deallocate(b3(i).pszParameters)
			
			b3(i).pszParameters = 0
			
		Endif
		
	Next
	
	For i As Long = i4 To Ubound(b4)
		
		If b4(i).pszExtType Then 
			
			Deallocate(b4(i).pszExtType)
			
			b4(i).pszExtType = 0
			
		Endif
		
		If b4(i).pszTypeName Then 
			
			Deallocate(b4(i).pszTypeName)
			
			b4(i).pszTypeName = 0
			
		Endif
		
	Next
	
	For i As Long = i5 To Ubound(b5)
		
		If b5(i).pszName Then 
			
			Deallocate(b5(i).pszName)
			
			b5(i).pszName = 0
			
		Endif
		
		If b5(i).pszParameters Then 
			
			Deallocate(b5(i).pszParameters)
			
			b5(i).pszParameters = 0
			
		Endif
		
		If b5(i).pszReturnParam Then 
			
			Deallocate(b5(i).pszReturnParam)
			
			b5(i).pszReturnParam = 0
			
		Endif
		
	Next
	
	If TGlobalVariables->bFlagBiFilesSignalUpdate = 1 Orelse _
	(i1 + i2 + i3 + i4 + i5) = 0 Then
		
		Redim As Short shAcDimMaxScopesNumbers(0 To 100) 
		
		Redim tAcDimVariables(30) As TAcVariables
		
		Redim tAcDimTypeVariables(30) As TAcVariablesType
		
		Redim tAcListTypes(20) As TAcListTypes
		
		Redim tAcDimLinesLocalArea(30) As TAcLinesLocalArea
		
		Redim tAcParserListDeclaresFunc(30) As TAcListDeclaresFunc
		
		iAcIndexDimVariables = 0 
		
		iAcIndexTypeVariables = 0
		
		iAcIndexListTypes = 0
		
		iAcIndexLinesLocalArea = 0
		
		iAcIndexParserListDeclaresFunc = 0
		
	Else
		
		iAcIndexDimVariables = iAcIndexDimVariables_ForBI
		
		iAcIndexTypeVariables = iAcIndexTypeVariables_ForBI
		
		iAcIndexListTypes = iAcIndexListTypes_ForBI
		
		iAcIndexLinesLocalArea = iAcIndexLinesLocalArea_ForBI
		
		iAcIndexParserListDeclaresFunc = iAcIndexParserListDeclaresFunc_ForBI							
		
	Endif
	
End Sub

' function splits a string containing a string of the form: qqq.www.eee separately 
Function ac_split_words_proc(mt As Ihandle Ptr , iCurPos As Integer) As Integer
	
	Dim As Integer  iPosLineBegin , iPosTemp ,  iLine , iColumn 
	
	Dim As Long iLevel
	
	Dim As String sWord 
	
	Dim As Integer iChar
	
	Redim As String sAcChainOfWords(20)
	
	iAcIndexChainOfWords = 0
	
	IupTextConvertPosToLinCol(mt, iCurPos, Cast(Any Ptr, @iLine), Cast(Any Ptr, @iColumn))
	
	IupTextConvertLinColToPos(mt, iLine , 0, Cast(Any Ptr, @iPosLineBegin))
	
	iPosTemp = iCurPos - 1
	
	Function = iLine
	
	Do
		
		If iPosTemp < iPosLineBegin Then
			
			Exit Do
			
		Endif
		
		iChar = Cint(IupScintillaSendMessage(mt , SCI_GETCHARAT , iPosTemp , 0 ))
		
		If iChar = 46 Then ' .
			
			iPosTemp-=1
			
			If Len(sWord) Then
				
				If iAcIndexChainOfWords > Ubound(sAcChainOfWords) Then
					
					Redim Preserve As String sAcChainOfWords(20)
					
				Endif
				
				misc_reverse_string_proc(sWord)
				
				If Len(sWord) Then
					
					sAcChainOfWords(iAcIndexChainOfWords) = Ucase(sWord)
					
					iAcIndexChainOfWords +=1					
					
				Endif
				
			Endif
			
			sWord = ""
			
		Elseif iChar = 62 Andalso IupScintillaSendMessage(mt , SCI_GETCHARAT , iPosTemp-1 , 0 ) = 45 Then ' ->
			
			iPosTemp-=2
			
			If Len(sWord) Then
				
				If iAcIndexChainOfWords > Ubound(sAcChainOfWords) Then
					
					Redim Preserve As String sAcChainOfWords(20)
					
				Endif
				
				misc_reverse_string_proc(sWord)
				
				If Len(sWord) Then
					
					sAcChainOfWords(iAcIndexChainOfWords) = Ucase(sWord)
					
					iAcIndexChainOfWords +=1
					
				Endif
				
			Endif			
			
			sWord = ""
			
		Elseif iChar = 41 Orelse iChar = 93 Then ' ) ]
			
			iLevel +=1
			
			iPosTemp-=1
			
		Elseif iChar = 40 Orelse iChar = 91 Then ' ( [
			
			If iLevel > 0 Then
				
				iLevel -=1
				
				iPosTemp-=1
				
			Else
				
				Exit Do
				
			Endif
			
		Elseif (iChar = 95) Orelse (iChar > 47 Andalso iChar < 58) _
			Orelse (iChar > 64 Andalso iChar < 91) _
			Orelse (iChar > 96 Andalso iChar < 123) Then ' _ 0...9 A...Z a....z
			
			If iLevel = 0 Then
				
				sWord &= Chr(iChar)
				
			Endif
			
			iPosTemp-=1
			
		Else
			
			If iLevel = 0 Then
				
				Exit Do
				
			Else
				
				iPosTemp-=1
				
			Endif
			
		Endif
		
	Loop
	
	If Len(sWord) Then
		
		misc_reverse_string_proc(sWord)
		
		If Len(sWord) Then
			
			sAcChainOfWords(iAcIndexChainOfWords) = Ucase(sWord)
			
			iAcIndexChainOfWords +=1			
			
		Endif
		
	Endif
	
End Function

' parsing individual multitext
Sub ac_parser_proc(mt As iHandle Ptr , bBiBasFlag As Byte) 
	
	Dim As String sScopes = "_1"
	
	Dim As TMultiCommentsLinePositions Ptr ListMKLP = cmt_multi_comments_line_positions_proc(mt)
	
	Dim As Integer iCount = IupGetInt(mt, "LINECOUNT")
	
	Dim As Long iTypeBlockEnd , iEnumBlockEnd , iASMBlock
	
	For i As Long = 0 To iCount -1
		
		Dim As Byte bFlagML
		
		If ListMKLP Then
			
			If ListMKLP->IsIn(i) Then
				
				bFlagML = 1
				
			Endif
			
		Endif
		
		If bFlagML = 0 Then
			
			Dim As String szText
			
			Dim As Long iLineBFW = atc_get_string_from_multiline_text_proc(mt , i , szText , 1)
			
			If iLineBFW <> -1 Then
				
				Dim As String sNameFunction
				
				If i >= iTypeBlockEnd Andalso i >= iEnumBlockEnd Then
					
					ac_vars_get_proc(szText , i , bBiBasFlag , mt)
					
					iTypeBlockEnd = 0
					
					iEnumBlockEnd = 0
					
				Endif			
				
				Dim As Integer iRet
				
				If iASMBlock = 0 Then
					
					iRet = ac_check_block_area_proc(mt , i , sNameFunction )	
					
				Else
					
					Dim As String sRet = Ltrim(Lcase(*IupGetAttribute(mt , "LINE" & i)) , Any Chr(9) & " ")
					
					If (Len(sRet) > 5) Then
						
						Select Case Left(sRet , 4)
								
							Case "end " , "end" & Chr(9)
								
								If Instr(sRet , "asm") Then
									
									iASMBlock = 0
									
								Endif							
								
						End Select
						
					Endif
					
				Endif
				
				If iRet = 3 Orelse iRet = 5 Orelse iTypeBlockEnd <> 0 Then
					
					If iTypeBlockEnd = 0 Then
						
						iTypeBlockEnd = ac_vars_type_get_proc(mt ,szText , i , iCount , 1)
						
					Else
						
						ac_vars_type_get_proc(mt , szText , i , iCount , 0)
						
					Endif
					
				Elseif iRet = 6 Orelse iEnumBlockEnd <> 0 Then
					
					If iEnumBlockEnd = 0 Then
						
						iEnumBlockEnd = ac_consts_enum_get_proc(mt , szText , i , iCount , 1)
						
						'else	
						'
						'consts_enum_get_proc(szText , i , iCount , 0)
						
					Endif
					
				Elseif iRet = 20 Then	
					
					iASMBlock = 1
					
				Endif  			
				
				If bBiBasFlag Then
					
					Select Case iRet            
							
						Case 1 , 2 , 10 , 11 , 12 , 13
							
							If iAcIndexLinesLocalArea > Ubound(tAcDimLinesLocalArea) Then
								
								Redim Preserve tAcDimLinesLocalArea(Ubound(tAcDimLinesLocalArea)+10) As TAcLinesLocalArea
								
							Endif
							
							Dim As Long j = Len(sScopes)\2
							
							If j > Ubound(shAcDimMaxScopesNumbers) Then
								
								Redim Preserve As Short shAcDimMaxScopesNumbers(j+10)
								
							Endif
							
							tAcDimLinesLocalArea(iAcIndexLinesLocalArea).iLineB = i
							
							tAcDimLinesLocalArea(iAcIndexLinesLocalArea).iLineBFW = iLineBFW
							
							If Len(sNameFunction) Then
								
								tAcDimLinesLocalArea(iAcIndexLinesLocalArea).pszName = Callocate(Len(sNameFunction)+1)
								
								*(tAcDimLinesLocalArea(iAcIndexLinesLocalArea).pszName) = sNameFunction
								
								tAcDimLinesLocalArea(iAcIndexLinesLocalArea).fType = iRet							
								
							Endif
							
							shAcDimMaxScopesNumbers(j) +=1
							
							sScopes = sScopes & "_" & shAcDimMaxScopesNumbers(j)					
							
						Case 4 , 7 , 8 , 14 , 15 , 16  , 17 , 18
							
							Dim As Long j = Len(sScopes)\2
							
							If j > Ubound(shAcDimMaxScopesNumbers) Then
								
								Redim Preserve As Short shAcDimMaxScopesNumbers(j+10)
								
							Endif
							
							shAcDimMaxScopesNumbers(j) +=1
							
							sScopes = sScopes & "_" & shAcDimMaxScopesNumbers(j)
							
						Case Else   
							
							szText = Ucase(Ltrim(szText , Any " " & Chr(9) & Chr(13) & Chr(10)))
							
							Dim As Long iRest  = Instrrev(sScopes , "_")
							
							iRest = Len(sScopes)-(Len(sScopes) - iRest + 1)
							
							If Len(szText) Then
								
								Select Case Left(szText , 4) 
										
									Case "WEND" , "LOOP" , "NEXT"
										
										sScopes = Left(sScopes , iRest)
										
									Case "END " , "END" & Chr(9)
										
										szText = Rtrim(Mid(szText , 5  , 11))
										
										If Len(szText) Then
											
											Dim As String sTextEightLeft = Left(szText , 8) 
											
											If sTextEightLeft = "FUNCTION" Orelse _                   
											Left(szText , 3) = "SUB" Orelse _                            
											Left(szText , 11) = "CONSTRUCTOR" Orelse _                  
											Left(szText , 10) = "DESTRUCTOR" Orelse _                
											sTextEightLeft = "PROPERTY" Orelse _ 
											sTextEightLeft = "OPERATOR" Then
												
												If iAcIndexLinesLocalArea > Ubound(tAcDimLinesLocalArea) Then
													
													Redim Preserve tAcDimLinesLocalArea(Ubound(tAcDimLinesLocalArea)+10) As TAcLinesLocalArea
													
												Endif
												
												tAcDimLinesLocalArea(iAcIndexLinesLocalArea).iLineE = i
												
												iAcIndexLinesLocalArea +=1
												
												sScopes = Left(sScopes , iRest)
												
											Endif
											
											If Left(szText , 5) = "SCOPE" Orelse _
											Left(szText , 9) = "NAMESPACE" Orelse _         
											Left(szText , 4) = "WITH" Orelse _                                                                                              
											Left(szText , 6) = "SELECT" Then
												
												sScopes = Left(sScopes , iRest)
												
											Endif										
											
										Endif
										
									Case "ELSE" 
										
										If Len(szText) = 4 Then
											
											sScopes = Left(sScopes , iRest)
											
											Dim As Long j = Len(sScopes)\2
											
											If j > Ubound(shAcDimMaxScopesNumbers) Then
												
												Redim Preserve As Short shAcDimMaxScopesNumbers(j+10)
												
											Endif										
											
											shAcDimMaxScopesNumbers(j) +=1
											
											sScopes = sScopes & "_" & shAcDimMaxScopesNumbers(j) 										
											
										Endif
										
								End Select
								
								Select Case Left(szText , 5) 
										
									Case "ENDIF" 
										
										sScopes = Left(sScopes , iRest)
										
									Case "CASE " , "ELSE " , "ELSE" & Chr(9)
										
										sScopes = Left(sScopes , iRest)
										
										Dim As Long j = Len(sScopes)\2
										
										If j > Ubound(shAcDimMaxScopesNumbers) Then
											
											Redim Preserve As Short shAcDimMaxScopesNumbers(j+10)
											
										Endif									
										
										shAcDimMaxScopesNumbers(j) +=1
										
										sScopes = sScopes & "_" & shAcDimMaxScopesNumbers(j)                  
										
								End Select
								
								If Left(szText , 7) = "ELSEIF " _
								Orelse Left(szText , 7) = "ELSEIF" & Chr(9) _
								Orelse Left(szText , 10) = "CASE ELSE " _
								Orelse Left(szText , 10) = "CASE ELSE" & Chr(9) _
								Orelse Left(szText , 8) = "CASE IS " _
								Orelse Left(szText , 8) = "CASE IS" & Chr(9) Then
									
									sScopes = Left(sScopes , iRest)
									
									Dim As Long j = Len(sScopes)\2
									
									shAcDimMaxScopesNumbers(j) +=1
									
									If j > Ubound(shAcDimMaxScopesNumbers) Then
										
										Redim Preserve As Short shAcDimMaxScopesNumbers(j+10)
										
									Endif								
									
									sScopes = sScopes & "_" & shAcDimMaxScopesNumbers(j)                   
									
								Endif
								
							Endif
							
					End Select 
					
				Endif
				
			Endif 
			
		Endif	
		
		If Len(sScopes) = 0 Then
			
			sScopes = "_1"
			
		Endif
		
		sAcDimScopes( i ) = sScopes
		
	Next
	
	If ListMKLP Then
		
		ListMKLP->delAll()
		
		Delete ListMKLP		
		
	Endif	
	
End Sub

' preparation before parsing 
Sub ac_parserdoc_proc() 
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Then
		
		Exit Sub
		
	Endif	
	
	Dim As Integer iCountTabs , iCurentTabs , iCountLines
	
	Dim As iHandle Ptr mt , mtc
	
	iCountTabs = IupGetChildCount(TGlobalVariables->tabs)
	
	iCurentTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	ac_free_dims_proc(tAcDimVariables() , tAcDimTypeVariables() , TAcDimLinesLocalArea() ,_
	tAcListTypes() , tAcParserListDeclaresFunc() )
	
	Redim sAcDimScopes(0) As String
	
	For i As Long = 1 To iCountTabs-1
		
		mt = TGlobalVariables->tTabsOptions(i).multitext
		
		If mt = 0 Then Continue For
		
		If i = iCurentTabs Then
			
			mtc = mt
			
		Else 'if Lcase(Right(*IupGetAttribute(mt , "FILENAME"),3)) = ".bi" Then
			
			If TGlobalVariables->bFlagBiFilesSignalUpdate Then
				
				iCountLines = IupGetInt(mt, "LINECOUNT")
				
				If iCountLines <=0 Then Continue For
				
				Redim Preserve sAcDimScopes(Ubound(sAcDimScopes) + iCountLines) As String
				
				ac_parser_proc(mt , 0) ' parsing only types and declarations and SHARED variables
				
			Endif
			
		Endif
		
	Next
	
	If TGlobalVariables->bFlagBiFilesSignalUpdate Then
		
		iAcIndexDimVariables_ForBI = iAcIndexDimVariables
		
		iAcIndexTypeVariables_ForBI = iAcIndexTypeVariables
		
		iAcIndexListTypes_ForBI = iAcIndexListTypes
		
		iAcIndexLinesLocalArea_ForBI = iAcIndexLinesLocalArea
		
		iAcIndexParserListDeclaresFunc_ForBI = iAcIndexParserListDeclaresFunc			
		
	Endif
	
	iCountLines = IupGetInt(mtc, "LINECOUNT")
	
	If iCountLines <=0 Then Exit Sub
	
	Redim Preserve sAcDimScopes(Ubound(sAcDimScopes) + iCountLines) As String
	
	ac_parser_proc(mtc , 1) ' full parsing	
	
	TGlobalVariables->bFlagBiFilesSignalUpdate = 0
	
End Sub

' the function searches for the part of the word in the array words  
Function ac_find_keywords_in_list_proc(pszDim As Zstring Ptr , sFind As String , bFlag As Byte ) As String
	
	Dim As Long iStart = 1 , iIndexFind , iSp
	
	Dim As Byte bFlagFindFirst
	
	Dim As String sResult 
	
	Do
		
		If bFlagFindFirst = 0 Andalso Len(sFind) Andalso Ucase(Left(*pszDim , Len(sFind))) = sFind Then
			
			bFlagFindFirst = 1
			
			iIndexFind = 0
			
		Else
			
			If bFlagFindFirst = 0 Andalso bFlag = 4 Then
				
				bFlagFindFirst = 1
				
			Else
				
				iIndexFind = Instr(iStart , Ucase(*pszDim) , " " & sFind)
				
			Endif
			
		Endif
		
		If iIndexFind Orelse bFlagFindFirst = 1 Then
			
			iIndexFind+=1
			
			bFlagFindFirst = 2
			
			iSp = Instr(iIndexFind + Len(sFind) , *pszDim , " ")
			
			If iSp Then
				
				sResult &= (Mid(*pszDim , iIndexFind , iSp - iIndexFind) & "?1 ")
				
				iStart = iSp
				
			Else
				
				sResult &= (Mid(*pszDim , iIndexFind ) & "?1 ")
				
				Exit Do
				
			Endif
			
		Else
			
			Exit Do
			
		Endif		
		
	Loop
	
	Return sResult	
	
End Function

' the function fills the string with data from extends types
Sub ac_get_extends_data_from_types_proc(Byval sType As String , sData As String , bReset As Byte ) 
	
	Static iCRecursionError As Long
	
	Static bErrorRecursion As Byte
	
	If bReset = 1 Then
		
		iCRecursionError = 0
		
		bErrorRecursion = 0
		
	Endif
	
	If iCRecursionError > 100 Then
		
		Print "infinity loop , force quit" 
		
		bErrorRecursion = 1
		
		Exit Sub
		
	Endif
	
	For i As Long = 0 To iAcIndexTypeVariables -1 
		
		If tAcDimTypeVariables(i).pszTypeName <> 0 Andalso *(tAcDimTypeVariables(i).pszTypeName) = sType Then
			
			If tAcDimTypeVariables(i).pszExtType Then
				
				If bErrorRecursion = 0 Then 
					iCRecursionError+=1
					ac_get_extends_data_from_types_proc(*(tAcDimTypeVariables(i).pszExtType) , sData , 0)
					iCRecursionError-=1
				Endif
				
			Endif
			
			If bAcDimIndexesExtends(i) = 0 Then
				
				bAcDimIndexesExtends(i) = 1
				
				If tAcDimTypeVariables(i).bTypeVar = 2 Orelse tAcDimTypeVariables(i).bTypeVar = 3 Then
					
					sData &= *(tAcDimTypeVariables(i).pszName) & "()?1 "
					
				Else
					
					sData &= *(tAcDimTypeVariables(i).pszName) & "?1 "
					
				Endif
				
			Endif
			
		Endif
		
	Next
	
End Sub

'function populates the autocomplete list 
Sub ac_fill_list_proc(sFind As String , bFlag As Byte , bFlagDotVar As Byte = 0)
	
	If bFlag = 3 Orelse bFlag = 10 Then
		
		Dim As String szDim = Trim(Ucase(*(TGlobalVariables->pszKeywords1)) , Any Chr(13) & Chr(10) & Chr(9) & " ") & " ", sTemp
		
		If iAcIndexListTypes Then
			
			For i As Long  = 0 To iAcIndexListTypes - 1
				
				If sTemp <> *(tAcListTypes(i).pszTypeName) Then
					
					sTemp = *(tAcListTypes(i).pszTypeName)
					
					szDim &= sTemp & " "
					
				Endif
				
			Next			
			
		Endif
		
		If Len(sFind) Then
			
			szDim = Trim(szDim , Any Chr(13) & Chr(10) & " " & Chr(9))
			
			If Len(szDim) Then
				
				sAcList = Trim(ac_find_keywords_in_list_proc(Strptr(szDim), sFind , 2))
				
			Endif
			
		Else
			
			szDim = misc_replace_string_proc(szDim , " " , "?1 " , ,1)
			
			szDim = Trim(szDim , Any Chr(13) & Chr(10) & " " & Chr(9))
			
			sAcList = szDim
			
		Endif
		
	Elseif bFlag = 1 Orelse bFlag = 4  Orelse bFlag = 20 Then	
		
		Dim As String sDim = Ucase(Trim(*(TGlobalVariables->pszKeywords0) , Any Chr(13) & Chr(10) & " ") _
		& " " & Trim(*(TGlobalVariables->pszKeywords2), Any Chr(13) & Chr(10) & " ") _ 
		& " " & Trim(*(TGlobalVariables->pszKeywords3), Any Chr(13) & Chr(10) & " ")) 
		
		sAcList = ""
		
		If Len(sFind) Then
			
			sAcList &= ac_find_keywords_in_list_proc(Strptr(sDim) , sFind , 2)
			
		Elseif bFlag = 4 Then
			
			sAcList &= ac_find_keywords_in_list_proc(Strptr(sDim) , sFind , 4)
			
		Endif
		
		sAcList	= Trim(sAcList)
		
	Elseif bFlag = 2 Orelse bFlag = 15 Then	
		
		Dim As String szDim  , sTempType
		
		Dim As Long iIndex = -1
		
		If bFlag = 2 Then	
			
			If iAcIndexTypeVariables Then
				
				For i As Long = 0 To iAcIndexTypeVariables -1 
					
					If tAcDimTypeVariables(i).pszTypeName <> 0 Andalso *(tAcDimTypeVariables(i).pszTypeName) = sFind Andalso _
					Len(*(tAcDimTypeVariables(i).pszName)) Then
						
						If tAcDimTypeVariables(i).bTypeVar = 2 Orelse tAcDimTypeVariables(i).bTypeVar = 3 _
						Orelse (tAcDimTypeVariables(i).bTypeVar = 4 Andalso bFlagDotVar) Then
							
							szDim &= *(tAcDimTypeVariables(i).pszName) & "()?1 "
							
						Elseif tAcDimTypeVariables(i).bTypeVar = 4 Then
							
							Continue For
							
						Elseif bFlagDotVar = 0 Then
							
							szDim &= *(tAcDimTypeVariables(i).pszName) & "?1 "
							
						Endif
						
						iIndex = i
						
					Endif
					
				Next
				
				
				If iIndex <> -1 Then
					
					If tAcDimTypeVariables(iIndex).pszExtType Then
						
						Redim bAcDimIndexesExtends(iAcIndexTypeVariables -1) As Byte
						
						ac_get_extends_data_from_types_proc(*(tAcDimTypeVariables(iIndex).pszExtType) , sTempType , 1)
						
						If Len(sTempType) Then
							
							szDim = sTempType & szDim
							
						Endif
						
					Endif
					
				Endif
				
				sAcList = Trim(szDim)
				
			Endif	
			
		Else
			
			szDim = misc_replace_string_proc(sAcList, "?1" , ""  , ,1)
			
			szDim = Trim(szDim)
			
			If Len(szDim) Then
				
				sAcList = Trim(ac_find_keywords_in_list_proc(Strptr(szDim) , sFind , 2))
				
			Endif
			
		Endif
		
	Endif	
	
End Sub

' function gets word from line in the curent position
Sub ac_get_word_proc(mt As Ihandle Ptr , iCurPos As Integer , sTextFind As String) 
	
	Dim As Integer iWordStartPosition , iWordEndPosition
	
	Dim As Zstring Ptr pszBuf
	
	iWordStartPosition = Cint(IupScintillaSendMessage( mt, SCI_WORDSTARTPOSITION, iCurPos, Cast(Any Ptr,-1)))
	
	iWordEndPosition = Cint(IupScintillaSendMessage( mt, SCI_WORDENDPOSITION, iCurPos, Cast(Any Ptr,0)))	
	
	If iWordEndPosition > iWordStartPosition Then
		
		Dim tr  As SCI_TEXTRANGE
		
		tr.chrg.cpMin = iWordStartPosition
		
		tr.chrg.cpMax = iWordEndPosition 
		
		pszBuf = Callocate((iWordEndPosition - iWordStartPosition) + 2)
		
		tr.lpstrText = pszBuf
		
		IupScintillaSendMessage( mt, SCI_GETTEXTRANGE, 0, Cast(Any Ptr, @tr)) 
		
		sTextFind = Ucase(Trim(*pszBuf , Any Chr(13) & Chr(10) & Chr(9) ))
		
		Deallocate(pszBuf)
		
	Endif
	
End Sub

'function get type from arrays chain of word (Sub AA.BB()   return  AA)
Function ac_gettype_subtypedotvar_proc(mt As Ihandle Ptr) As String
	
	If iAcIndexChainOfWords = 1 Then
		
		For i As Long = 0 To iAcIndexListTypes-1
			
			If *(tAcListTypes(i).pszTypeName) = sAcChainOfWords(0) Then
				
				Dim As String szTemp = Ucase(*IupGetAttribute(mt , "LINEVALUE")) 
				
				Dim As Byte bFlag
				
				If  Instr(szTemp , "SUB") <=0 Then
					
					If Instr(szTemp , "FUNCTION") <=0 Then
						
						If Instr(szTemp , "PROPERTY") <=0 Then
							
							If Instr(szTemp , "OPERATOR") <=0 Then
								
								Exit For
								
							Else	
								
								bFlag = 1
								
							Endif
							
						Else
							
							bFlag = 1
							
						Endif
						
					Else
						
						bFlag = 1
						
					Endif
					
				Else	
					
					bFlag = 1
					
				Endif
				
				If bFlag = 1 Then
					
					Return *(tAcListTypes(i).pszTypeName)
					
				Else
					
					Exit For
					
				Endif							
				
			Endif
			
		Next
		
	Endif	
	
End Function

' get all extends types
Sub ac_get_all_exttypes_proc(sFirstType As String , bReset As Byte = 0)
	
	Static iCRecursionError As Long
	
	Static bErrorRecursion As Byte
	
	If bReset = 1 Then
		
		iCRecursionError = 0
		
		bErrorRecursion = 0
		
	Endif
	
	If iCRecursionError > 100 Then
		
		Print "infinity loop , force quit" 
		
		bErrorRecursion = 1
		
		Exit Sub
		
	Endif
	
	For i As Long = 0 To iAcIndexListTypes-1
		
		If tAcListTypes(i).pszTypeName Andalso *(tAcListTypes(i).pszTypeName) = sFirstType Then
			
			If tAcListTypes(i).pszExtType Then
				
				iCRecursionError+=1
				
				If bErrorRecursion = 0 Then 
					
					ac_get_all_exttypes_proc(*(tAcListTypes(i).pszExtType))
					
				Endif
				
				iCRecursionError-=1
				
				If (iAcIndexExtendsTypes > 0)  Then
					
					For j As Long = 0 To iAcIndexExtendsTypes-1
						
						If sAcExtendsTypes(j) = *(tAcListTypes(i).pszExtType) Then
							
							Continue For , For
							
						Endif
						
					Next
					
				Endif
				
				sAcExtendsTypes(iAcIndexExtendsTypes) = *(tAcListTypes(i).pszExtType)
				
				iAcIndexExtendsTypes+=1
				
				If iAcIndexExtendsTypes > Ubound(sAcExtendsTypes) Then
					
					Redim Preserve sAcExtendsTypes(iAcIndexExtendsTypes+10) As String
					
				Endif
				
			Endif
			
		Endif
		
	Next
	
End Sub

' check: type has extends?
Function ac_is_exttype_proc(sType As String , iIndexMax As Long) As Long
	
	If iIndexMax = 0 Then Return -1
	
	For i As Long = 0 To iIndexMax-1  
		
		If sAcExtendsTypes(i) = sType Then
			
			Return i
			
		Endif
		
	Next
	
	Return -1
	
End Function

' check: type suitable for autocomplete? 
Function ac_is_actype_proc(sType As String) As Long
	
	If iAcIndexListTypes = 0 Then Return -1
	
	For i As Long = 0 To iAcIndexListTypes-1  
		
		If *(tAcListTypes(i).pszTypeName) = sType Then
			
			Return i
			
		Endif
		
	Next
	
	Return -1
	
End Function

' the function gets the type for the word , which is obtained under the cursor (in fact of the current word in the array sAcChainOfWords)
Function ac_gettype_from_alltypes_proc(Byref mt As Ihandle Ptr , iCurLine As Integer , Byref iResultLine As Integer , Byref bPlace As Byte = 0 , bAcChecking As Byte = 0) As String
	
	Dim As String sLocalFieldTypeName ' the name of the local type (field type) for a refund if allows scope and will not be found overriding the local variable 
	
	Dim As String sNoACType ' the name of the type to return , not having continuations completion (e.g. Long , string ...) 
	
	Dim As String sNoACTypeLocal ' the name of the local type (type field) to return , not having continuations completion (e.g. Long , string ...) 
	
	Dim As Byte bFlagLocalOK ' if equal to 1 , then the local variable (field type) is overridden by another variable 
	
	Dim As Byte bFlagLocalCurLine ' determines that the current line is in the local scope ( procedure , constructor...) 
	
	Redim sAcExtendsTypes(10) As String ' stores the types that extend the specified type.   
	
	iResultLine = -1
	
	'check local names from the list of fields types 
	If iAcIndexLinesLocalArea Then
		
		For i As Long = 0 To iAcIndexLinesLocalArea -1
			
			If iCurLine > tAcDimLinesLocalArea(i).iLineB Andalso iCurLine < tAcDimLinesLocalArea(i).iLineE Then
				
				bFlagLocalCurLine = 1
				
				Dim As Long iPos  = Instr(*(tAcDimLinesLocalArea(i).pszName), ".")
				
				Dim As Byte bFlagConstDestr
				
				If tAcDimLinesLocalArea(i).ftype = 10 Orelse tAcDimLinesLocalArea(i).ftype = 11 Then
					
					bFlagConstDestr = 1
					
				Endif
				
				If iPos Orelse bFlagConstDestr = 1 Then
					
					Dim As String sTempType ' curent local type (for example  sub A.func()  in this case  sTempType = A)
					
					If bFlagConstDestr = 1 Then
						
						sTempType = Ucase(*(tAcDimLinesLocalArea(i).pszName))
						
					Else
						
						sTempType = Ucase(Left(*(tAcDimLinesLocalArea(i).pszName) , iPos -1 ))
						
					Endif
					
					For j As Long = 0 To iAcIndexListTypes-1 
						
						If *(tAcListTypes(j).pszTypeName) = sTempType Then
							
							iAcIndexExtendsTypes = 0
							
							ac_get_all_exttypes_proc(sTempType, 1)
							
							Dim As Long iIndexMax = iAcIndexExtendsTypes
							
							For jt As Long = 0 To iAcIndexTypeVariables-1
								
								If tAcDimTypeVariables(jt).pszTypeName = 0 Then Continue For
								
								Dim As Long iIndexExt = ac_is_exttype_proc(*(tAcDimTypeVariables(jt).pszTypeName) , iIndexMax)
								
								If (*(tAcDimTypeVariables(jt).pszTypeName) = sTempType) Orelse (iIndexExt <> -1) Then
									
									If (sAcChainOfWords(iAcIndexChainOfWords-1) =  "THIS") Orelse (tAcDimTypeVariables(jt).pszName Andalso _
									Ucase(*(tAcDimTypeVariables(jt).pszName)) = sAcChainOfWords(iAcIndexChainOfWords-1)) Then
										
										Dim As String sType
										
										Dim As String sAcNoCheckType
										
										If (sAcChainOfWords(iAcIndexChainOfWords-1) =  "THIS") Then
											
											sType = sTempType
											
											sAcNoCheckType = sTempType
											
										Else
											
											If tAcDimTypeVariables(jt).pszType Then
												
												sAcNoCheckType = Ucase(*(tAcDimTypeVariables(jt).pszType))
												
												sType = ac_truncate_pointers_proc(sAcNoCheckType)
												
											Endif
											
										Endif												
										
										If iAcIndexChainOfWords = 1 Then
											
											If bAcChecking Then
												
												sLocalFieldTypeName = sType
												
											Else
												
												sLocalFieldTypeName = sAcNoCheckType
												
											Endif
											
											If (sAcChainOfWords(iAcIndexChainOfWords-1) =  "THIS") Then
												
												If Len(sLocalFieldTypeName) Then
													
													iResultLine = -1
													
													Return sLocalFieldTypeName
													
												Endif														
												
											Endif
											
											If iIndexExt <> -1 Then
												
												Continue For
												
											Endif
											
											Exit For , For
											
										Endif
										
										Dim As String sIntermediateType ' extending type 
										
										Dim As String sAcNoCheckIntermediateType ' (not for completion) extends type 
										
										Dim As Byte bFlagOk ' shows that found a complete coincidence, one part of the chain 
										
										For q As Long = iAcIndexChainOfWords-2 To 0 Step -1
											
											Dim As Byte bFlagIfIs ' shows the coincidence of the words with the names of the fields types 
											
											Dim As Byte bFlagNoErrorType ' If set to 1 , then the type of the given part of the chain is correct 
											
											For w As Long = 0 To iAcIndexTypeVariables-1
												
												If tAcDimTypeVariables(w).pszTypeName = 0 Orelse _
												tAcDimTypeVariables(w).pszName = 0 Then
													
													Continue For
													
												Endif
												
												If Ucase(*(tAcDimTypeVariables(w).pszName)) = sAcChainOfWords(q) Then
													
													bFlagIfIs = 1
													
												Else
													
													Continue For
													
												Endif
												
												If *(tAcDimTypeVariables(w).pszTypeName) = sType Then
													
													bFlagNoErrorType = 1
													
													sAcNoCheckType = *(tAcDimTypeVariables(w).pszType)
													
													sType = ac_truncate_pointers_proc(sAcNoCheckType)
													
													sNoACTypeLocal = ""
													
													bFlagOk = 1
													
													Exit For
													
												Else
													
													iAcIndexExtendsTypes = 0
													
													ac_get_all_exttypes_proc(sType,  1)
													
													Dim As Long iIndexMax = iAcIndexExtendsTypes
													
													Dim As Long iIndexExt = ac_is_exttype_proc(*(tAcDimTypeVariables(w).pszTypeName) , iIndexMax)	
													
													If iIndexExt <> -1 Then 	
														
														If Len(sType) Andalso sType <> "THIS" Andalso ac_is_actype_proc(sType) = -1 Then
															
															If Len(sNoACTypeLocal) Then
																
																Return ""																
																
															Endif
															
															If q <> iAcIndexChainOfWords-2 Then
																
																sNoACTypeLocal = ""
																
																sIntermediateType = ""
																
																Exit For, For ,For
																
															Else
																
																sNoACTypeLocal = *(tAcDimTypeVariables(w).pszType)
																
																sIntermediateType = ""
																
																Exit For, For 																
																
															Endif
															
														Else
															
															bFlagNoErrorType = 1
															
															sAcNoCheckIntermediateType = *(tAcDimTypeVariables(w).pszType)
															
															sIntermediateType = ac_truncate_pointers_proc(sAcNoCheckIntermediateType)
															
															sNoACTypeLocal = ""
															
														Endif
														
													Endif													
													
												Endif
												
											Next
											
											If bFlagIfIs = 0 Then
												
												sNoACTypeLocal = ""
												
												sIntermediateType = ""
												
												Exit For, For ,For
												
											Endif												
											
											If bFlagOk = 0 Andalso Len(sIntermediateType) Then
												
												If bFlagNoErrorType = 0 Then
													
													'sType = ""
													
													Exit For, For ,For
													
												Else
													
													sType = sIntermediateType 
													
													sAcNoCheckType = sAcNoCheckIntermediateType
													
												Endif
												
											Endif
											
											Dim As Byte bFieldTypeYesFlag ' just shows that the type was found to further determine the local type with THIS 
											
											If q = 0 Andalso bFlagOk = 1 Then 
												
												If bAcChecking Then
													
													sLocalFieldTypeName = sType
													
												Else
													
													sLocalFieldTypeName = sAcNoCheckType
													
												Endif
												
												bFieldTypeYesFlag = 1
												
											Elseif q = 0 Andalso Len(sIntermediateType) <> 0 Then
												
												If bAcChecking Then
													
													sLocalFieldTypeName = sIntermediateType
													
												Else
													
													sLocalFieldTypeName = sAcNoCheckIntermediateType
													
												Endif
												
												bFieldTypeYesFlag = 1
												
											Else
												
												bFlagOk = 0
												
											Endif	
											
											If bFieldTypeYesFlag = 1 Andalso (sAcChainOfWords(iAcIndexChainOfWords-1) =  "THIS") Then
												
												If Len(sLocalFieldTypeName) Then
													
													iResultLine = -1
													
													Return sLocalFieldTypeName		
													
												Endif
												
												Exit For , For																
												
											Endif
											
										Next
										
									Endif
									
								Endif
								
							Next
							
						Endif
						
					Next
					
				Else
					
					Exit For
					
				Endif
				
			Endif
			
		Next
		
	Endif
	
	'check all other names 
	If iAcIndexDimVariables Andalso iAcIndexChainOfWords Then
		
		For i As Long = iAcIndexDimVariables-1 To 0 Step -1
			
			If tAcDimVariables(i).pszName <> 0 Andalso Ucase(*(tAcDimVariables(i).pszName)) = sAcChainOfWords(iAcIndexChainOfWords-1) Then ' if the variable in the array is equal to the name in the chain 
				
				Dim As Long iLine = tAcDimVariables(i).iLine ' get the place (row) where the declared 
				
				If iLine > iCurLine Then
					
					Continue For
					
				Endif
				
				If iLine < Lbound(sAcDimScopes) Orelse iLine > Ubound(sAcDimScopes) Orelse _
				iCurLine > Ubound(sAcDimScopes) Orelse iCurLine < Lbound(sAcDimScopes) Then
					
					Exit For
					
				Endif
				
				Dim As Long iLenA = Len(sAcDimScopes(iLine)) ' get the length of the string in the array Scopes for this line where is declared 
				
				If Left(sAcDimScopes(iCurLine) , iLenA) = sAcDimScopes(iLine) Then ' if part of a string array Scope for the current line = line of the array Scope for line declares 
					
					If iLenA = 2 Andalso iLenA < Len(sAcDimScopes(iCurLine))  Then 
						
						If (tAcDimVariables(i).bGlob = 0 Andalso bFlagLocalCurLine = 1) Orelse (tAcDimVariables(i).bGlob = 1 Andalso Len(sLocalFieldTypeName) <> 0) Then
							
							Continue For ' if different scopes , but not a global variable or a variable from the field list, then continue search 
							
						Endif
						
					Endif
					
					bFlagLocalOK = 1
					
					Redim sAcExtendsTypes(10) As String
					
					'the scope of the variable choice  
					
					'continue to look for a type for a variable 
					
					Dim As String sTruncatePointersText = ac_truncate_pointers_proc(*(tAcDimVariables(i).pszType))
					
					Dim As String sAcNoCheckType , sAcNoCheckIntermediateType
					
					sNoACType = *(tAcDimVariables(i).pszType)
					
					If sTruncatePointersText = *(tAcDimVariables(i).pszName) Then
						
						If  tAcDimVariables(i).bPlace = 2 Then
							
							bPlace = 3
							
						Else
							
							bPlace = tAcDimVariables(i).bPlace
							
						Endif
						
					Else
						
						bPlace = tAcDimVariables(i).bPlace
						
					Endif
					
					mt = tAcDimVariables(i).mt
					
					If mt Then
						
						iResultLine = tAcDimVariables(i).iRealLineForBi
						
					Else
					
						iResultLine = iLine
						
					Endif
					
					Dim As Byte bFlagOk
					
					For j As Long = 0 To iAcIndexListTypes-1
						
						If tAcDimVariables(i).pszType = 0 Then Continue For 
						
						If *(tAcListTypes(j).pszTypeName) = sTruncatePointersText Then	
							
							Dim As String sType = sTruncatePointersText
							
							sAcNoCheckType = *(tAcDimVariables(i).pszType)
							
							If iAcIndexChainOfWords = 1 Then
								
								If bAcChecking Then
									
									Return sType
									
								Else
									
									Return sAcNoCheckType
									
								Endif
								
							Endif
							
							Dim As String sIntermediateType
							
							For q As Long = iAcIndexChainOfWords-2 To 0 Step -1
								
								Dim As Byte bFlagIfIs , bFlagNoErrorType
								
								For w As Long = 0 To iAcIndexTypeVariables-1
									
									If tAcDimTypeVariables(w).pszTypeName = 0 Orelse tAcDimTypeVariables(w).pszName = 0 Then
										
										Continue For
										
									Endif
									
									If Ucase(*(tAcDimTypeVariables(w).pszName)) = sAcChainOfWords(q) Then
										
										bFlagIfIs = 1
										
									Else
										
										Continue For
										
									Endif									
									
									If *(tAcDimTypeVariables(w).pszTypeName) = sType Then
										
										bFlagNoErrorType = 1
										
										sType = ac_truncate_pointers_proc(*(tAcDimTypeVariables(w).pszType))
										
										sAcNoCheckType = *(tAcDimTypeVariables(w).pszType)
										
										bFlagOk = 1
										
										Exit For
										
									Else
										
										iAcIndexExtendsTypes = 0
										
										ac_get_all_exttypes_proc(sType,  1)
										
										Dim As Long iIndexMax = iAcIndexExtendsTypes
										
										Dim As Long iIndexExt = ac_is_exttype_proc(*(tAcDimTypeVariables(w).pszTypeName) , iIndexMax)	
										
										If iIndexExt <> -1 Then 	
											
											bFlagNoErrorType = 1
											
											sIntermediateType = ac_truncate_pointers_proc(*(tAcDimTypeVariables(w).pszType))
											
											sAcNoCheckIntermediateType = *(tAcDimTypeVariables(w).pszType)																													
											
										Endif
										
									Endif
									
								Next
								
								If bFlagIfIs = 0 Then
									
									sNoACType = ""
									
									Exit For, For ,For
									
								Endif								
								
								If bFlagOk = 0 Andalso Len(sIntermediateType) Then
									
									If Len(sType) Andalso ac_is_actype_proc(sType) = -1 Then
										
										sNoACType = ""
										
										Exit For,For
										
									Endif
									
									If bFlagNoErrorType = 0 Then
										
										Return ""
										
									Else
										
										sType = sIntermediateType 
										
										sAcNoCheckType = sType
										
									Endif
									
								Endif
								
								If q = 0 Andalso bFlagOk = 1 Then 
									
									If bAcChecking Then
										
										Return sType
										
									Else
										
										Return sAcNoCheckType
										
									Endif
									
								Elseif q = 0 Andalso Len(sIntermediateType) <> 0 Then
									
									If bAcChecking Then
										
										Return sIntermediateType
										
									Else
										
										Return sAcNoCheckIntermediateType
										
									Endif
									
								Elseif q = 0  Then	
									
									sNoACType = ""
									
								Else
									
									bFlagOk = 0
									
								Endif
								
							Next
							
						Endif
						
					Next
					
					Exit For
					
				Endif
				
			Endif
			
		Next
		
	Endif
	
	If Len(sLocalFieldTypeName) Andalso bFlagLocalOK = 0 Then	
		
		iResultLine = -1
		
		Return sLocalFieldTypeName	
		
	Elseif Len(sNoACType) Then
		
		Return sNoACType
		
	Elseif Len(sNoACTypeLocal) Then	
		
		Return sNoACTypeLocal
		
	Endif
	
End Function

' specifies the start and the auto-complete option, depending on what flag bAcKeyOption
Sub ac_start_proc(mt As Ihandle Ptr)
	
	If (bAcKeyOption = 10 Orelse bAcKeyOption = 15 Orelse bAcKeyOption = 20) Andalso *IupGetAttribute(mt , "AUTOCACTIVE") = "NO" Then
		
		bAcKeyOption = 0
		
	Endif	
	
	Select Case bAcKeyOption 
			
		Case 1 , 4 , 10 , 15 , 20
			
			Dim As Integer  iCurPos , iLength 
			
			Dim As String sTextFind
			
			iCurPos = Cint(IupScintillaSendMessage(mt , SCI_GETCURRENTPOS , 0 , 0 ))
			
			iLength = iCurPos - Cint(IupScintillaSendMessage( mt, SCI_WORDSTARTPOSITION, iCurPos, Cast(Any Ptr,-1)))
			
			If bAcKeyOption = 1 Andalso iLength < Val(*(IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser" , "lenght"))) Then
				
				bAcKeyOption = 0
				
				Exit Sub	
				
			Endif	
			
			ac_get_word_proc(mt , iCurPos , sTextFind)				
			
			ac_fill_list_proc(sTextFind , bAcKeyOption)
			
			If Len(sAcList) Then
				
				IupScintillaSendMessage(mt, SCI_AUTOCSETORDER, SC_ORDER_PERFORMSORT , 0)
				
				IupScintillaSendMessage(mt, SCI_AUTOCSHOW, iLength, Cast(Any Ptr,Strptr(sAcList)))
				
			Endif	
			
			If bAcKeyOption = 1	Then
				
				bAcKeyOption = 0
				
			Elseif bAcKeyOption = 4	Then
				
				bAcKeyOption = 20
				
			Endif
			
		Case 3
			
			Dim As Integer  iCurPos
			
			Dim As String sTextFind
			
			iCurPos = Cint(IupScintillaSendMessage(mt , SCI_GETCURRENTPOS , 0 , 0 )) - 1	
			
			ac_get_word_proc(mt , iCurPos , sTextFind)
			
			If Left(sTextFind , 3) = "AS " Then
				
				ac_fill_list_proc("" , 3)
				
				If Len(sAcList) Then
					
					IupScintillaSendMessage(mt, SCI_AUTOCSETORDER, SC_ORDER_PERFORMSORT , 0)
					
					IupScintillaSendMessage(mt, SCI_AUTOCSHOW, 0, Cast(Any Ptr,Strptr(sAcList)))
					
					bAcKeyOption = 10	
					
				Endif	
				
			Else
				
				bAcKeyOption = 0
				
				IupSetAttribute(mt , "AUTOCCANCEL" , "YES")				
				
			Endif
			
		Case 2
			
			If iAcIndexListTypes = 0 Orelse iAcIndexListTypes-1 > Ubound(tAcListTypes) Then
				
				Exit Sub
				
			Endif
			
			Dim As Integer iCurPos = Cint(IupScintillaSendMessage(mt , SCI_GETCURRENTPOS , 0 , 0 ))
			
			Dim As Integer iCurLine = ac_split_words_proc(mt , iCurPos)
			
			Dim As String sRetType
			
			If iAcIndexChainOfWords Then
				
				' check {sub typeA.mytype}			
				sRetType = ac_gettype_subtypedotvar_proc(mt)
				
				Dim As Byte bFlagDotVar
				
				If Len(sRetType) = 0 Then
					' checking all other types
					Dim As Integer iRetLine
					
					Dim As iHandle Ptr hMultiText
					
					sRetType = ac_gettype_from_alltypes_proc(hMultiText , iCurLine , iRetLine,,1)
					
				Else
					
					bFlagDotVar = 1
					
				Endif
				
				If Len(sRetType) Then	
					
					ac_fill_list_proc(sRetType , 2 , bFlagDotVar)
					
					If Len(sAcList) Then
						
						IupScintillaSendMessage(mt, SCI_AUTOCSETORDER, 2 , 0) 'SC_ORDER_CUSTOM = 2
						
						IupScintillaSendMessage(mt, SCI_AUTOCSHOW, 0, Cast(Any Ptr,Strptr(sAcList)))
						
						bAcKeyOption = 15
						
						Exit Sub
						
					Endif					
					
				Endif
				
			Endif				
			
	End Select
	
End Sub

' parses keys and sets a flag  bAcKeyOption
Sub ac_parser_keys_proc(mt As Ihandle Ptr, iKey As Integer)
	
	If *IupGetAttribute(mt , "AUTOCACTIVE") = "NO" Then
		
		bAcKeyOption = 0
		
	Endif
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Then
		
		Exit Sub
		
	Endif
	
	Select Case iKey
			
		Case &h30 To &h39 , &h41 To &h5A , &h61 To &h7A , &h5F , K_BS  
			
			'automatic auto-completion  
			If bAcKeyOption = 0 Andalso *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isautokeyword") = "ON" Then
				
				bAcKeyOption = 1
				
			Endif
			
		Case K_period , K_greater
			
			'Supplement field types 
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isautoft") = "ON" Then
				
				bAcKeyOption = 2
				
			Endif
			
		Case K_SP
			
			If bAcKeyOption = 0 Then
				
				If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isautoas") = "ON" Then
					
					bAcKeyOption = 3
					
				Endif
				
				'checking add on AS 
				
			Else
				
				bAcKeyOption = 0
				
				IupSetAttribute(mt , "AUTOCCANCEL" , "YES")
				
			Endif
			
		Case K_cSP
			
			'automatic completion caused by force with the help of CTRL+SPACE 
			
			bAcKeyOption = 4
			
			ac_start_proc(mt)	
			
		Case K_DEL
			
			TGlobalVariables->dTimeUpdateListSideWin = Timer
			
			TGlobalVariables->bUpdateAutoCompletion = 0
			
			TGlobalVariables->bUpdateListSideWin = 0
			
			TGlobalVariables->bUpdateTips = 0
			
		Case K_LSHIFT , K_RSHIFT , K_CAPS
			
		Case Else
			
			bAcKeyOption = 0	
			
	End Select
	
End Sub

' gets the type of the current word under the cursor when pressing the hot key and highlights it in the tip
Sub ac_user_action_get_type_proc() 
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Exit Sub
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgwarningtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgnotactiveparser"))
		
		Exit Sub
		
	Endif
	
	Dim As Integer iCurPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETCURRENTPOS , 0 , 0 ))	
	
	Dim As Integer iCurLine  , iIndex 
	
	For iIndex = iCurPos To iCurPos+100
		
		Select Case *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CHAR" & iIndex) 
				
			Case Chr(&h30) To Chr(&h39) , Chr(&h41) To Chr(&h5A) , Chr(&h61) To Chr(&h7A) , Chr(&h5F)
				
			Case Else
				
				Exit For
				
		End Select
		
	Next
	
	iCurLine = ac_split_words_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , iIndex)
	
	Dim As Integer iRetLine
	
	Dim As iHandle Ptr hMultiText
	
	Dim As String sRet = ac_gettype_from_alltypes_proc(hMultiText , iCurLine , iRetLine)		
	
	If Len(sRet) Then
		
		If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Parser" , "tips1") = "1" Then
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CALLTIPCANCEL , 0, 0)
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_CALLTIPSHOW , iCurPos, Strptr(sRet))
			
		Else
			
			Dim As String sStyles = String(Len(sRet), 45)
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONCLEARALL, 0, 0)	
			
			IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONSETTEXT, iCurLine, Strptr(sRet))
			
			If Len(sStyles) Then
				
				IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext, SCI_ANNOTATIONSETSTYLES, iCurLine, Strptr(sStyles))
				
			Endif
			
		Endif	
		
	Endif
	
End Sub

'gets the type of the current word under the cursor when pressing the hot key and goto to its place declaration 
Sub ac_get_var_declares_proc() 
	
	If IupGetChildCount(TGlobalVariables->tabs) < 2 Then Exit Sub
	
	Dim As Long idTabs = Val(*IupGetAttribute(TGlobalVariables->tabs, "VALUEPOS"))
	
	If TGlobalVariables->tTabsOptions(idTabs).multitext = 0 Then Exit Sub
	
	If *IupConfigGetVariableStr(TGlobalVariables->hConfig,"Parser","isparser") = "OFF" Then
		
		IupMessage(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgwarningtitle"),_
		*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgnotactiveparser"))
		
		Exit Sub
		
	Endif
	
	Dim As Integer iCurPos = Cint(IupScintillaSendMessage(TGlobalVariables->tTabsOptions(idTabs).multitext , SCI_GETCURRENTPOS , 0 , 0 ))	
	
	Dim As String sText
	
	Dim As Integer iCurLine  , iIndex  , iCurPosTemp = iCurPos-1
	
	If iCurPosTemp >=0 Then
		
		Select Case *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CHAR" & iCurPosTemp)
				
			Case Chr(&h30) To Chr(&h39) , Chr(&h41) To Chr(&h5A) , Chr(&h61) To Chr(&h7A) , Chr(&h5F)
				
			Case Else
				
				iCurPosTemp = iCurPos
				
		End Select
		
	Else
		
		iCurPosTemp = iCurPos
		
	Endif
	
	ac_get_word_proc(TGlobalVariables->tTabsOptions(idTabs).multitext, iCurPosTemp , sText)
	
	sText = Ucase(Trim(sText, Any " " &Chr(9)))
	
	If Len(sText) = 0 Then Exit Sub
	
	For iIndex = iCurPos To iCurPos+100
		
		Select Case *IupGetAttribute(TGlobalVariables->tTabsOptions(idTabs).multitext, "CHAR" & iIndex) 
				
			Case Chr(&h30) To Chr(&h39) , Chr(&h41) To Chr(&h5A) , Chr(&h61) To Chr(&h7A) , Chr(&h5F)
				
			Case Else
				
				Exit For
				
		End Select
		
	Next
	
	iCurLine = ac_split_words_proc(TGlobalVariables->tTabsOptions(idTabs).multitext , iIndex)
	
	Dim As Integer iLine
	
	Dim As Byte bPlace
	
	Dim As iHandle Ptr hMultiText
	
	Dim As String sRet = ac_gettype_from_alltypes_proc(hMultiText, iCurLine , iLine , bPlace)
	
	If Len(sRet) = 0 Then Exit Sub
	
	If hMultiText = 0 Then
		
		For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
			
			If IupGetInt(TGlobalVariables->tTabsOptions(j).multitext, "DECLAREPREVMT") Then
				
				IupSetInt(TGlobalVariables->tTabsOptions(j).multitext, "DECLAREPREVMT" , 0)
				
				IupSetInt(TGlobalVariables->tTabsOptions(j).multitext, "DECLAREPREVPOS" , -1)
				
				Exit For
				
			Endif
			
		Next
		
		hMultiText = TGlobalVariables->tTabsOptions(idTabs).multitext
		
	Else
		
		Static As Zstring*17 pszMt
		
		pszMt = Str(TGlobalVariables->tTabsOptions(idTabs).multitext)
		
		For j As Long = 1 To IupGetChildCount(TGlobalVariables->tabs) - 1
			
			If TGlobalVariables->tTabsOptions(j).multitext = hMultiText Then
				
				IupSetAttribute(hMultiText, "DECLAREPREVMT" , @pszMt)
				
				IupSetAttribute(TGlobalVariables->tabs, "VALUEPOS" , Str(j))
				
				IupSetFocus(TGlobalVariables->tTabsOptions(j).multitext)
				
				IupFlush()
				
				tmr_update_after_changes()
				
				Exit For
				
			Endif
			
		Next
		
	Endif
	
	Dim As Integer iLineCount = Val(*IupGetAttribute(hMultiText,"LINECOUNT"))
	
	If iLineCount <= 0 Then Exit Sub
	
	If iLine = -1 Orelse iLineCount-1 < iLine  Then Exit Sub	
	
	Dim As Integer iPosLineBegin , iLenLine , iLenFind = Len(sText) 
	
	If iLenFind = 0 Orelse bPlace = 0 Then Exit Sub
	
	IupTextConvertLinColToPos(hMultiText, iLine , 0, Cast(Any Ptr, @iPosLineBegin))
	
	iLenLine = Len(*IupGetAttribute(hMultiText , "LINE" & iLine))
	
	Dim As String sOperAS = "AS"
	
	Dim As Integer iResult
	
	If bPlace = 2 Orelse bPlace = 3 Then
		
		IupScintillaSendMessage( hMultiText , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)	
		
		IupScintillaSendMessage( hMultiText , SCI_SETTARGETSTART , iPosLineBegin , 0)
		
		IupScintillaSendMessage( hMultiText , SCI_SETTARGETEND ,  iPosLineBegin+iLenLine , 0)		
		
		If bPlace = 2 Then
			
			iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
			SCI_SEARCHINTARGET , 2  , Strptr(sOperAS) ))
			
		Else
			
			iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
			SCI_SEARCHINTARGET , iLenFind  , Strptr(sText)))		
			
		Endif
		
		If iResult = -1 Then
			
			Exit Sub
			
		Endif
		
		IupScintillaSendMessage( hMultiText , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)	
		
		IupScintillaSendMessage( hMultiText , SCI_SETTARGETSTART , iResult + 2 , 0)
		
		IupScintillaSendMessage( hMultiText , SCI_SETTARGETEND ,  iPosLineBegin+iLenLine , 0)	
		
		iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
		SCI_SEARCHINTARGET , iLenFind  , Strptr(sText) ))		
		
	Elseif bPlace = 1 Then	
		
		IupScintillaSendMessage( hMultiText , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)	
		
		IupScintillaSendMessage( hMultiText , SCI_SETTARGETSTART , iPosLineBegin , 0)
		
		IupScintillaSendMessage( hMultiText , SCI_SETTARGETEND ,  iPosLineBegin+iLenLine , 0)	
		
		iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
		SCI_SEARCHINTARGET , iLenFind  , Strptr(sText) ))		
		
	Endif
	
	If iResult = -1 Then
		
		Dim As String sML
		
		Dim As Long iBeginTransferLines
		
		iBeginTransferLines = ann_get_multiline_string_proc(hMultiText , iLine , sML , 1)
		
		If iBeginTransferLines = -2 Then Exit Sub
		
		Dim As Integer iPosLineBeginTransfer
		
		IupTextConvertLinColToPos(hMultiText, iBeginTransferLines , 0, Cast(Any Ptr, @iPosLineBeginTransfer))
		
		If bPlace = 2 Then
			
			IupScintillaSendMessage( hMultiText , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)	
			
			IupScintillaSendMessage( hMultiText , SCI_SETTARGETSTART , iPosLineBeginTransfer , 0)
			
			IupScintillaSendMessage( hMultiText , SCI_SETTARGETEND ,  iPosLineBegin , 0)		
			
			iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
			SCI_SEARCHINTARGET , 2  , Strptr(sOperAS) ))	
			
			If iResult = -1 Then
				
				Exit Sub
				
			Endif
			
			IupScintillaSendMessage( hMultiText , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)	
			
			IupScintillaSendMessage( hMultiText , SCI_SETTARGETSTART , iResult + 2 , 0)
			
			IupScintillaSendMessage( hMultiText , SCI_SETTARGETEND ,  iPosLineBegin , 0)	
			
			iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
			SCI_SEARCHINTARGET , iLenFind  , Strptr(sText) ))	
			
		Else
			
			IupScintillaSendMessage( hMultiText , SCI_SETSEARCHFLAGS , SCFIND_WHOLEWORD , 0)	
			
			IupScintillaSendMessage( hMultiText , SCI_SETTARGETSTART , iPosLineBeginTransfer , 0)
			
			IupScintillaSendMessage( hMultiText , SCI_SETTARGETEND , iPosLineBegin  , 0)	
			
			iResult =  Cint(IupScintillaSendMessage( hMultiText ,_
			SCI_SEARCHINTARGET , iLenFind  , Strptr(sText) ))					
			
		Endif
		
	Endif
	
	If iResult <> -1 Then
		
		IupSetInt(hMultiText, "CARETPOS" , iResult)
		
		IupSetfAttribute(hMultiText, "SELECTIONPOS", !"%d:%d", iResult,iResult+iLenFind )	
		
		IupSetInt(hMultiText, "DECLAREPREVPOS" , iCurPos)				
		
	Endif
	
End Sub
