#ifdef __fb_win32__
	#ifdef __fb_64bit__
		#libpath "libchm\w64"
	#else
		#libpath "libchm\w32"
	#endif	
#else
	#ifdef __fb_64bit__
		#libpath "libchm/l64"
	#else
		#libpath "libchm/l32"
	#endif	
#endif

#inclib "chm"

#pragma Once

Extern "C"
	
	#define INCLUDED_CHMLIB_H
	
	#ifdef __fb_win32__
		Type __int64 As Longint
	#endif
	
	Type chmFile As Any 
	
	Type LONGUINT64 As Ulongint
	Type LONGINT64 As Longint
	Const CHM_UNCOMPRESSED = 0
	Const CHM_COMPRESSED = 1
	Const CHM_MAX_PATHLEN = 512
	
	Type chmUnitInfo
		start As LONGUINT64
		length As LONGUINT64
		Space As Long
		flags As Long
		path As Zstring * 512 + 1
	End Type
	
	Declare Function chm_open(Byval filename As Const Zstring Ptr) As chmFile Ptr
	Declare Sub chm_close(Byval h As chmFile Ptr)
	Const CHM_PARAM_MAX_BLOCKS_CACHED = 0
	Declare Sub chm_set_param(Byval h As chmFile Ptr, Byval paramType As Long, Byval paramVal As Long)
	Const CHM_RESOLVE_SUCCESS = 0
	Const CHM_RESOLVE_FAILURE = 1
	Declare Function chm_resolve_object(Byval h As chmFile Ptr, Byval objPath As Const Zstring Ptr, Byval ui As chmUnitInfo Ptr) As Long
	Declare Function chm_retrieve_object(Byval h As chmFile Ptr, Byval ui As chmUnitInfo Ptr, Byval buf As Ubyte Ptr, Byval addr As LONGUINT64, Byval Len As LONGINT64) As LONGINT64
	Type CHM_ENUMERATOR As Function(Byval h As chmFile Ptr, Byval ui As chmUnitInfo Ptr, Byval context As Any Ptr) As Long
	Const CHM_ENUMERATE_NORMAL = 1
	Const CHM_ENUMERATE_META = 2
	Const CHM_ENUMERATE_SPECIAL = 4
	Const CHM_ENUMERATE_FILES = 8
	Const CHM_ENUMERATE_DIRS = 16
	Const CHM_ENUMERATE_ALL = 31
	Const CHM_ENUMERATOR_FAILURE = 0
	Const CHM_ENUMERATOR_CONTINUE = 1
	Const CHM_ENUMERATOR_SUCCESS = 2
	Declare Function chm_enumerate(Byval h As chmFile Ptr, Byval what As Long, Byval e As CHM_ENUMERATOR, Byval context As Any Ptr) As Long
	Declare Function chm_enumerate_dir(Byval h As chmFile Ptr, Byval prefix As Const Zstring Ptr, Byval what As Long, Byval e As CHM_ENUMERATOR, Byval context As Any Ptr) As Long
	
End Extern
