'#define __USE_GTK3__

#ifdef __fb_win32__
	
	#include "windows.bi"
	
	#include "win\shellapi.bi"
	
	#include "libiconv.bi"
	
	#inclib "iconv-2"
	
	#libpath "."
	
	Declare Function hlp_OpenHelp_proc(szPathHelp As String ,szTopic As String , iParam As Integer ) As HWND 

#else

	#include "crt/iconv.bi"
	
	#include "gtk/gtk.bi"
	
	Extern "C"
	
		Type _stat
			
			st_dev As dev_t
			
			#ifndef __fb_64bit__
			
			pad1 As Long
			
			st_ino As ino_t
			
			st_mode As mode_t
			
			st_nlink As nlink_t
			
			#else
			
			st_ino As ino_t
			
			st_nlink As nlink_t
			
			st_mode As mode_t	
			
			#endif
			
			st_uid As uid_t
			
			st_gid As gid_t
			
			st_rdev As dev_t
			
			#ifndef __fb_64bit__
			
			pad2 As Long
			
			#endif
			
			st_size As off_t
			
			st_atime As time_t
			
			st_atime_usec As time_t
			
			st_mtime As time_t
			
			st_mtime_usec As time_t
			
			st_ctime As time_t
			
			st_ctime_usec As time_t
			
			st_blksize As Uinteger 'blksize_t
			
			st_blocks As blkcnt_t
			
		End Type

		Declare Function stat (Byval As Zstring Ptr, Byval As _stat Ptr) As Long 
	
	End Extern
	
	#define S_IFMT  &o170000
	
	#define S_IFDIR  &o40000	
	
	#define S_ISDIR(m)	(((m) And S_IFMT) = S_IFDIR)

#endif

#include Once "IUP/iup.bi"

#include Once "IUP/iup_scintilla.bi"

#include Once "IUP/iup_config.bi"

#include Once "crt.bi"

#include Once "vbcompat.bi"

#include "chm_lib.bi"

Extern "C"
Declare Function IupScintillaSendMessage(Byval ih As Ihandle Ptr, Byval iMessage As Ulong, Byval wParam As Uinteger , Byval lParam As Zstring Ptr) As Integer Ptr
Declare Function IupExecute(As Zstring Ptr , As Zstring Ptr) As Integer
End Extern

#define SCFIND_WHOLEWORD &h2
#define SCFIND_MATCHCASE &h4
#define SCFIND_WORDSTART &h00100000
#define SCFIND_REGEXP &h00200000
#define SCFIND_POSIX &h00400000
#define SCI_SETSEARCHFLAGS 2198
#define SCI_SETTARGETRANGE 2686
#define SCI_SEARCHINTARGET 2197
#define SCI_SETTARGETSTART 2190
#define SCI_GETTARGETSTART 2191
#define SCI_SETTARGETEND 2192
#define SCI_REPLACESEL 2170
#define SCI_SETSELFORE 2067
#define SCI_SETSELBACK 2068
#define SCI_SETCARETLINEVISIBLE 2096
#define SCI_CONVERTEOLS 2029
#define SC_EOL_CRLF 0
#define SC_EOL_LF 2
#define SC_ORDER_PERFORMSORT 1
#define SCI_SETEOLMODE 2031
#define SCI_GETSELECTIONSTART 2143
#define SCI_GETSELECTIONEND 2145
#define SCI_COUNTCHARACTERS 2633
#define SCI_GETCURLINE 2027
#define SCI_GETCURRENTPOS 2008
#define SCI_WORDSTARTPOSITION 2266
#define SCI_WORDENDPOSITION 2267
#define SCI_GETTEXTRANGE 2162
#define SCI_STYLESETCASE = 2060
#define SCI_SETWORDCHARS 2077
#define SCI_COPY 2178
#define SCI_PASTE 2179
#define SCI_CUT 2177
#define SCI_GETEOLMODE 2030
#define SCI_AUTOCSETORDER 2660
#define SCI_AUTOCSETCHOOSESINGLE 2113
#define SCI_AUTOCSETIGNORECASE 2115
#define SCI_AUTOCSETMAXWIDTH 2208
#define SCI_AUTOCSETMAXHEIGHT 2210
#define SCI_AUTOCSETAUTOHIDE 2118
#define SCI_RGBAIMAGESETWIDTH 2624
#define SCI_RGBAIMAGESETHEIGHT 2625
#define SCI_REGISTERRGBAIMAGE 2627
#define SCI_AUTOCSHOW 2100
#define SCI_AUTOCCANCEL 2101
#define SCI_AUTOCACTIVE 2102
#define SCI_GETCHARAT 2007
#define ANNOTATION_BOXED 2
#define SCI_ANNOTATIONSETVISIBLE 2548
#define SCI_STYLESETBACK 2052
#define SCI_STYLESETFORE 2051
#define SCI_ANNOTATIONSETTEXT 2540
#define SCI_ANNOTATIONCLEARALL 2547
#define SCI_ANNOTATIONSETSTYLES 2544
#define SCI_GOTOLINE 2024
#define SCI_CANUNDO 2174
#define SCI_CANREDO 2016
#define SCI_EMPTYUNDOBUFFER 2175
#define SCI_GETSTYLEAT 2010
#define SCI_GETSTYLEDTEXT 2015
#define SCI_GETFIRSTVISIBLELINE 2152
#define SCI_LINESCROLL 2168
#define SCI_LINEFROMPOSITION 2166
#define SCI_LINESONSCREEN 2370
#define SCI_SETFIRSTVISIBLELINE 2613
#define SCI_SETXOFFSET 2397
#define SCI_POSITIONFROMLINE 2167
#define SCI_CALLTIPCANCEL 2201
#define SCI_CALLTIPSHOW 2200
#define SCI_CALLTIPSETBACK 2205
#define SCI_CALLTIPSETFORE 2206
#define SCI_CALLTIPSETFOREHLT 2207
#define SCI_STYLESETSIZE 2055
#define SCI_STYLESETFONT 2056
#define SCI_STYLESETBOLD 2053
#define SCI_STYLESETITALIC 2054
#define SCI_CALLTIPUSESTYLE 2212

Type TProjectChild
	
	As Ihandle Ptr mt
	
	As Zstring Ptr pszFile
	
End Type

Type TProject
	
	As Zstring Ptr pszNameProject
	
	As Zstring Ptr pszPathProject
	
	As Zstring Ptr pszParamProject
	
	As Zstring Ptr pszEncProject
	
	As TProjectChild tBasFiles(1000)
	
	As TProjectChild tBiFiles(1000)
	
	As TProjectChild tRcFiles(100)
	
	As Long iCurentMainFile
	
	As Long iProjectLoad
	
End Type

Type SCI_CHARACTERRANGE 
   
   #ifdef __fb_win32__
   ' Для windows 32 и 64-bit нужны 4-х байтовые определения cpMin, cpMax 
      cpMin As Long
      
      cpMax As Long
   
   #else
   ' Для Linux 64 bit , почему то важно , чтобы поля были Integer (8 байтовые). 
      cpMin As Integer
      
      cpMax As Integer   
   
   #endif
   
End Type

Type SCI_TEXTRANGE  
   
   chrg      As SCI_CHARACTERRANGE
   
   lpstrText As Zstring Ptr
   
End Type

Type TProcess
   
	pszFileName As Zstring Ptr
	
	pszExeName As Zstring Ptr
	
End Type

Type T_TabsOptions
	
	As IHandle Ptr multitext
	
End Type

Type T_GlobalVariables
	
	As Tlist Ptr t_list
	
	As IHandle Ptr dlg
	
	As IHandle Ptr find_dlg
	
	As Ihandle Ptr tool_dlg
	
	As IHandle Ptr tabs
	
	As IHandle Ptr toolbar
	
	As IHandle Ptr statusbar
	
	As IHandle Ptr buildbox
	
	As IHandle Ptr split
	
	As IHandle Ptr vertsplit
	
	As Ihandle Ptr hTimer 
	
	As Ihandle Ptr hTimerUpdateStatusBar
	
	As Ihandle Ptr hTimerUpdateBiFiles
	
	As ihandle Ptr hConfig
	
	As ihandle Ptr hConfigL
	
	As ihandle Ptr hConfigplug
	
	As ihandle Ptr hOptions
	
	As ihandle Ptr hItemTools
	
	As ihandle Ptr hItemFB
	
	As ihandle Ptr hItemAbout
	
	As Double dTimeUpdateListSideWin
	
	As Byte bFlagFindInfo
	
	As Byte bUpdateListSideWin
	
	As Byte bUpdateAutoCompletion
	
	As Byte bUpdateTips
	
	As Byte bFlagBiFilesSignalUpdate
	
	As Byte bFlagInitEditor_ForCallbacks
	
	As Zstring*4 szLangid
	
	As Zstring*40 szLangName
	
	As Zstring*8 szColorbtn(1 To 40)
	
	As Zstring*4 szAlphaCaret
	
	As Zstring*100 szFontEditor
	
	As Zstring*4 szFontEditorSize
		
	As Zstring*100 szFontStatus
	
	As Zstring*4 szFontStatusSize
	
	As Zstring*100 szFontWinOut
	
	As Zstring*4 szFontWinOutSize
	
	As Zstring*100 szFontWinSide
	
	As Zstring*4 szFontWinSideSize
	
	As Zstring*100 szFontAnnot
	
	As Zstring*4 szFontAnnotSize		
		
	As Byte blangCurrent
	
	As Byte bLineAutocomplect
	
	As Byte bFlagAutoComplect
	
	As Byte bFlagFolding
	
	As Zstring*21 szDefaultSystemEncoding
	
	As Zstring Ptr pszKeywords0
	
	As Zstring Ptr pszKeywords1
	
	As Zstring Ptr pszKeywords2
	
	As Zstring Ptr pszKeywords3
	
	As Zstring Ptr pszKeywordscpp
	
	As Zstring Ptr pszKeywordsasm
	
	As Zstring Ptr pszKeywordsrc
	
	As T_TabsOptions tTabsOptions(100)
	
End Type

Type T_DimInfoSideList
	
	As Zstring*50 szText
	
	As Long iLine
	
	As Long iExtLine = -1
	
End Type

' Not all functions are described below, only those that are required for successful compilation.

'file config.bi
Declare Sub cnf_config_proc()
Declare Sub cnf_set_info_recent_prj_and_find_in_config()

'file goto.bi
Declare Function gt_goto_proc () As Integer
Declare Sub gt_goto_prevpos()

'file comments.bi
Declare Sub cmt_comment_proc()
Declare Sub cmt_uncomment_proc()
Declare Function cmt_multi_comments_line_positions_proc(As iHandle Ptr) As TMultiCommentsLinePositions Ptr
Declare Function cnv_convert_case_before_save_file(pszBuf As Zstring Ptr , Byref iFlagDeallocate As Long) As Zstring Ptr

'file indent.bi
Declare Sub indt_indent_proc()
Declare Sub indt_outdent_proc()

'file find_replace.bi
Declare Function fnd_replace_proc() As Long
Declare Sub fnd_replace_all_proc()
Declare Sub fnd_find_replace_visibility_proc(iParam As Integer)
Declare Function fnd_create_find_dialog_proc (iParamReplace As Integer ) As Ihandle Ptr
Declare Function fnd_find_proc(iAllfind As Integer , iFlagReplace As Integer = 0) As Long

'file options_dialog.bi
Declare Function optdlg_create_dialog_proc() As iHandle Ptr
Declare Function optdlg_create_tool_dialog_proc(iParam As Byte) As iHandle Ptr
Declare Sub optdlg_get_theme_color_proc(iParam As Byte = 0)
Declare Function optdlg_get_color_dlg_proc(szPrevColor As String ) As String
Declare Sub optdlg_reset_proc()
Declare Sub optdlg_apply_proc()
Declare Sub optdlg_ok_proc()
Declare Sub optdlg_tool_btninsert_proc()
Declare Sub optdlg_tool_btnedit_proc()
Declare Sub optdlg_tool_btndelete_proc()
Declare Sub optdlg_tool_btncancel_proc()
Declare Sub optdlg_tool_btnok_proc()
Declare Sub optdlg_tool_btndown_proc()
Declare Sub optdlg_tool_btnup_proc()
Declare Sub optdlg_tool_list_action_proc(As Integer)
Declare Sub optdlg_set_checkbox_style_font_group_proc(ih As Ihandle Ptr , iState As Integer)

'file multitext.bi
Declare Sub mtxt_load_keywords_proc()
Declare Sub mtxt_set_attribute_multitext_proc(multitext As Ihandle Ptr , iTempFlag As Byte = 0)
Declare Sub mtxt_line_display_proc(mt As Ihandle Ptr , iLine As Integer)
Declare Sub mtxt_set_syntax_highlighting(multitext As Ihandle Ptr , sHighlight As String)
Declare Sub mtxt_set_attribute_for_another_files(mt As Ihandle Ptr , sName As String)

'file winoutput.bi
Declare Sub winout_set_visual_params_build_info_proc(iParam As Byte = 0)
Declare Sub winout_processing_click_mouse_buildbox_proc(ih As Ihandle Ptr, button As Integer , pressed As Integer, x As Integer , y As Integer , pszStatus As Zstring Ptr)
Declare Sub winout_copy_text_from_buildbox_proc( bParam As Byte)
Declare Sub winout_popup_buildbox_only_errors_proc ()
Declare Sub winout_popup_buildbox_only_warnings_proc ()
Declare Sub winout_popup_buildbox_errors_and_warnings_proc ()
'declare sub winout_backup_information_buildbox_proc(iFlag as Long)

'file winsideinfo.bi
Declare Sub winside_set_visual_params_info_proc(iParam As Byte = 0)
Declare Sub winside_addInfo_inlist_proc()
Declare Sub winside_addInfo_prj_inlist_proc()
Declare Sub winside_setactiveitem_prj_proc(idTabs As Long)
Declare Sub winside_add_info_recent_prj_proc(list As ihandle Ptr)

'file statusbar.bi
Declare Sub sb_set_visual_params_statusbar_proc(iParam As Byte = 0)

'file tabs.bi
Declare Function tbs_item_close_proc (idTabs As Long , iFlagCloseProject As Long = 0 , iFlagDeInitFilePrj As Long = 0) As Integer
Declare Function tbs_set_activetab_from_winside(ih As iHandle Ptr) As Long

'file widgetvisibility.bi
Declare Sub widvis_child_widget_visibility_proc  (ih As Ihandle Ptr , hItemMenu As Ihandle Ptr )

'file tabs_spaces.bi
Declare Sub tbspc_spaces_to_tab_begin_proc()
Declare Sub tbspc_spaces_to_tab_proc()
Declare Sub tbspc_fast_tab_in_space_proc(szLine As String)
Declare Sub tbspc_tab_to_spaces_begin_proc()
Declare Sub tbspc_tab_to_spaces_proc()
Declare Sub tbspc_remove_leading_spaces_proc (mt As Ihandle Ptr)
Declare Sub tbspc_remove_trailing_spaces_proc (mt As Ihandle Ptr)

'file convert_case.bi
Declare Sub cnv_convert_lower_or_upper_case_proc (iParam As Integer )

'file marker.bi
Declare Sub mrk_toggle_marker_proc (ih As Ihandle Ptr, iLine As Integer, iMargin As Integer)
Declare Function mrk_bookmark_next_prev_proc(ih As Ihandle Ptr , iParamNextPrev As Integer ) As Integer

'file encoding.bi
Declare Function enc_encode_buffer_proc(szEncTo As Zstring Ptr , szEncFrom As Zstring Ptr , bBuf As Byte Ptr,_
iSizeBuf As Integer , Byref iSizeReturnBytes As Integer , mt As Ihandle Ptr = 0, iProjectFlag As Long = 0) As Byte Ptr
Declare Sub enc_select_default_system_encoding_dialog_proc()
Declare Function enc_convert_document_as_encoding_proc(ih As Ihandle Ptr) As Integer
Declare Sub enc_encoding_dialog_proc ()
'Declare Function enc_encode_path_proc(sPath As String , iParamUtf As Long) As String     'declared in the tlist.bi 

'file messagedialog.bi
Declare Function msdlg_dialog_message_yes_no_proc(szTitle As Zstring Ptr , szMessage As Zstring Ptr , iCountButtons As Long = 3) As Integer

'file callbacks.bi
Declare Function encoding_menu_popup_callback Cdecl (ih As Ihandle Ptr) As Integer 
Declare Function plugin_setting_exit_callback Cdecl(ih As Ihandle Ptr ) As Integer
Declare Function plugin_setting_action_callback Cdecl(ih As Ihandle Ptr, state As Integer) As Integer
Declare Function item_open_setting_dialog_plugin_callback Cdecl (ih As Ihandle Ptr) As Integer
Declare Function timer_update_size_winside_callback Cdecl (ih As Ihandle Ptr) As Integer 
Declare Function options_select_fonttabs_callback Cdecl (ih As Ihandle Ptr) As Integer
Declare Function timer_open_include_callback Cdecl (ih As Ihandle Ptr) As Integer

'file menu.bi
Declare Function mn_encoding_menu_popup_proc (ih As Ihandle Ptr) As Integer
Declare Sub mn_menu_popup_editor_proc()
Declare Sub mn_update_mainmenu_after_options_encoding_proc()
Declare Sub mn_set_flag_on_item_encoding_proc()
Declare Sub mn_create_project_popup_inwinside_proc()
Declare Sub mn_find_recent_proc()

'file fontdialog.bi
Declare Function fntdlg_font_dialog_proc(pszPrevNameFont As Zstring Ptr) As String 

'file compile.bi
Declare Function cmp_prepare_compile_proc() As Integer
Declare Sub cmp_start_program_proc()
Declare Sub cmp_quick_run_proc() 
Declare Sub cmp_run_with_debug_proc()
Declare Sub cmp_command_for_exe_proc()

'file hotkeys.bi
Declare Sub hkey_hotkeys_proc(iKey As Integer)

'file help.bi
Declare Sub hlp_CloseHelp_proc()
Declare Sub hlp_processing_f1_proc()
Declare Function hlp_getword_proc() As Zstring Ptr
Declare Function hlp_trim_path(sPath As String) As String
Declare Sub hlp_enum_keywords_helps(As Any Ptr)

'file autocomplect.bi
Declare Sub atc_cursor_on_column_proc(iLine As Integer , sAdded As String)
Declare Sub atc_autoindent_proc()
Declare Function atc_check_simbol_underscore_proc(sText As String) As Long
Declare Function atc_get_string_from_multiline_text_proc(mt As Ihandle Ptr , iLine As Integer , sRet As String , iCheckUnderscoreFlag As Long) As Long

'file plugins.bi
Declare Sub plg_FreePluginsProc()
Declare Sub plg_PluginSettingDialogProc ()

'file misc.bi
Declare Function misc_replace_string_proc (Byval sString As String, Byval sSearchStr As String, Byval sReplaceStr As String,_
Byval iPosition As Integer = 1 , Byval iSearchParam As Integer = 0 ) As String 
Declare Sub misc_reverse_string_proc(sText As String)
Declare Function misc_case_utf8(sText As String , iFlagLcase As Long = 1) As String 

'file autocompletion.bi
Declare Sub ac_parser_keys_proc(mt As Ihandle Ptr, iKey As Integer)
Declare Sub ac_start_proc(mt As Ihandle Ptr)
Declare Function ac_truncate_blocks_proc(sText As String , sMarkerBegin As String , sMarkerEnd As String) As String

'file annotation.bi
Declare Function ann_get_multiline_string_proc(mt As Ihandle Ptr , iLine As Integer , sRet As String , iLenSimbols As Long) As Long

'file toolbar.bi
Declare Sub tb_fill_combobuild_proc()

'file file.bi
Declare Function fl_is_fileproject_to_open_proc(sFullPath As String , Byref mt As ihandle Ptr) As Long
Declare Function fl_save_project_proc(iNew As Long , sOldName As String  = "") As Long
Declare Sub fl_rename_file(sSource As String , sDest As String)
Declare Function fl_prepare_path(sPath As String) As String

'file project
Declare Function prj_dialog_proc(iOptionNew As Long = 1) As Ihandle Ptr
Declare Sub prj_create_or_edit_proc(ih As Ihandle Ptr)
Declare Function prj_dialog_add_file_proc(iModule As Long ) As Ihandle Ptr
Declare Sub prj_add_file_in_project_proc(ih As Ihandle Ptr)
Declare Sub prj_add_EX_file_in_project_proc(iModule As Long)
Declare Sub prj_close_proc()
Declare Function prj_open_project_proc(sFileInput As String) As Long
Declare Sub prj_winside_dblclick_fileopen(iItem As Integer , sText As Zstring Ptr)
Declare Sub prj_set_main_curent()
Declare Function prj_get_file_from_winside_or_tabs(Byref iModule As Long , iItem As Long = 0) As String
Declare Function prj_dialog_rename_file_proc(iModule As Long  , sFile As String) As Ihandle Ptr
Declare Sub prj_rename_file(ih As iHandle Ptr)
Declare Sub prj_delete_file(sFile As String)

'file timer.bi
Declare Sub tmr_update_after_changes()

Extern "C"

Declare Function IupFlatTabs (Byval child As Ihandle Ptr, ...) As Ihandle Ptr

End Extern

Dim Shared As TQueue Ptr tRecentProjectInfo

tRecentProjectInfo = New TQueue

Dim Shared As TQueue Ptr tRecentFindInfo

tRecentFindInfo = New TQueue

Dim Shared As Byte bFlag_F6_OnPressed

Redim Shared As Any Ptr pHandlesMemorySharedLibrarys()

Redim Shared As Any Ptr pHandlesHotkeysSharedLibrarys()

Dim Shared As TProject pProject

Dim Shared As T_GlobalVariables Ptr TGlobalVariables 

Redim Shared As T_DimInfoSideList tDimInfoSideList(10)

Dim Shared As Zstring Ptr pszDimErrors(1 To 1000)

Dim Shared As Byte bEncodingBool(121)  = {1}

Redim Shared As THELPLIST pArrayTHelpList(1 To 100)

Dim Shared As Zstring*21 szEncodingString(121) = {_
"Default System",_
"UTF-8",_
"UTF-8 BOM",_
"UTF-16",_
"UTF-16LE",_
"UTF-16BE",_
"UTF-32",_
"UTF-32LE",_
"UTF-32BE",_
"UTF-7",_
"UCS-2",_
"UCS-2BE",_
"UCS-2LE",_
"UCS-2-INTERNAL",_
"UCS-4",_
"UCS-4BE",_
"UCS-4LE",_
"UCS-4-INTERNAL",_
"ISO-2022-CN",_
"ISO-2022-CN-EXT",_
"ISO-2022-KR",_
"ISO-2022-JP",_
"ISO-2022-JP-1",_
"ISO-2022-JP-2",_
"ISO-2022-JP-3",_
"ISO-2022-JP-MS",_
"ISO-8859-1",_
"ISO-8859-2",_
"ISO-8859-3",_
"ISO-8859-4",_
"ISO-8859-5",_
"ISO-8859-6",_
"ISO-8859-7",_
"ISO-8859-8",_
"ISO-8859-9",_
"ISO-8859-10",_
"ISO-8859-11",_
"ISO-8859-12",_
"ISO-8859-13",_
"ISO-8859-14",_
"ISO-8859-15",_
"ISO-8859-16",_ 
"KOI8-R",_
"KOI8-U",_
"KOI8-RU",_
"KOI8-T",_
"CP437",_
"CP737",_
"CP775",_
"CP850",_
"CP852",_
"CP853",_
"CP855",_
"CP857",_
"CP858",_
"CP860",_
"CP861",_
"CP862",_
"CP863",_
"CP864",_
"CP865",_
"CP866",_
"CP869",_
"CP874",_
"CP932",_
"CP936",_
"CP949",_
"CP950",_
"CP1125",_
"CP1131",_
"CP1133",_
"CP1250",_
"CP1251",_
"CP1252",_
"CP1253",_
"CP1254",_
"CP1255",_
"CP1256",_
"CP1257",_
"CP1258",_
"MacRoman",_
"MacCentralEurope",_
"MacIceland",_
"MacCroatian",_
"MacRomania",_
"MacCyrillic",_
"MacUkraine",_
"MacGreek",_
"MacTurkish",_
"Macintosh",_
"MacHebrew",_
"MacArabic",_
"MacThai",_
"HZ",_
"GBK",_
"GB18030",_
"EUC-KR",_
"EUC-CN",_
"EUC-TW",_
"EUC-JP",_
"EUC-JISX0213",_
"BIG5",_
"BIG5-HKSCS",_
"BIG5-HKSCS:2004",_
"BIG5-HKSCS:2001",_
"BIG5-HKSCS:1999",_
"JOHAB",_
"ARMSCII-8",_
"SHIFT_JIS",_
"Georgian-Academy",_
"Georgian-PS",_
"PT154",_
"RK1048",_
"TIS-620",_
"MuleLao-1",_
"VISCII",_
"TCVN",_
"HP-ROMAN8",_
"NEXTSTEP",_
"Shift_JISX0213",_
"TDS565",_
"RISCOS-LATIN1"_
}

Type Tmnem
	
	As Zstring*25 sMnem
	As Zstring*10 sHtml
	As Zstring*6 sCss
	As Short uni	
	
End Type

Dim Shared arr_mnem(...) As tmnem = {("&dollar;","&#36;","\0024",&h24) , _
("&cent;","&#162;","\00A2",&hA2) , _
("&pound;","&#163;","\00A3",&hA3) , _
("&curren;","&#164;","\00A4",&hA4) , _
("&yen;","&#165;","\00A5",&hA5) , _
("&copy;","&#169;","\00A9",&hA9) , _
("&reg;","&#174;","\00AE",&hAE) , _
("&trade;","&#8482;","\2122",&h2122) , _
("&commat;","&#64;","\0040",&h40) , _
("&Copf;","&#8450;","\2102",&h2102) , _
("&incare;","&#8453;","\2105",&h2105) , _
("&gscr;","&#8458;","\210A",&h210A) , _
("&hamilt;","&#8459;","\210B",&h210B) , _
("&Hfr;","&#8460;","\210C",&h210C) , _
("&Hopf;","&#8461;","\210D",&h210D) , _
("&planckh;","&#8462;","\210E",&h210E) , _
("&planck;","&#8463;","\210F",&h210F) , _
("&Iscr;","&#8464;","\2110",&h2110) , _
("&image;","&#8465;","\2111",&h2111) , _
("&Lscr;","&#8466;","\2112",&h2112) , _
("&ell;","&#8467;","\2113",&h2113) , _
("&Nopf;","&#8469;","\2115",&h2115) , _
("&numero;","&#8470;","\2116",&h2116) , _
("&copysr;","&#8471;","\2117",&h2117) , _
("&weierp;","&#8472;","\2118",&h2118) , _
("&Popf;","&#8473;","\2119",&h2119) , _
("&Qopf;","&#8474;","\211A",&h211A) , _
("&Rscr;","&#8475;","\211B",&h211B) , _
("&real;","&#8476;","\211C",&h211C) , _
("&Ropf;","&#8477;","\211D",&h211D) , _
("&rx;","&#8478;","\211E",&h211E) , _
("&Zopf;","&#8484;","\2124",&h2124) , _
("&mho;","&#8487;","\2127",&h2127) , _
("&Zfr;","&#8488;","\2128",&h2128) , _
("&iiota;","&#8489;","\2129",&h2129) , _
("&bernou;","&#8492;","\212C",&h212C) , _
("&Cfr;","&#8493;","\212D",&h212D) , _
("&escr;","&#8495;","\212F",&h212F) , _
("&Escr;","&#8496;","\2130",&h2130) , _
("&Fscr;","&#8497;","\2131",&h2131) , _
("&Mscr;","&#8499;","\2133",&h2133) , _
("&oscr;","&#8500;","\2134",&h2134) , _
("&alefsym;","&#8501;","\2135",&h2135) , _
("&beth;","&#8502;","\2136",&h2136) , _
("&gimel;","&#8503;","\2137",&h2137) , _
("&daleth;","&#8504;","\2138",&h2138) , _
("&DD;","&#8517;","\2145",&h2145) , _
("&dd;","&#8518;","\2146",&h2146) , _
("&ee;","&#8519;","\2147",&h2147) , _
("&ii;","&#8520;","\2148",&h2148) , _
("&starf;","&#9733;","\2605",&h2605) , _
("&star;","&#9734;","\2606",&h2606) , _
("&phone;","&#9742;","\260E",&h260E) , _
("&female;","&#9792;","\2640",&h2640) , _
("&male;","&#9794;","\2642",&h2642) , _
("&spades;","&#9824;","\2660",&h2660) , _
("&clubs;","&#9827;","\2663",&h2663) , _
("&hearts;","&#9829;","\2665",&h2665) , _
("&diams;","&#9830;","\2666",&h2666) , _
("&loz;","&#9674;","\25CA",&h25CA) , _
("&sung;","&#9834;","\266A",&h266A) , _
("&flat;","&#9837;","\266D",&h266D) , _
("&natural;","&#9838;","\266E",&h266E) , _
("&sharp;","&#9839;","\266F",&h266F) , _
("&check;","&#10003;","\2713",&h2713) , _
("&cross;","&#10007;","\2717",&h2717) , _
("&malt;","&#10016;","\2720",&h2720) , _
("&sext;","&#10038;","\2736",&h2736) , _
("&VerticalSeparator;","&#10072;","\2758",&h2758) , _
("&lbbrk;","&#10098;","\2772",&h2772) , _
("&rbbrk;","&#10099;","\2773",&h2773) , _
("&excl;","&#33;","\0021",&h21) , _
("&num;","&#35;","\0023",&h23) , _
("&percnt;","&#37;","\0025",&h25) , _
("&amp;","&#38;","\0026",&h26) , _
("&lpar;","&#40;","\0028",&h28) , _
("&rpar;","&#41;","\0029",&h29) , _
("&ast;","&#42;","\002A",&h2A) , _
("&comma;","&#44;","\002C",&h2C) , _
("&period;","&#46;","\002E",&h2E) , _
("&sol;","&#47;","\002F",&h2F) , _
("&colon;","&#58;","\003A",&h3A) , _
("&semi;","&#59;","\003B",&h3B) , _
("&quest;","&#63;","\003F",&h3F) , _
("&lbrack;","&#91;","\005B",&h5B) , _
("&bsol;","&#92;","\005C",&h5C) , _
("&rbrack;","&#93;","\005D",&h5D) , _
("&Hat;","&#94;","\005E",&h5E) , _
("&lowbar;","&#95;","\005F",&h5F) , _
("&grave;","&#96;","\0060",&h60) , _
("&lbrace;","&#123;","\007B",&h7B) , _
("&vert;","&#124;","\007C",&h7C) , _
("&rbrace;","&#125;","\007D",&h7D) , _
("&tilde;","&#126;","\007E",&h7E) , _
("&circ;","&#710;","\02C6",&h2C6) , _
("&nbsp;","&#160;","\00A0",&hA0) , _
("&ensp;","&#8194;","\2002",&h2002) , _
("&emsp;","&#8195;","\2003",&h2003) , _
("&thinsp;","&#8201;","\2009",&h2009) , _
("&zwnj;","&#8204;","\200C",&h200C) , _
("&zwj;","&#8205;","\200D",&h200D) , _
("&lrm;","&#8206;","\200E",&h200E) , _
("&rlm;","&#8207;","\200F",&h200F) , _
("&iexcl;","&#161;","\00A1",&hA1) , _
("&brvbar;","&#166;","\00A6",&hA6) , _
("&sect;","&#167;","\00A7",&hA7) , _
("&uml;","&#168;","\00A8",&hA8) , _
("&ordf;","&#170;","\00AA",&hAA) , _
("&Not;","&#172;","\00AC",&hAC) , _
("&shy;","&#173;","\00AD",&hAD) , _
("&macr;","&#175;","\00AF",&hAF) , _
("&sup2;","&#178;","\00B2",&hB2) , _
("&sup3;","&#179;","\00B3",&hB3) , _
("&acute;","&#180;","\00B4",&hB4) , _
("&micro;","&#181;","\00B5",&hB5) , _
("&para;","&#182;","\00B6",&hB6) , _
("&middot;","&#183;","\00B7",&hB7) , _
("&cedil;","&#184;","\00B8",&hB8) , _
("&sup1;","&#185;","\00B9",&hB9) , _
("&ordm;","&#186;","\00BA",&hBA) , _
("&iquest;","&#191;","\00BF",&hBF) , _
("&hyphen;","&#8208;","\2010",&h2010) , _
("&ndash;","&#8211;","\2013",&h2013) , _
("&mdash;","&#8212;","\2014",&h2014) , _
("&horbar;","&#8213;","\2015",&h2015) , _
("&Vert;","&#8214;","\2016",&h2016) , _
("&dagger;","&#8224;","\2020",&h2020) , _
("&Dagger;","&#8225;","\2021",&h2021) , _
("&bull;","&#8226;","\2022",&h2022) , _
("&nldr;","&#8229;","\2025",&h2025) , _
("&hellip;","&#8230;","\2026",&h2026) , _
("&;","&#8240;","\2030",&h2030) , _
("&pertenk;","&#8241;","\2031",&h2031) , _
("&prime;","&#8242;","\2032",&h2032) , _
("&Prime;","&#8243;","\2033",&h2033) , _
("&tprime;","&#8244;","\2034",&h2034) , _
("&bprime;","&#8245;","\2035",&h2035) , _
("&oline;","&#8254;","\203E",&h203E) , _
("&caret;","&#8257;","\2041",&h2041) , _
("&hybull;","&#8259;","\2043",&h2043) , _
("&frasl;","&#8260;","\2044",&h2044) , _
("&bsemi;","&#8271;","\204F",&h204F) , _
("&qprime;","&#8279;","\2057",&h2057) , _
("&quot;","&#34;","\0022",&h22) , _
("&apos;","&#39;","\0027",&h27) , _
("&laquo;","&#171;","\00AB",&hAB) , _
("&raquo;","&#187;","\00BB",&hBB) , _
("&lsquo;","&#8216;","\2018",&h2018) , _
("&rsquo;","&#8217;","\2019",&h2019) , _
("&sbquo;","&#8218;","\201A",&h201A) , _
("&ldquo;","&#8220;","\201C",&h201C) , _
("&rdquo;","&#8221;","\201D",&h201D) , _
("&bdquo;","&#8222;","\201E",&h201E) , _
("&lsaquo;","&#8249;","\2039",&h2039) , _
("&rsaquo;","&#8250;","\203A",&h203A) , _
("&frac14;","&#188;","\00BC",&hBC) , _
("&frac12;","&#189;","\00BD",&hBD) , _
("&frac34;","&#190;","\00BE",&hBE) , _
("&frac13;","&#8531;","\2153",&h2153) , _
("&frac23;","&#8532;","\2154",&h2154) , _
("&frac15;","&#8533;","\2155",&h2155) , _
("&frac25;","&#8534;","\2156",&h2156) , _
("&frac35;","&#8535;","\2157",&h2157) , _
("&frac45;","&#8536;","\2158",&h2158) , _
("&frac16;","&#8537;","\2159",&h2159) , _
("&frac56;","&#8538;","\215A",&h215A) , _
("&frac18;","&#8539;","\215B",&h215B) , _
("&frac38;","&#8540;","\215C",&h215C) , _
("&frac58;","&#8541;","\215D",&h215D) , _
("&frac78;","&#8542;","\215E",&h215E) , _
("&plus;","&#43;","\002B",&h2B) , _
("&minus;","&#8722;","\2212",&h2212) , _
("&times;","&#215;","\00D7",&hD7) , _
("&divide;","&#247;","\00F7",&hF7) , _
("&equals;","&#61;","\003D",&h3D) , _
("&ne;","&#8800;","\2260",&h2260) , _
("&plusmn;","&#177;","\00B1",&hB1) , _
("&Not;","&#172;","\00AC",&hAC) , _
("&lt;","&#60;","\003C",&h3C) , _
("&gt;","&#62;","\003E",&h3E) , _
("&deg;","&#176;","\00B0",&hB0) , _
("&sup1;","&#185;","\00B9",&hB9) , _
("&sup2;","&#178;","\00B2",&hB2) , _
("&sup3;","&#179;","\00B3",&hB3) , _
("&fnof;","&#402;","\0192",&h192) , _
("&percnt;","&#37;","\0025",&h25) , _
("&permil;","&#137;","\0089",&h89) , _
("&pertenk;","&#8241;","\2031",&h2031) , _
("&forall;","&#8704;","\2200",&h2200) , _
("&comp;","&#8705;","\2201",&h2201) , _
("&part;","&#8706;","\2202",&h2202) , _
("&exist;","&#8707;","\2203",&h2203) , _
("&nexist;","&#8708;","\2204",&h2204) , _
("&empty;","&#8709;","\2205",&h2205) , _
("&nabla;","&#8711;","\2207",&h2207) , _
("&isin;","&#8712;","\2208",&h2208) , _
("&notin;","&#8713;","\2209",&h2209) , _
("&ni;","&#8715;","\220B",&h220B) , _
("&notni;","&#8716;","\220C",&h220C) , _
("&prod;","&#8719;","\220F",&h220F) , _
("&coprod;","&#8720;","\2210",&h2210) , _
("&sum;","&#8721;","\2211",&h2211) , _
("&mnplus;","&#8723;","\2213",&h2213) , _
("&plusdo;","&#8724;","\2214",&h2214) , _
("&setminus;","&#8726;","\2216",&h2216) , _
("&lowast;","&#8727;","\2217",&h2217) , _
("&compfn;","&#8728;","\2218",&h2218) , _
("&radic;","&#8730;","\221A",&h221A) , _
("&prop;","&#8733;","\221D",&h221D) , _
("&infin;","&#8734;","\221E",&h221E) , _
("&angrt;","&#8735;","\221F",&h221F) , _
("&ang;","&#8736;","\2220",&h2220) , _
("&angmsd;","&#8737;","\2221",&h2221) , _
("&angsph;","&#8738;","\2222",&h2222) , _
("&Mid;","&#8739;","\2223",&h2223) , _
("&nmid;","&#8740;","\2224",&h2224) , _
("&parallel;","&#8741;","\2225",&h2225) , _
("&npar;","&#8742;","\2226",&h2226) , _
("&And;","&#8743;","\2227",&h2227) , _
("&Or;","&#8744;","\2228",&h2228) , _
("&cap;","&#8745;","\2229",&h2229) , _
("&cup;","&#8746;","\222A",&h222A) , _
("&Int;","&#8747;","\222B",&h222B) , _
("&Int;","&#8748;","\222C",&h222C) , _
("&iiint;","&#8749;","\222D",&h222D) , _
("&conint;","&#8750;","\222E",&h222E) , _
("&Conint;","&#8751;","\222F",&h222F) , _
("&Cconint;","&#8752;","\2230",&h2230) , _
("&cwint;","&#8753;","\2231",&h2231) , _
("&cwconint;","&#8754;","\2232",&h2232) , _
("&awconint;","&#8755;","\2233",&h2233) , _
("&there4;","&#8756;","\2234",&h2234) , _
("&because;","&#8757;","\2235",&h2235) , _
("&ratio;","&#8758;","\2236",&h2236) , _
("&Colon;","&#8759;","\2237",&h2237) , _
("&minusd;","&#8760;","\2238",&h2238) , _
("&mDDot;","&#8762;","\223A",&h223A) , _
("&homtht;","&#8763;","\223B",&h223B) , _
("&sim;","&#8764;","\223C",&h223C) , _
("&bsim;","&#8765;","\223D",&h223D) , _
("&ac;","&#8766;","\223E",&h223E) , _
("&acd;","&#8767;","\223F",&h223F) , _
("&wreath;","&#8768;","\2240",&h2240) , _
("&nsim;","&#8769;","\2241",&h2241) , _
("&esim;","&#8770;","\2242",&h2242) , _
("&sime;","&#8771;","\2243",&h2243) , _
("&nsime;","&#8772;","\2244",&h2244) , _
("&cong;","&#8773;","\2245",&h2245) , _
("&simne;","&#8774;","\2246",&h2246) , _
("&ncong;","&#8775;","\2247",&h2247) , _
("&asymp;","&#8776;","\2248",&h2248) , _
("&nap;","&#8777;","\2249",&h2249) , _
("&approxeq;","&#8778;","\224A",&h224A) , _
("&apid;","&#8779;","\224B",&h224B) , _
("&bcong;","&#8780;","\224C",&h224C) , _
("&asympeq;","&#8781;","\224D",&h224D) , _
("&bump;","&#8782;","\224E",&h224E) , _
("&bumpe;","&#8783;","\224F",&h224F) , _
("&esdot;","&#8784;","\2250",&h2250) , _
("&eDot;","&#8785;","\2251",&h2251) , _
("&efDot;","&#8786;","\2252",&h2252) , _
("&erDot;","&#8787;","\2253",&h2253) , _
("&colone;","&#8788;","\2254",&h2254) , _
("&ecolon;","&#8789;","\2255",&h2255) , _
("&ecir;","&#8790;","\2256",&h2256) , _
("&cire;","&#8791;","\2257",&h2257) , _
("&wedgeq;","&#8793;","\2259",&h2259) , _
("&veeeq;","&#8794;","\225A",&h225A) , _
("&trie;","&#8796;","\225C",&h225C) , _
("&equest;","&#8799;","\225F",&h225F) , _
("&equiv;","&#8801;","\2261",&h2261) , _
("&nequiv;","&#8802;","\2262",&h2262) , _
("&le;","&#8804;","\2264",&h2264) , _
("&ge;","&#8805;","\2265",&h2265) , _
("&lE;","&#8806;","\2266",&h2266) , _
("&gE;","&#8807;","\2267",&h2267) , _
("&lnE;","&#8808;","\2268",&h2268) , _
("&gnE;","&#8809;","\2269",&h2269) , _
("&Lt;","&#8810;","\226A",&h226A) , _
("&Gt;","&#8811;","\226B",&h226B) , _
("&between;","&#8812;","\226C",&h226C) , _
("&NotCupCap;","&#8813;","\226D",&h226D) , _
("&nlt;","&#8814;","\226E",&h226E) , _
("&ngt;","&#8815;","\226F",&h226F) , _
("&nle;","&#8816;","\2270",&h2270) , _
("&nge;","&#8817;","\2271",&h2271) , _
("&lsim;","&#8818;","\2272",&h2272) , _
("&gsim;","&#8819;","\2273",&h2273) , _
("&nlsim;","&#8820;","\2274",&h2274) , _
("&ngsim;","&#8821;","\2275",&h2275) , _
("&lg;","&#8822;","\2276",&h2276) , _
("&gl;","&#8823;","\2277",&h2277) , _
("&ntlg;","&#8824;","\2278",&h2278) , _
("&ntgl;","&#8825;","\2279",&h2279) , _
("&pr;","&#8826;","\227A",&h227A) , _
("&sc;","&#8827;","\227B",&h227B) , _
("&prcue;","&#8828;","\227C",&h227C) , _
("&sccue;","&#8829;","\227D",&h227D) , _
("&prsim;","&#8830;","\227E",&h227E) , _
("&scsim;","&#8831;","\227F",&h227F) , _
("&npr;","&#8832;","\2280",&h2280) , _
("&nsc;","&#8833;","\2281",&h2281) , _
("&Sub;","&#8834;","\2282",&h2282) , _
("&sup;","&#8835;","\2283",&h2283) , _
("&nsub;","&#8836;","\2284",&h2284) , _
("&nsup;","&#8837;","\2285",&h2285) , _
("&sube;","&#8838;","\2286",&h2286) , _
("&supe;","&#8839;","\2287",&h2287) , _
("&nsube;","&#8840;","\2288",&h2288) , _
("&nsupe;","&#8841;","\2289",&h2289) , _
("&subne;","&#8842;","\228A",&h228A) , _
("&supne;","&#8843;","\228B",&h228B) , _
("&cupdot;","&#8845;","\228D",&h228D) , _
("&uplus;","&#8846;","\228E",&h228E) , _
("&sqsub;","&#8847;","\228F",&h228F) , _
("&sqsup;","&#8848;","\2290",&h2290) , _
("&sqsube;","&#8849;","\2291",&h2291) , _
("&sqsupe;","&#8850;","\2292",&h2292) , _
("&sqcap;","&#8851;","\2293",&h2293) , _
("&sqcup;","&#8852;","\2294",&h2294) , _
("&oplus;","&#8853;","\2295",&h2295) , _
("&ominus;","&#8854;","\2296",&h2296) , _
("&otimes;","&#8855;","\2297",&h2297) , _
("&osol;","&#8856;","\2298",&h2298) , _
("&odot;","&#8857;","\2299",&h2299) , _
("&ocir;","&#8858;","\229A",&h229A) , _
("&oast;","&#8859;","\229B",&h229B) , _
("&odash;","&#8861;","\229D",&h229D) , _
("&plusb;","&#8862;","\229E",&h229E) , _
("&minusb;","&#8863;","\229F",&h229F) , _
("&timesb;","&#8864;","\22A0",&h22A0) , _
("&sdotb;","&#8865;","\22A1",&h22A1) , _
("&vdash;","&#8866;","\22A2",&h22A2) , _
("&dashv;","&#8867;","\22A3",&h22A3) , _
("&top;","&#8868;","\22A4",&h22A4) , _
("&perp;","&#8869;","\22A5",&h22A5) , _
("&models;","&#8871;","\22A7",&h22A7) , _
("&vDash;","&#8872;","\22A8",&h22A8) , _
("&Vdash;","&#8873;","\22A9",&h22A9) , _
("&Vvdash;","&#8874;","\22AA",&h22AA) , _
("&VDash;","&#8875;","\22AB",&h22AB) , _
("&nvdash;","&#8876;","\22AC",&h22AC) , _
("&nvDash;","&#8877;","\22AD",&h22AD) , _
("&nVdash;","&#8878;","\22AE",&h22AE) , _
("&nVDash;","&#8879;","\22AF",&h22AF) , _
("&prurel;","&#8880;","\22B0",&h22B0) , _
("&vltri;","&#8882;","\22B2",&h22B2) , _
("&vrtri;","&#8883;","\22B3",&h22B3) , _
("&ltrie;","&#8884;","\22B4",&h22B4) , _
("&rtrie;","&#8885;","\22B5",&h22B5) , _
("&origof;","&#8886;","\22B6",&h22B6) , _
("&imof;","&#8887;","\22B7",&h22B7) , _
("&mumap;","&#8888;","\22B8",&h22B8) , _
("&hercon;","&#8889;","\22B9",&h22B9) , _
("&intcal;","&#8890;","\22BA",&h22BA) , _
("&veebar;","&#8891;","\22BB",&h22BB) , _
("&barvee;","&#8893;","\22BD",&h22BD) , _
("&angrtvb;","&#8894;","\22BE",&h22BE) , _
("&lrtri;","&#8895;","\22BF",&h22BF) , _
("&xwedge;","&#8896;","\22C0",&h22C0) , _
("&xvee;","&#8897;","\22C1",&h22C1) , _
("&xcap;","&#8898;","\22C2",&h22C2) , _
("&xcup;","&#8899;","\22C3",&h22C3) , _
("&diamond;","&#8900;","\22C4",&h22C4) , _
("&sdot;","&#8901;","\22C5",&h22C5) , _
("&Star;","&#8902;","\22C6",&h22C6) , _
("&divonx;","&#8903;","\22C7",&h22C7) , _
("&bowtie;","&#8904;","\22C8",&h22C8) , _
("&ltimes;","&#8905;","\22C9",&h22C9) , _
("&rtimes;","&#8906;","\22CA",&h22CA) , _
("&lthree;","&#8907;","\22CB",&h22CB) , _
("&rthree;","&#8908;","\22CC",&h22CC) , _
("&bsime;","&#8909;","\22CD",&h22CD) , _
("&cuvee;","&#8910;","\22CE",&h22CE) , _
("&cuwed;","&#8911;","\22CF",&h22CF) , _
("&Sub;","&#8912;","\22D0",&h22D0) , _
("&Sup;","&#8913;","\22D1",&h22D1) , _
("&Cap;","&#8914;","\22D2",&h22D2) , _
("&Cup;","&#8915;","\22D3",&h22D3) , _
("&fork;","&#8916;","\22D4",&h22D4) , _
("&epar;","&#8917;","\22D5",&h22D5) , _
("&ltdot;","&#8918;","\22D6",&h22D6) , _
("&gtdot;","&#8919;","\22D7",&h22D7) , _
("&Ll;","&#8920;","\22D8",&h22D8) , _
("&Gg;","&#8921;","\22D9",&h22D9) , _
("&leg;","&#8922;","\22DA",&h22DA) , _
("&gel;","&#8923;","\22DB",&h22DB) , _
("&cuepr;","&#8926;","\22DE",&h22DE) , _
("&cuesc;","&#8927;","\22DF",&h22DF) , _
("&nprcue;","&#8928;","\22E0",&h22E0) , _
("&nsccue;","&#8929;","\22E1",&h22E1) , _
("&nsqsube;","&#8930;","\22E2",&h22E2) , _
("&nsqsupe;","&#8931;","\22E3",&h22E3) , _
("&lnsim;","&#8934;","\22E6",&h22E6) , _
("&gnsim;","&#8935;","\22E7",&h22E7) , _
("&prnsim;","&#8936;","\22E8",&h22E8) , _
("&scnsim;","&#8937;","\22E9",&h22E9) , _
("&nltri;","&#8938;","\22EA",&h22EA) , _
("&nrtri;","&#8939;","\22EB",&h22EB) , _
("&nltrie;","&#8940;","\22EC",&h22EC) , _
("&nrtrie;","&#8941;","\22ED",&h22ED) , _
("&vellip;","&#8942;","\22EE",&h22EE) , _
("&ctdot;","&#8943;","\22EF",&h22EF) , _
("&utdot;","&#8944;","\22F0",&h22F0) , _
("&dtdot;","&#8945;","\22F1",&h22F1) , _
("&disin;","&#8946;","\22F2",&h22F2) , _
("&isinsv;","&#8947;","\22F3",&h22F3) , _
("&isins;","&#8948;","\22F4",&h22F4) , _
("&isindot;","&#8949;","\22F5",&h22F5) , _
("&notinvc;","&#8950;","\22F6",&h22F6) , _
("&notinvb;","&#8951;","\22F7",&h22F7) , _
("&isinE;","&#8953;","\22F9",&h22F9) , _
("&nisd;","&#8954;","\22FA",&h22FA) , _
("&xnis;","&#8955;","\22FB",&h22FB) , _
("&nis;","&#8956;","\22FC",&h22FC) , _
("&notnivc;","&#8957;","\22FD",&h22FD) , _
("&notnivb;","&#8958;","\22FE",&h22FE) , _
("&lceil;","&#8968;","\2308",&h2308) , _
("&rceil;","&#8969;","\2309",&h2309) , _
("&lfloor;","&#8970;","\230A",&h230A) , _
("&rfloor;","&#8971;","\230B",&h230B) , _
("&lang;","&#9001;","\2329",&h2329) , _
("&rang;","&#9002;","\232A",&h232A) , _
("&Alpha;","&#913;","\0391",&h391) , _
("&Beta;","&#914;","\0392",&h392) , _
("&Gamma;","&#915;","\0393",&h393) , _
("&Delta;","&#916;","\0394",&h394) , _
("&Epsilon;","&#917;","\0395",&h395) , _
("&Zeta;","&#918;","\0396",&h396) , _
("&Eta;","&#919;","\0397",&h397) , _
("&Theta;","&#920;","\0398",&h398) , _
("&Iota;","&#921;","\0399",&h399) , _
("&Kappa;","&#922;","\039A",&h39A) , _
("&Lambda;","&#923;","\039B",&h39B) , _
("&Mu;","&#924;","\039C",&h39C) , _
("&Nu;","&#925;","\039D",&h39D) , _
("&Xi;","&#926;","\039E",&h39E) , _
("&Omicron;","&#927;","\039F",&h39F) , _
("&Pi;","&#928;","\03A0",&h3A0) , _
("&Rho;","&#929;","\03A1",&h3A1) , _
("&Sigma;","&#931;","\03A3",&h3A3) , _
("&Tau;","&#932;","\03A4",&h3A4) , _
("&Upsilon;","&#933;","\03A5",&h3A5) , _
("&Phi;","&#934;","\03A6",&h3A6) , _
("&Chi;","&#935;","\03A7",&h3A7) , _
("&Psi;","&#936;","\03A8",&h3A8) , _
("&Omega;","&#937;","\03A9",&h3A9) , _
("&Alpha;","&#945;","\03B1",&h3B1) , _
("&beta;","&#946;","\03B2",&h3B2) , _
("&gamma;","&#947;","\03B3",&h3B3) , _
("&delta;","&#948;","\03B4",&h3B4) , _
("&epsilon;","&#949;","\03B5",&h3B5) , _
("&zeta;","&#950;","\03B6",&h3B6) , _
("&eta;","&#951;","\03B7",&h3B7) , _
("&theta;","&#952;","\03B8",&h3B8) , _
("&iota;","&#953;","\03B9",&h3B9) , _
("&kappa;","&#954;","\03BA",&h3BA) , _
("&lambda;","&#955;","\03BB",&h3BB) , _
("&mu;","&#956;","\03BC",&h3BC) , _
("&nu;","&#957;","\03BD",&h3BD) , _
("&xi;","&#958;","\03BE",&h3BE) , _
("&omicron;","&#959;","\03BF",&h3BF) , _
("&pi;","&#960;","\03C0",&h3C0) , _
("&rho;","&#961;","\03C1",&h3C1) , _
("&sigmaf;","&#962;","\03C2",&h3C2) , _
("&sigma;","&#963;","\03C3",&h3C3) , _
("&tau;","&#964;","\03C4",&h3C4) , _
("&upsilon;","&#965;","\03C5",&h3C5) , _
("&phi;","&#966;","\03C6",&h3C6) , _
("&chi;","&#967;","\03C7",&h3C7) , _
("&psi;","&#968;","\03C8",&h3C8) , _
("&omega;","&#969;","\03C9",&h3C9) , _
("&thetasym;","&#977;","\03D1",&h3D1) , _
("&upsih;","&#978;","\03D2",&h3D2) , _
("&piv;","&#982;","\03D6",&h3D6) , _
("&Agrave;","&#192;","\00C0",&hC0) , _
("&Aacute;","&#193;","\00C1",&hC1) , _
("&Acirc;","&#194;","\00C2",&hC2) , _
("&Atilde;","&#195;","\00C3",&hC3) , _
("&Auml;","&#196;","\00C4",&hC4) , _
("&Aring;","&#197;","\00C5",&hC5) , _
("&AElig;","&#198;","\00C6",&hC6) , _
("&Ccedil;","&#199;","\00C7",&hC7) , _
("&Egrave;","&#200;","\00C8",&hC8) , _
("&Eacute;","&#201;","\00C9",&hC9) , _
("&Ecirc;","&#202;","\00CA",&hCA) , _
("&Euml;","&#203;","\00CB",&hCB) , _
("&Lgrave;","&#204;","\00CC",&hCC) , _
("&Lacute;","&#313;","\0139",&h139) , _
("&Lcirc;","&#206;","\00CE",&hCE) , _
("&Luml;","&#207;","\00CF",&hCF) , _
("&ETH;","&#208;","\00D0",&hD0) , _
("&Ntilde;","&#209;","\00D1",&hD1) , _
("&Ograve;","&#210;","\00D2",&hD2) , _
("&Oacute;","&#211;","\00D3",&hD3) , _
("&Ocirc;","&#212;","\00D4",&hD4) , _
("&Otilde;","&#213;","\00D5",&hD5) , _
("&Ouml;","&#214;","\00D6",&hD6) , _
("&Oslash;","&#216;","\00D8",&hD8) , _
("&Ugrave;","&#217;","\00D9",&hD9) , _
("&Uacute;","&#218;","\00DA",&hDA) , _
("&Ucirc;","&#219;","\00DB",&hDB) , _
("&Uuml;","&#220;","\00DC",&hDC) , _
("&Yacute;","&#221;","\00DD",&hDD) , _
("&THORN;","&#222;","\00DE",&hDE) , _
("&szlig;","&#223;","\00DF",&hDF) , _
("&agrave;","&#224;","\00E0",&hE0) , _
("&aacute;","&#225;","\00E1",&hE1) , _
("&acirc;","&#226;","\00E2",&hE2) , _
("&atilde;","&#227;","\00E3",&hE3) , _
("&auml;","&#228;","\00E4",&hE4) , _
("&aring;","&#229;","\00E5",&hE5) , _
("&aelig;","&#230;","\00E6",&hE6) , _
("&ccedil;","&#231;","\00E7",&hE7) , _
("&egrave;","&#232;","\00E8",&hE8) , _
("&eacute;","&#233;","\00E9",&hE9) , _
("&ecirc;","&#234;","\00EA",&hEA) , _
("&euml;","&#235;","\00EB",&hEB) , _
("&igrave;","&#236;","\00EC",&hEC) , _
("&iacute;","&#237;","\00ED",&hED) , _
("&icirc;","&#238;","\00EE",&hEE) , _
("&iuml;","&#239;","\00EF",&hEF) , _
("&eth;","&#240;","\00F0",&hF0) , _
("&ntilde;","&#241;","\00F1",&hF1) , _
("&ograve;","&#242;","\00F2",&hF2) , _
("&oacute;","&#243;","\00F3",&hF3) , _
("&ocirc;","&#244;","\00F4",&hF4) , _
("&otilde;","&#245;","\00F5",&hF5) , _
("&ouml;","&#246;","\00F6",&hF6) , _
("&oslash;","&#248;","\00F8",&hF8) , _
("&ugrave;","&#249;","\00F9",&hF9) , _
("&uacute;","&#250;","\00FA",&hFA) , _
("&ucirc;","&#251;","\00FB",&hFB) , _
("&uuml;","&#252;","\00FC",&hFC) , _
("&yacute;","&#253;","\00FD",&hFD) , _
("&thorn;","&#254;","\00FE",&hFE) , _
("&yuml;","&#255;","\00FF",&hFF) , _
("&Amacr;","&#256;","\0100",&h100) , _
("&amacr;","&#257;","\0101",&h101) , _
("&Abreve;","&#258;","\0102",&h102) , _
("&abreve;","&#259;","\0103",&h103) , _
("&Aogon;","&#260;","\0104",&h104) , _
("&aogon;","&#261;","\0105",&h105) , _
("&Cacute;","&#262;","\0106",&h106) , _
("&cacute;","&#263;","\0107",&h107) , _
("&Ccirc;","&#264;","\0108",&h108) , _
("&ccirc;","&#265;","\0109",&h109) , _
("&Cdot;","&#266;","\010A",&h10A) , _
("&cdot;","&#267;","\010B",&h10B) , _
("&Ccaron;","&#268;","\010C",&h10C) , _
("&ccaron;","&#269;","\010D",&h10D) , _
("&Dcaron;","&#270;","\010E",&h10E) , _
("&dcaron;","&#271;","\010F",&h10F) , _
("&Dstrok;","&#272;","\0110",&h110) , _
("&dstrok;","&#273;","\0111",&h111) , _
("&Emacr;","&#274;","\0112",&h112) , _
("&emacr;","&#275;","\0113",&h113) , _
("&Edot;","&#278;","\0116",&h116) , _
("&edot;","&#279;","\0117",&h117) , _
("&Eogon;","&#280;","\0118",&h118) , _
("&eogon;","&#281;","\0119",&h119) , _
("&Ecaron;","&#282;","\011A",&h11A) , _
("&ecaron;","&#283;","\011B",&h11B) , _
("&Gcirc;","&#284;","\011C",&h11C) , _
("&gcirc;","&#285;","\011D",&h11D) , _
("&Gbreve;","&#286;","\011E",&h11E) , _
("&gbreve;","&#287;","\011F",&h11F) , _
("&Gdot;","&#288;","\0120",&h120) , _
("&gdot;","&#289;","\0121",&h121) , _
("&Gcedil;","&#290;","\0122",&h122) , _
("&Hcirc;","&#292;","\0124",&h124) , _
("&hcirc;","&#293;","\0125",&h125) , _
("&Hstrok;","&#294;","\0126",&h126) , _
("&hstrok;","&#295;","\0127",&h127) , _
("&Itilde;","&#296;","\0128",&h128) , _
("&itilde;","&#297;","\0129",&h129) , _
("&Imacr;","&#298;","\012A",&h12A) , _
("&imacr;","&#299;","\012B",&h12B) , _
("&Iogon;","&#302;","\012E",&h12E) , _
("&iogon;","&#303;","\012F",&h12F) , _
("&Idot;","&#304;","\0130",&h130) , _
("&imath;","&#305;","\0131",&h131) , _
("&IJlig;","&#306;","\0132",&h132) , _
("&ijlig;","&#307;","\0133",&h133) , _
("&Jcirc;","&#308;","\0134",&h134) , _
("&jcirc;","&#309;","\0135",&h135) , _
("&Kcedil;","&#310;","\0136",&h136) , _
("&kcedil;","&#311;","\0137",&h137) , _
("&kgreen;","&#312;","\0138",&h138) , _
("&lacute;","&#314;","\013A",&h13A) , _
("&Lcedil;","&#315;","\013B",&h13B) , _
("&lcedil;","&#316;","\013C",&h13C) , _
("&Lcaron;","&#317;","\013D",&h13D) , _
("&lcaron;","&#318;","\013E",&h13E) , _
("&Lmidot;","&#319;","\013F",&h13F) , _
("&lmidot;","&#320;","\0140",&h140) , _
("&Lstrok;","&#321;","\0141",&h141) , _
("&lstrok;","&#322;","\0142",&h142) , _
("&Nacute;","&#323;","\0143",&h143) , _
("&nacute;","&#324;","\0144",&h144) , _
("&Ncedil;","&#325;","\0145",&h145) , _
("&ncedil;","&#326;","\0146",&h146) , _
("&Ncaron;","&#327;","\0147",&h147) , _
("&ncaron;","&#328;","\0148",&h148) , _
("&napos;","&#329;","\0149",&h149) , _
("&ENG;","&#330;","\014A",&h14A) , _
("&eng;","&#331;","\014B",&h14B) , _
("&Omacr;","&#332;","\014C",&h14C) , _
("&omacr;","&#333;","\014D",&h14D) , _
("&Odblac;","&#336;","\0150",&h150) , _
("&odblac;","&#337;","\0151",&h151) , _
("&OElig;","&#338;","\0152",&h152) , _
("&oelig;","&#339;","\0153",&h153) , _
("&Racute;","&#340;","\0154",&h154) , _
("&racute;","&#341;","\0155",&h155) , _
("&Rcedil;","&#342;","\0156",&h156) , _
("&rcedil;","&#343;","\0157",&h157) , _
("&Rcaron;","&#344;","\0158",&h158) , _
("&rcaron;","&#345;","\0159",&h159) , _
("&Sacute;","&#346;","\015A",&h15A) , _
("&sacute;","&#347;","\015B",&h15B) , _
("&Scirc;","&#348;","\015C",&h15C) , _
("&scirc;","&#349;","\015D",&h15D) , _
("&Scedil;","&#350;","\015E",&h15E) , _
("&scedil;","&#351;","\015F",&h15F) , _
("&Scaron;","&#352;","\0160",&h160) , _
("&scaron;","&#353;","\0161",&h161) , _
("&Tcedil;","&#354;","\0162",&h162) , _
("&tcedil;","&#355;","\0163",&h163) , _
("&Tcaron;","&#356;","\0164",&h164) , _
("&tcaron;","&#357;","\0165",&h165) , _
("&Tstrok;","&#358;","\0166",&h166) , _
("&tstrok;","&#359;","\0167",&h167) , _
("&Utilde;","&#360;","\0168",&h168) , _
("&utilde;","&#361;","\0169",&h169) , _
("&Umacr;","&#362;","\016A",&h16A) , _
("&umacr;","&#363;","\016B",&h16B) , _
("&Ubreve;","&#364;","\016C",&h16C) , _
("&ubreve;","&#365;","\016D",&h16D) , _
("&Uring;","&#366;","\016E",&h16E) , _
("&uring;","&#367;","\016F",&h16F) , _
("&Udblac;","&#368;","\0170",&h170) , _
("&udblac;","&#369;","\0171",&h171) , _
("&Uogon;","&#370;","\0172",&h172) , _
("&uogon;","&#371;","\0173",&h173) , _
("&Wcirc;","&#372;","\0174",&h174) , _
("&wcirc;","&#373;","\0175",&h175) , _
("&Ycirc;","&#374;","\0176",&h176) , _
("&ycirc;","&#375;","\0177",&h177) , _
("&Yuml;","&#376;","\0178",&h178) , _
("&Zacute;","&#377;","\0179",&h179) , _
("&zacute;","&#378;","\017A",&h17A) , _
("&Zdot;","&#379;","\017B",&h17B) , _
("&zdot;","&#380;","\017C",&h17C) , _
("&Zcaron;","&#381;","\017D",&h17D) , _
("&zcaron;","&#382;","\017E",&h17E) , _
("&DownBreve;","&#785;","\0311",&h311) , _
("&olarr;","&#8634;","\21BA",&h21BA) , _
("&orarr;","&#8635;","\21BB",&h21BB) , _
("&lharu;","&#8636;","\21BC",&h21BC) , _
("&lhard;","&#8637;","\21BD",&h21BD) , _
("&uharr;","&#8638;","\21BE",&h21BE) , _
("&uharl;","&#8639;","\21BF",&h21BF) , _
("&rharu;","&#8640;","\21C0",&h21C0) , _
("&rhard;","&#8641;","\21C1",&h21C1) , _
("&dharr;","&#8642;","\21C2",&h21C2) , _
("&dharl;","&#8643;","\21C3",&h21C3) , _
("&rlarr;","&#8644;","\21C4",&h21C4) , _
("&udarr;","&#8645;","\21C5",&h21C5) , _
("&lrarr;","&#8646;","\21C6",&h21C6) , _
("&llarr;","&#8647;","\21C7",&h21C7) , _
("&uuarr;","&#8648;","\21C8",&h21C8) , _
("&rrarr;","&#8649;","\21C9",&h21C9) , _
("&ddarr;","&#8650;","\21CA",&h21CA) , _
("&lrhar;","&#8651;","\21CB",&h21CB) , _
("&rlhar;","&#8652;","\21CC",&h21CC) , _
("&nlArr;","&#8653;","\21CD",&h21CD) , _
("&nhArr;","&#8654;","\21CE",&h21CE) , _
("&nrArr;","&#8655;","\21CF",&h21CF) , _
("&lArr;","&#8656;","\21D0",&h21D0) , _
("&uArr;","&#8657;","\21D1",&h21D1) , _
("&rArr;","&#8658;","\21D2",&h21D2) , _
("&dArr;","&#8659;","\21D3",&h21D3) , _
("&hArr;","&#8660;","\21D4",&h21D4) , _
("&vArr;","&#8661;","\21D5",&h21D5) , _
("&nwArr;","&#8662;","\21D6",&h21D6) , _
("&neArr;","&#8663;","\21D7",&h21D7) , _
("&seArr;","&#8664;","\21D8",&h21D8) , _
("&swArr;","&#8665;","\21D9",&h21D9) , _
("&lAarr;","&#8666;","\21DA",&h21DA) , _
("&rAarr;","&#8667;","\21DB",&h21DB) , _
("&ziglarr;","&#8668;","\21DC",&h21DC) , _
("&zigrarr;","&#8669;","\21DD",&h21DD) , _
("&larrb;","&#8676;","\21E4",&h21E4) , _
("&rarrb;","&#8677;","\21E5",&h21E5) , _
("&duarr;","&#8693;","\21F5",&h21F5) , _
("&hoarr;","&#8703;","\21FF",&h21FF) , _
("&loarr;","&#8701;","\21FD",&h21FD) , _
("&roarr;","&#8702;","\21FE",&h21FE) , _
("&xlarr;","&#10229;","\27F5",&h27F5) , _
("&xrarr;","&#10230;","\27F6",&h27F6) , _
("&xharr;","&#10231;","\27F7",&h27F7) , _
("&xlArr;","&#10232;","\27F8",&h27F8) , _
("&xrArr;","&#10233;","\27F9",&h27F9) , _
("&xhArr;","&#10234;","\27FA",&h27FA) , _
("&dzigrarr;","&#10239;","\27FF",&h27FF) , _
("&xmap;","&#10236;","\27FC",&h27FC) , _
("&nvlArr;","&#10498;","\2902",&h2902) , _
("&nvrArr;","&#10499;","\2903",&h2903) , _
("&nvHarr;","&#10500;","\2904",&h2904) , _
("&Map;","&#10501;","\2905",&h2905) , _
("&lbarr;","&#10508;","\290C",&h290C) , _
("&rbarr;","&#10509;","\290D",&h290D) , _
("&lBarr;","&#10510;","\290E",&h290E) , _
("&rBarr;","&#10511;","\290F",&h290F) , _
("&RBarr;","&#10512;","\2910",&h2910) , _
("&DDotrahd;","&#10513;","\2911",&h2911) , _
("&UpArrowBar;","&#10514;","\2912",&h2912) , _
("&DownArrowBar;","&#10515;","\2913",&h2913) , _
("&Rarrtl;","&#10518;","\2916",&h2916) , _
("&latail;","&#10521;","\2919",&h2919) , _
("&ratail;","&#10522;","\291A",&h291A) , _
("&lAtail;","&#10523;","\291B",&h291B) , _
("&rAtail;","&#10524;","\291C",&h291C) , _
("&larrfs;","&#10525;","\291D",&h291D) , _
("&rarrfs;","&#10526;","\291E",&h291E) , _
("&larrbfs;","&#10527;","\291F",&h291F) , _
("&rarrbfs;","&#10528;","\2920",&h2920) , _
("&nwarhk;","&#10531;","\2923",&h2923) , _
("&nearhk;","&#10532;","\2924",&h2924) , _
("&searhk;","&#10533;","\2925",&h2925) , _
("&swarhk;","&#10534;","\2926",&h2926) , _
("&nwnear;","&#10535;","\2927",&h2927) , _
("&nesear;","&#10536;","\2928",&h2928) , _
("&seswar;","&#10537;","\2929",&h2929) , _
("&swnwar;","&#10538;","\292A",&h292A) , _
("&cudarrr;","&#10549;","\2935",&h2935) , _
("&ldca;","&#10550;","\2936",&h2936) , _
("&rdca;","&#10551;","\2937",&h2937) , _
("&cudarrl;","&#10552;","\2938",&h2938) , _
("&larrpl;","&#10553;","\2939",&h2939) , _
("&curarrm;","&#10556;","\293C",&h293C) , _
("&cularrp;","&#10557;","\293D",&h293D) , _
("&rarrpl;","&#10565;","\2945",&h2945) , _
("&harrcir;","&#10568;","\2948",&h2948) , _
("&Uarrocir;","&#10569;","\2949",&h2949) , _
("&lurdshar;","&#10570;","\294A",&h294A) , _
("&ldrushar;","&#10571;","\294B",&h294B) , _
("&RightUpDownVector;","&#10575;","\294F",&h294F) , _
("&DownLeftRightVector;","&#10576;","\2950",&h2950) , _
("&LeftUpDownVector;","&#10577;","\2951",&h2951) , _
("&LeftVectorBar;","&#10578;","\2952",&h2952) , _
("&RightVectorBar;","&#10579;","\2953",&h2953) , _
("&RightUpVectorBar;","&#10580;","\2954",&h2954) , _
("&RightDownVectorBar;","&#10581;","\2955",&h2955) , _
("&DownLeftVectorBar;","&#10582;","\2956",&h2956) , _
("&DownRightVectorBar;","&#10583;","\2957",&h2957) , _
("&LeftUpVectorBar;","&#10584;","\2958",&h2958) , _
("&LeftDownVectorBar;","&#10585;","\2959",&h2959) , _
("&LeftTeeVector;","&#10586;","\295A",&h295A) , _
("&RightTeeVector;","&#10587;","\295B",&h295B) , _
("&RightUpTeeVector;","&#10588;","\295C",&h295C) , _
("&RightDownTeeVector;","&#10589;","\295D",&h295D) , _
("&DownLeftTeeVector;","&#10590;","\295E",&h295E) , _
("&DownRightTeeVector;","&#10591;","\295F",&h295F) , _
("&LeftUpTeeVector;","&#10592;","\2960",&h2960) , _
("&LeftDownTeeVector;","&#10593;","\2961",&h2961) , _
("&lHar;","&#10594;","\2962",&h2962) , _
("&uHar;","&#10595;","\2963",&h2963) , _
("&rHar;","&#10596;","\2964",&h2964) , _
("&dHar;","&#10597;","\2965",&h2965) , _
("&luruhar;","&#10598;","\2966",&h2966) , _
("&ldrdhar;","&#10599;","\2967",&h2967) , _
("&ruluhar;","&#10600;","\2968",&h2968) , _
("&rdldhar;","&#10601;","\2969",&h2969) , _
("&lharul;","&#10602;","\296A",&h296A) , _
("&llhard;","&#10603;","\296B",&h296B) , _
("&rharul;","&#10604;","\296C",&h296C) , _
("&lrhard;","&#10605;","\296D",&h296D) , _
("&udhar;","&#10606;","\296E",&h296E) , _
("&duhar;","&#10607;","\296F",&h296F) , _
("&RoundImplies;","&#10608;","\2970",&h2970) , _
("&erarr;","&#10609;","\2971",&h2971) , _
("&simrarr;","&#10610;","\2972",&h2972) , _
("&larrsim;","&#10611;","\2973",&h2973) , _
("&rarrsim;","&#10612;","\2974",&h2974) , _
("&rarrap;","&#10613;","\2975",&h2975) , _
("&ltlarr;","&#10614;","\2976",&h2976) , _
("&gtrarr;","&#10616;","\2978",&h2978) , _
("&subrarr;","&#10617;","\2979",&h2979) , _
("&suplarr;","&#10619;","\297B",&h297B) , _
("&lfisht;","&#10620;","\297C",&h297C) , _
("&rfisht;","&#10621;","\297D",&h297D) , _
("&ufisht;","&#10622;","\297E",&h297E) , _
("&dfisht;","&#10623;","\297F",&h297F)}