#include "tlist.bi"

#include "declarations.bi"

#include "init.bi"

#include "images.bi"

#include "filedlg.bi"

#include "file.bi"

#include "autocomplect.bi"

#include "autocompletion.bi"

#include "annotation.bi"

#include "callbacks.bi"

#include "menu.bi"

#include "toolbar.bi"

#include "statusbar.bi"

#include "winoutput.bi"

#include "multitext.bi"

#include "tabs.bi"

#include "encoding.bi"

#include "goto.bi"

#include "tabs_spaces.bi"

#include "convert_case.bi"

#include "comments.bi"

#include "indent.bi"

#include "marker.bi"

#include "timer.bi"

#include "find_replace.bi"

#include "options_dialog.bi"

#include "fontdialog.bi"

#include "messagedialog.bi"

#include "widgetvisibility.bi"

#include "config.bi"

#include "compile.bi"

#include "hotkeys.bi"

#include "chmread.bi"

#include "help.bi"

#include "misc.bi"

#include "winsideinfo.bi"

#include "project.bi"

#include "plugins.bi"


Sub main()
	
	Chdir(Exepath)
	
	init_initialization_proc
	
	img_Load_Imades_Proc()
	
	mtxt_load_keywords_proc()
	
	mn_create_main_menu_proc()
	
	TGlobalVariables->toolbar = tb_create_toolbar_proc()
	
	TGlobalVariables->statusbar = sb_Create_statusBar_proc()
	
	TGlobalVariables->buildbox = winout_Create_build_info_BuildBox_proc()
	
	TGlobalVariables->tabs = tbs_Create_Tabs_proc()
	
	TGlobalVariables->vertsplit = IupSplit(TGlobalVariables->tabs , 0 )
	
	IupSetAttribute(TGlobalVariables->vertsplit, "ORIENTATION", "VERTICAL")
	
	IupSetAttribute(TGlobalVariables->vertsplit, "SHOWGRIP", "NO")
	
	IupSetAttribute(TGlobalVariables->vertsplit, "AUTOHIDE", "YES")
	
	If *(IupConfigGetVariableStr(TGlobalVariables->hConfig, "ChildParam", "winsidevisible")) = "1" Then
		
		IupSetAttribute(TGlobalVariables->vertsplit, "VALUE", IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","vertsplitsize"))
		
	Else
		
		IupSetAttribute(TGlobalVariables->vertsplit, "VALUE", "1000")
		
	Endif
	
	TGlobalVariables->split = IupSplit(TGlobalVariables->vertsplit, TGlobalVariables->buildbox)
	
	IupSetAttribute(TGlobalVariables->split, "ORIENTATION", "HORIZONTAL")
	
	IupSetstrAttribute(TGlobalVariables->split, "VALUE", IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","splitsize"))
	
	IupSetCallback(TGlobalVariables->split, "VALUECHANGED_CB", Cast(Any Ptr, @value_changed_split_callback))
	
	winside_create_window_side_info_proc()
	
	Dim As Ihandle Ptr hSpaceBox = IupVBox(0)
	
	TGlobalVariables->dlg = IupDialog(IupVBox(hSpaceBox ,TGlobalVariables->toolbar , TGlobalVariables->split, TGlobalVariables->statusbar ,NULL))
	
	IupSetAttribute(TGlobalVariables->dlg, "TITLE", "IUP_FB_Editor")
	
	IupSetAttribute(TGlobalVariables->dlg, "MENU", "MainMenu")
	
	If Len(*IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","dlgsize")) Then
		
		IupSetAttribute(TGlobalVariables->dlg, "RASTERSIZE", IupConfigGetVariableStr(TGlobalVariables->hConfig,"DialogSize","dlgsize"))
		
	Else
		
		IupSetAttribute(TGlobalVariables->dlg, "RASTERSIZE", "800x600")
		
	Endif
	
	If IupGetInt(TGlobalVariables->dlg, "RASTERSIZE") >= IupGetInt(NULL, "FULLSIZE") Then
		
		IupSetAttribute(TGlobalVariables->dlg, "PLACEMENT", "MAXIMIZED")
		
	Endif
	
	IupSetAttribute(TGlobalVariables->dlg, "SHRINK", "YES")
	
	IupSetAttributeHandle( 0, "PARENTDIALOG", TGlobalVariables->dlg )
	
	IupSetCallback(TGlobalVariables->dlg, "DROPFILES_CB", Cast(Any Ptr, @dropfiles_callback))
	
	IupSetCallback(TGlobalVariables->dlg, "CLOSE_CB", Cast(Any Ptr, @close_dialog_callback))
	
	IupSetCallback(TGlobalVariables->dlg, "K_ANY", Cast(Any Ptr, @k_any_dialog_callback))
	
	IupSetCallback(TGlobalVariables->dlg, "RESIZE_CB", Cast(Any Ptr,@resize_dialog_callback))
	
	IupSetCallback(TGlobalVariables->dlg, "SHOW_CB", Cast(Any Ptr,@show_dialog_callback))	
	
	sb_set_visual_params_statusbar_proc(0)
	
	winout_set_visual_params_build_info_proc(0)
	
	winside_set_visual_params_info_proc(0)
	
	tmr_init_timer_proc()
	
	IupShow(TGlobalVariables->dlg)
	
	#ifdef __fb_win32__
		
		Var icon=LoadIcon(GetModuleHandle(0),MAKEINTRESOURCE(100))
		
		SendMessage(Cast(HWND,IupGetAttribute(TGlobalVariables->dlg,"HWND")),WM_SETICON,ICON_BIG,Cast(Lparam,icon))
		
		SendMessage(Cast(HWND,IupGetAttribute(TGlobalVariables->dlg,"HWND")),WM_SETICON,ICON_SMALL,Cast(Lparam,icon))
		
	#endif
	
	For i As Long  = 1 To 100
		
		Dim As Zstring*2256 szFileName = Command(i)
		
		If Len(szFileName)>0 Then
			
			If pProject.iProjectLoad = 0 Then
				
				If Lcase(Right(szFileName, 4)) = ".prj" Then
					
					Select Case IupAlarm(*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"optionmesstitlewarning") ,_
					*IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"dlgopenprjorfile") , "YES" , "NO" , 0)
							
						Case 1
							
							prj_open_project_proc(szFileName)
							
							Continue For
							
					End Select
					
				Endif
				
			Endif
			
			fl_open_file_proc(szFileName)
			
		Else
			
			Exit For
			
		Endif
		
	Next	
	
	#ifdef __fb_win32__
	#else
		
		gtk_window_set_icon_from_file(GTK_WINDOW(IupGetAttribute(TGlobalVariables->dlg, "WID")), (Exepath & "/media/res.png"), NULL)
		
		hkey_InitHotKeyAccel_proc()
		
	#endif
	
	plg_LoadAllPluginsProc()
	
	Threadcreate(@hlp_enum_keywords_helps())
	
	#ifndef __fb_win32__
	
	Dim As Zstring Ptr pszPos = iupGetAttribute(TGlobalVariables->toolbar , "POSITION")
	
	If pszPos Andalso IupGetGlobal("GLOBALMENU") = 0 Then
		
		Dim As String s = *pszPos
		
		If Len(s) Then
			
			Dim As Long iPos = Instr(s , ",")
			
			s = Mid(s , iPos+1)
			
			Dim As Long iH = Val(s)
			
			Dim As gint iMinH , iNatH
			
			#ifdef __USE_GTK3__
				
				gtk_widget_get_preferred_height(Cast(Any Ptr ,iupGetAttribute(IupGetHandle("MainMenu") , "WID")) , @iMinH , @iNatH)
				
			#else
				
				Dim As GdkRectangle rect
				
				gtk_widget_get_allocation(Cast(Any Ptr ,iupGetAttribute(IupGetHandle("MainMenu") , "WID")) , @rect)
				
				iNatH = rect.height
				
			#endif
			
			If iH < iNatH Then
				
				IupSetAttribute(hSpaceBox , "RASTERSIZE" , "0x" & iNatH - iH)
				
				IupRefresh(TGlobalVariables->dlg)
				
			Endif
			
		Endif
		
	Endif
	
	#endif
	
	IupMainLoop()
	
	IupClose()
	
End Sub

main()

