
Sub plg_PluginSettingDialogProc () Export
	
	Dim As IHandle Ptr dlg , vbox, hbox , hScroll
	
	Redim As IHandle Ptr hPluginCheckButtons(0)
	
	Dim As Long iIndex
	
	#ifndef __fb_win32__
		
		Chdir(Exepath & "/plugins" )
		
		Dim sKey As String = Dir("*.so" , 32 )
		
	#else
		
		Chdir(Exepath & "\plugins")
		
		Dim sKey As String = Dir("*.dll" , 32 )
		
	#endif
	
	If sKey <> "" Then
		
		Do
			
			Redim Preserve As IHandle Ptr hPluginCheckButtons(iIndex+1)
			
			hPluginCheckButtons(iIndex) = IupToggle(Strptr(sKey),Strptr(sKey))
			
			IupSetStrAttribute(hPluginCheckButtons(iIndex), "NAMEPLUGIN", Str(sKey))
			
			IupSetCallback(hPluginCheckButtons(iIndex), "ACTION", Cast(Any Ptr,@plugin_setting_action_callback()))
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Plugins" ,Strptr(sKey)) = "1" Then
				
				IupSetAttribute(hPluginCheckButtons(iIndex), "VALUE", "ON")
				
			Endif
			
			iIndex+=1
			
			sKey= Dir()
			
		Loop Until sKey = ""		
		
	Endif
	
	Chdir(Exepath)
	
	vbox = IupVboxv(@hPluginCheckButtons(0))
	
	hScroll = IupScrollBox(vbox)	
	
	dlg = IupDialog(hScroll)
	
	IupSetAttribute(dlg, "TITLE", *IupConfigGetVariableStr(TGlobalVariables->hConfigL,TGlobalVariables->szLangid,"plugins"))
	
	IupSetCallback(dlg, "CLOSE_CB", Cast(Any Ptr, @plugin_setting_exit_callback()))
	
	IupPopup(dlg,IUP_CURRENT,IUP_CURRENT)
	
End Sub

Function plg_LoadPluginProc(szPath As Zstring Ptr) As Integer Export
	
	Static iCountPlugins As Long
	
	Static iCountHotkeysProc As Long
	
	If Ubound(pHandlesMemorySharedLibrarys) = -1 Then
		
		Redim As Any Ptr pHandlesMemorySharedLibrarys(10)
		
	Elseif Ubound(pHandlesMemorySharedLibrarys) >= iCountPlugins - 1 Then
		
		Redim Preserve As Any Ptr pHandlesMemorySharedLibrarys(Ubound(pHandlesMemorySharedLibrarys)+10)
		
	Endif
	
	If Ubound(pHandlesHotkeysSharedLibrarys) = -1 Then
		
		Redim As Any Ptr pHandlesHotkeysSharedLibrarys(10)
		
	Elseif Ubound(pHandlesHotkeysSharedLibrarys) >= iCountHotkeysProc - 1 Then
		
		Redim Preserve As Any Ptr pHandlesHotkeysSharedLibrarys(Ubound(pHandlesHotkeysSharedLibrarys)+10)
		
	Endif		
	
	Dim pDll As  Any Ptr
	
	Dim InitPluginProc As Function (TGlobalVariables As T_GlobalVariables Ptr , pszDimErrors() As Zstring Ptr , bEncodingBool() As Byte , szEncodingString As Any Ptr ) As Integer
	
	Dim HotkeysPluginProc As Function (iSimbols As Integer) As Integer	
	
	pDll = Dylibload(*szPath)
	
	If pDll <> 0 Then
		
		InitPluginProc = Dylibsymbol(pDll, "INITPLUGINPROC")
		
		If InitPluginProc Then 
			
			If InitPluginProc(TGlobalVariables, pszDimErrors(), bEncodingBool(), @szEncodingString(0)) Then
				
				pHandlesMemorySharedLibrarys(iCountPlugins) = pDll
				
				iCountPlugins +=1
				
				Function = 1
				
			Else
				
				Print "Call InitPluginProc error!"
				
				Return 0
				
			Endif
			
		Else
			
			Print "Dylibsymbol InitPluginProc error!"
			
			Return 0
			
		Endif
		
		HotkeysPluginProc = Dylibsymbol(pDll, "HOTKEYSPLUGINPROC")
		
		If HotkeysPluginProc Then
			
			pHandlesHotkeysSharedLibrarys(iCountHotkeysProc) = HotkeysPluginProc
			
			iCountHotkeysProc+=1
			
			Return 1
			
		Else
			
			Print "Hotkeys in the plugin not using OR Dylibsymbol HotkeysPluginProc error"
			
			Return 0
			
		Endif
		
	Endif
	
End Function

Sub plg_FreePluginsProc() Export
	
	If Ubound(pHandlesMemorySharedLibrarys) <> -1 Then
		
		For i As Long = 0 To Ubound(pHandlesMemorySharedLibrarys) 
			
			If pHandlesMemorySharedLibrarys(i) Then
				
				Dylibfree(pHandlesMemorySharedLibrarys(i))
				
			Endif
			
		Next
		
	Endif
	
End Sub

Sub plg_LoadAllPluginsProc() Export
	
	#ifndef __fb_win32__
		
		Chdir(Exepath & "/plugins" )
		
		Dim sKey As String = Dir("*.so" , 32 )
		
	#else
		
		Chdir(Exepath & "\plugins")
		
		Dim sKey As String = Dir("*.dll" , 32 )
		
	#endif
	
	If sKey <> "" Then
		
		Do
			
			If *IupConfigGetVariableStr(TGlobalVariables->hConfig, "Plugins" ,Strptr(sKey)) = "1" Then
				
				plg_LoadPluginProc(Strptr(sKey))
				
			Else
				
				IupConfigSetVariableStr(TGlobalVariables->hConfig, "Plugins" ,Strptr(sKey),"0")
				
			Endif
			
			sKey= Dir() 
			
		Loop Until sKey = ""		
		
	Endif
	
	Chdir(Exepath)
	
End Sub 
